
      
!=======================================================================      

      subroutine solve_feas(grid_pt_box, X, N, DAT, IDAT)

!=======================================================================      

!.....returns an improved initial guess by solving for some of the variables
      implicit none

      integer, intent(in) :: N
      real(prec), intent(in)   ::  grid_pt_box(dim_model)
      real(prec) :: X(N)
      real(prec) :: X_tmp(N)

      integer                 ::  state_in

      
 
      real(prec),dimension(dim_sim) :: DAT
      integer :: IDAT(*)     

!-----------------------------------------------------------------------
!     compute random start points

      state_in = IDAT(1)

      X_tmp(:) = x(:)


          

        X(8) = X_tmp(8)**2 &
              & + X_tmp(9)**2 &
              & + X_tmp(11)**2
        X(9) = X_tmp(8)*X_tmp(9) &
              & + X_tmp(9)*X_tmp(10) &
              & + X_tmp(11)*X_tmp(12)
        X(11) = X_tmp(8)*X_tmp(11) &
              & + X_tmp(9)*X_tmp(12) &
              & + X_tmp(11)*X_tmp(13)
        X(10) = X_tmp(9)**2 &
              & + X_tmp(10)**2 &
              & + X_tmp(12)**2
        X(12) = X_tmp(9)*X_tmp(11) &
              & + X_tmp(10)*X_tmp(12) &
              & + X_tmp(12)*X_tmp(13)
        X(13) = X_tmp(11)**2 &
              & + X_tmp(12)**2 &
              & + X_tmp(13)**2
        X(14) = X_tmp(14)**2 &
              & + X_tmp(15)**2
        X(15) = X_tmp(14)*X_tmp(15) &
              & + X_tmp(15)*X_tmp(16)
        X(16) = X_tmp(15)**2 &
              & + X_tmp(16)**2
        X(3) = 1.*X(4)
        X(7) = 1.*grid_pt_box(1)
        X(2) = -1. &
              & + 0.6666666666666666*X(1)
        X(6) = -2.0408163265306123*(-1.2071067811865475 &
              & + 1.*(&
              &   0.5 &
              & + X(4))**0.5 &
              & - 0.5*grid_pt_box(1) &
              & + 1.*X(9) &
              & + 1.5*X(14))
        X(5) = -2.0408163265306123*(-0.7071067811865476 &
              & + 1.*(&
              &   0.5 &
              & + X(4))**0.5 &
              & - 0.5*grid_pt_box(1) &
              & + 0.5*X(8))

      
      return
!=======================================================================   
   
      end subroutine solve_feas

!======================================================================= 


!-----------------------------------------------------------------------      

      subroutine next_cont_state(f_next_all,state_in,  X, N)

!-----------------------------------------------------------------------      

!.....returns a matrix where the i-th row is the next continuous state given that state i will be the next discrete one
      implicit none

      integer, intent(in) :: N
      real(prec), intent(in)   ::  X(N)
      real(prec), dimension(no_integnodes,dim_sim), intent(out) :: f_next_all 

      integer :: indx

      integer                 ::  state_in



!-----------------------------------------------------------------------
!     compute random start points



      f_next_all(1,1) = X(5)



      return
!-----------------------------------------------------------------------      
      end subroutine next_cont_state
!-----------------------------------------------------------------------  
      
!-----------------------------------------------------------------------      

      subroutine inv_next_cont_state(f_next_all, X, N)

!-----------------------------------------------------------------------      

      implicit none

      integer, intent(in) :: N
      real(prec), intent(out)   ::  X(N)
      real(prec), dimension(no_integnodes,dim_sim), intent(in) :: f_next_all 
      
!----------------------------------------------------------------------   

!-----------------------------------------------------------------------
!     compute random start points


      X(5) = f_next_all(1,1)

      return
!-----------------------------------------------------------------------      
      end subroutine inv_next_cont_state
!-----------------------------------------------------------------------  
      

!=============================================================================
! 
!     Computation of objective 
! 
!=============================================================================

      subroutine princ_utility(X, iu, DAT,util)
        
      implicit none
      
      real(prec), intent(out) :: util
      real(prec), target   :: X(nvars)
      real(prec),dimension(dim_sim) :: DAT
      integer :: iu(*)

      integer               ::  state_in, indxit

      real(prec),dimension(dim_sim)  ::  grid_pt_box                
      real(prec)   ::  Prob(no_integnodes)              
      
!----------------------------------------------------------------------   

      state_in = iu(1)
      do indxit =1,dim_sim      
         grid_pt_box(indxit) = DAT(indxit)
      enddo

      call prob_weights(X,state_in,Prob)

!.....compute current util
      util = (48.99999999999996*X(1)*(1.5 &
              & - 0.25*(1.4142135623730951 &
              & + 0.020000000000000018*X(6))**2.))/(1 &
              & + X(1)) &
              & - X(3)

      return
      
!-----------------------------------------------------------------------      
      end subroutine princ_utility
!-----------------------------------------------------------------------         


!=============================================================================
! 
!     Computation of constraints 
! 
!=============================================================================

      subroutine constraints(N, X, M, G, IDAT, DAT)
        
      implicit none
      
      integer :: N, M
      real(prec), target   :: X(N)
      real(prec),dimension(dim_sim) :: DAT
      integer :: IDAT(*)
      real(prec)              :: G(M)       

      integer                 ::   state_in, indxit

      real(prec),dimension(dim_sim)  ::  grid_pt_box                
      real(prec)   ::  Prob(no_integnodes)                  
      
!----------------------------------------------------------------------   

      state_in = IDAT(1)
      do indxit =1,dim_sim      
         grid_pt_box(indxit) = DAT(indxit)
      enddo

      call prob_weights(X,state_in,Prob)


!.....mapping the x to named pointers
      G(1) = -grid_pt_box(1) &
              & + X(7)
      G(2) = -X(4) &
              & + X(3)
      G(3) = -1.5 &
              & + X(1) &
              & - 1.5*X(2)
      G(4) = -1.4142135623730951 &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(5) &
              & - 1.*X(7) &
              & + X(8)
      G(5) = -2.414213562373095 &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(6) &
              & - X(7) &
              & + 2*X(9) &
              & + 3.*X(14)
      G(6) = -1. &
              & + X(10) &
              & + 2*X(11) &
              & - X(14) &
              & + 6.*X(15)
      G(7) = X(13) &
              & - X(16)
      G(8) = 2*X(12) &
              & - 2*X(15) &
              & + 3.*X(16)
      G(9) = -((X(1)*(-1.4142135623730951 &
              & - X(1) &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(6)))/(1 &
              & + X(1))) &
              & - (1. &
              & - X(1)/(1 &
              & + X(1)))*(-1.4142135623730951 &
              & - X(1) &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(5)) &
              & + grid_pt_box(1)
      G(10) = 0.001 &
              & + X(8)
      G(11) = 0.001 &
              & + X(10)
      G(12) = 0.001 &
              & + X(13)
      G(13) = 1.e-6 &
              & + 0.001*X(8) &
              & - X(9)**2 &
              & + 0.001*X(10) &
              & + X(8)*X(10)
      G(14) = 1.e-6 &
              & + 0.001*X(8) &
              & - X(11)**2 &
              & + 0.001*X(13) &
              & + X(8)*X(13)
      G(15) = 1.e-6 &
              & + 0.001*X(10) &
              & - X(12)**2 &
              & + 0.001*X(13) &
              & + X(10)*X(13)
      G(16) = 1.e-9 &
              & + 1.e-6*X(8) &
              & - 0.001*X(9)**2 &
              & + 1.e-6*X(10) &
              & + 0.001*X(8)*X(10) &
              & - 0.001*X(11)**2 &
              & - X(10)*X(11)**2 &
              & + 2*X(9)*X(11)*X(12) &
              & - 0.001*X(12)**2 &
              & - X(8)*X(12)**2 &
              & + 1.e-6*X(13) &
              & + 0.001*X(8)*X(13) &
              & - X(9)**2*X(13) &
              & + 0.001*X(10)*X(13) &
              & + X(8)*X(10)*X(13)
      G(17) = 0.001 &
              & + X(14)
      G(18) = 0.001 &
              & + X(16)
      G(19) = 1.e-6 &
              & + 0.001*X(14) &
              & - X(15)**2 &
              & + 0.001*X(16) &
              & + X(14)*X(16)

      return
      
!-----------------------------------------------------------------------      
      end subroutine constraints
!-----------------------------------------------------------------------      
 
 

!=======================================================================      

      subroutine sparsity_pattern(ACON, AVAR, nnz) !returns the sparsity pattern

!=======================================================================      

!.....returns the sparsity pattern compatible for IPOPT
      implicit none

      integer, intent(in) :: nnz  !nonzero entries
      integer, intent(out)   ::  ACON(nnz),AVAR(nnz)

      ACON(1) = 1 
      AVAR(1) = 7
      ACON(2) = 2 
      AVAR(2) = 3
      ACON(3) = 2 
      AVAR(3) = 4
      ACON(4) = 3 
      AVAR(4) = 1
      ACON(5) = 3 
      AVAR(5) = 2
      ACON(6) = 4 
      AVAR(6) = 4
      ACON(7) = 4 
      AVAR(7) = 5
      ACON(8) = 4 
      AVAR(8) = 7
      ACON(9) = 4 
      AVAR(9) = 8
      ACON(10) = 5 
      AVAR(10) = 4
      ACON(11) = 5 
      AVAR(11) = 6
      ACON(12) = 5 
      AVAR(12) = 7
      ACON(13) = 5 
      AVAR(13) = 9
      ACON(14) = 5 
      AVAR(14) = 14
      ACON(15) = 6 
      AVAR(15) = 10
      ACON(16) = 6 
      AVAR(16) = 11
      ACON(17) = 6 
      AVAR(17) = 14
      ACON(18) = 6 
      AVAR(18) = 15
      ACON(19) = 7 
      AVAR(19) = 13
      ACON(20) = 7 
      AVAR(20) = 16
      ACON(21) = 8 
      AVAR(21) = 12
      ACON(22) = 8 
      AVAR(22) = 15
      ACON(23) = 8 
      AVAR(23) = 16
      ACON(24) = 9 
      AVAR(24) = 1
      ACON(25) = 9 
      AVAR(25) = 4
      ACON(26) = 9 
      AVAR(26) = 5
      ACON(27) = 9 
      AVAR(27) = 6
      ACON(28) = 10 
      AVAR(28) = 8
      ACON(29) = 11 
      AVAR(29) = 10
      ACON(30) = 12 
      AVAR(30) = 13
      ACON(31) = 13 
      AVAR(31) = 8
      ACON(32) = 13 
      AVAR(32) = 9
      ACON(33) = 13 
      AVAR(33) = 10
      ACON(34) = 14 
      AVAR(34) = 8
      ACON(35) = 14 
      AVAR(35) = 11
      ACON(36) = 14 
      AVAR(36) = 13
      ACON(37) = 15 
      AVAR(37) = 10
      ACON(38) = 15 
      AVAR(38) = 12
      ACON(39) = 15 
      AVAR(39) = 13
      ACON(40) = 16 
      AVAR(40) = 8
      ACON(41) = 16 
      AVAR(41) = 9
      ACON(42) = 16 
      AVAR(42) = 10
      ACON(43) = 16 
      AVAR(43) = 11
      ACON(44) = 16 
      AVAR(44) = 12
      ACON(45) = 16 
      AVAR(45) = 13
      ACON(46) = 17 
      AVAR(46) = 14
      ACON(47) = 18 
      AVAR(47) = 16
      ACON(48) = 19 
      AVAR(48) = 14
      ACON(49) = 19 
      AVAR(49) = 15
      ACON(50) = 19 
      AVAR(50) = 16


!-----------------------------------------------------------------------      
      end subroutine sparsity_pattern
!----------------------------------------------------------------------- 

!=======================================================================      

      subroutine sparsity_pattern_obj(AVAR, nnz) !returns the sparsity pattern of the objective

!=======================================================================      

!.....returns the sparsity pattern of the objective for SNOPT
      implicit none

      integer, intent(in) :: nnz  !nonzero entries
      integer, intent(out)   ::  AVAR(nnz)

 
      AVAR(1) = 1
 
      AVAR(2) = 3
 
      AVAR(3) = 5
 
      AVAR(4) = 6


!-----------------------------------------------------------------------      
      end subroutine sparsity_pattern_obj
!----------------------------------------------------------------------- 


!=======================================================================      

      subroutine bounds(n,xlow, xhigh, m, flow, fhigh,bigbnd, &
      & IDAT, DAT ) 
      !returns the bounds on variables and constraints

!=======================================================================      

      implicit none

      real(prec),dimension(dim_sim) :: DAT
      integer :: IDAT(*)

      integer, intent(in) :: n,m 
      real(prec), intent(in) :: bigbnd
      real(prec), intent(out)   ::  xlow(n),xhigh(n),flow(m),fhigh(m)

      integer                 ::  state_in,indxit

      real(prec),dimension(dim_sim)  ::  grid_pt_box                

            
   
!----------------------------------------------------------------------   

      state_in = IDAT(1)
      do indxit =1,dim_sim      
         grid_pt_box(indxit) = DAT(indxit)
      enddo




      xlow(1) = 0. 
      xhigh(1) = 3.
      xlow(2) = -1. 
      xhigh(2) = 1.
      xlow(3) = 0. 
      xhigh(3) = 1
      xlow(4) = 0 
      xhigh(4) = 1
      xlow(5) = 23.847308027332975 
      xhigh(5) = 51.76380902050409
      xlow(6) = 23.847308027332975 
      xhigh(6) = 51.76380902050409
      xlow(7) = -1000. 
      xhigh(7) = 1000.
      xlow(8) = -1000. 
      xhigh(8) = 1000.
      xlow(9) = -1000. 
      xhigh(9) = 1000.
      xlow(10) = -1000. 
      xhigh(10) = 1000.
      xlow(11) = -1000. 
      xhigh(11) = 1000.
      xlow(12) = -1000. 
      xhigh(12) = 1000.
      xlow(13) = -1000. 
      xhigh(13) = 1000.
      xlow(14) = -1000. 
      xhigh(14) = 1000.
      xlow(15) = -1000. 
      xhigh(15) = 1000.
      xlow(16) = -1000. 
      xhigh(16) = 1000.
      flow(1) = 0. 
      fhigh(1) = 0.
      flow(2) = 0. 
      fhigh(2) = 0.
      flow(3) = 0. 
      fhigh(3) = 0.
      flow(4) = 0. 
      fhigh(4) = 0.
      flow(5) = 0. 
      fhigh(5) = 0.
      flow(6) = 0. 
      fhigh(6) = 0.
      flow(7) = 0. 
      fhigh(7) = 0.
      flow(8) = 0. 
      fhigh(8) = 0.
      flow(9) = 0. 
      fhigh(9) = 0.
      flow(10) = 0. 
      fhigh(10) = bigBnd
      flow(11) = 0. 
      fhigh(11) = bigBnd
      flow(12) = 0. 
      fhigh(12) = bigBnd
      flow(13) = 0. 
      fhigh(13) = bigBnd
      flow(14) = 0. 
      fhigh(14) = bigBnd
      flow(15) = 0. 
      fhigh(15) = bigBnd
      flow(16) = 0. 
      fhigh(16) = bigBnd
      flow(17) = 0. 
      fhigh(17) = bigBnd
      flow(18) = 0. 
      fhigh(18) = bigBnd
      flow(19) = 0. 
      fhigh(19) = bigBnd
      if(grid_pt_box(1) .eq. 0.) then
            xlow(1) = 0. 
            xhigh(1) = 0.
            xlow(3) = 0. 
            xhigh(3) = 0.
            xlow(4) = 0. 
            xhigh(4) = 0.
            xlow(7) = 0. 
            xhigh(7) = 0.
            xlow(5) = 0. 
            xhigh(5) = 0.
            xlow(6) = 0. 
            xhigh(6) = 0.
      endif


!-----------------------------------------------------------------------      
      end subroutine bounds
!----------------------------------------------------------------------- 



!=============================================================================
! 
!                 Computation of Jacobian of equality constraints
! 
!=============================================================================

      subroutine jac_constraints(N, X, M, NZ, A, &
     &     IDAT, DAT)

      implicit none

      integer ::  NZ
      integer :: M, N
      real(prec), target :: X(N)
      real(prec) :: A(NZ)
      integer :: i, j, k
      real(prec),dimension(dim_sim) :: DAT
      integer :: IDAT(*)


      real(prec),dimension(dim_sim)  ::  grid_pt_box                

      integer :: indxit
!-----------------------------------------------------------------------      

      do indxit =1,dim_sim      
         grid_pt_box(indxit) = DAT(indxit)
      enddo


!-----------------------------------------------------------------------
      A(1) = 1. 
      A(2) = 1. 
      A(3) = -1. 
      A(4) = 1. 
      A(5) = -1.5 
      A(6) = 1./(0.5 &
              & + X(4))**0.5 
      A(7) = 0.98 
      A(8) = -1. 
      A(9) = 1. 
      A(10) = 1./(0.5 &
              & + X(4))**0.5 
      A(11) = 0.98 
      A(12) = -1. 
      A(13) = 2. 
      A(14) = 3. 
      A(15) = 1. 
      A(16) = 2. 
      A(17) = -1. 
      A(18) = 6. 
      A(19) = 1. 
      A(20) = -1. 
      A(21) = 2. 
      A(22) = -2. 
      A(23) = 3. 
      A(24) = 1.*(1. &
              & + (X(1)*(-1.4142135623730951 &
              & - X(1) &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(6)))/(1 &
              & + X(1))**2 &
              & - (-1.4142135623730951 &
              & - X(1) &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(6))/(1 &
              & + X(1)) &
              & - (X(1)/(1 &
              & + X(1))**2 &
              & - 1/(1 &
              & + X(1)))*(-1.4142135623730951 &
              & - X(1) &
              & + 2.*(0.5 &
              & + X(4))**0.5 &
              & + 0.98*X(5))) 
      A(25) = 1.*(-(X(1)/((1 &
              & + X(1))*(0.5 &
              & + X(4))**0.5)) &
              & - (1. &
              & - X(1)/(1 &
              & + X(1)))/(0.5 &
              & + X(4))**0.5) 
      A(26) = -0.98*(1. &
              & - X(1)/(1 &
              & + X(1))) 
      A(27) = (-0.98*X(1))/(1 &
              & + X(1)) 
      A(28) = 1. 
      A(29) = 1. 
      A(30) = 1. 
      A(31) = 1.*(0.001 &
              & + X(10)) 
      A(32) = -2.*X(9) 
      A(33) = 1.*(0.001 &
              & + X(8)) 
      A(34) = 1.*(0.001 &
              & + X(13)) 
      A(35) = -2.*X(11) 
      A(36) = 1.*(0.001 &
              & + X(8)) 
      A(37) = 1.*(0.001 &
              & + X(13)) 
      A(38) = -2.*X(12) 
      A(39) = 1.*(0.001 &
              & + X(10)) 
      A(40) = 1.*(1.e-6 &
              & + 0.001*X(10) &
              & - X(12)**2 &
              & + 0.001*X(13) &
              & + X(10)*X(13)) 
      A(41) = 1.*(-0.002*X(9) &
              & + 2*X(11)*X(12) &
              & - 2*X(9)*X(13)) 
      A(42) = 1.*(1.e-6 &
              & + 0.001*X(8) &
              & - X(11)**2 &
              & + 0.001*X(13) &
              & + X(8)*X(13)) 
      A(43) = 1.*(-0.002*X(11) &
              & - 2*X(10)*X(11) &
              & + 2*X(9)*X(12)) 
      A(44) = 1.*(2*X(9)*X(11) &
              & - 0.002*X(12) &
              & - 2*X(8)*X(12)) 
      A(45) = 1.*(1.e-6 &
              & + 0.001*X(8) &
              & - X(9)**2 &
              & + 0.001*X(10) &
              & + X(8)*X(10)) 
      A(46) = 1. 
      A(47) = 1. 
      A(48) = 1.*(0.001 &
              & + X(16)) 
      A(49) = -2.*X(15) 
      A(50) = 1.*(0.001 &
              & + X(14)) 



!-----------------------------------------------------------------------      
      return
!-----------------------------------------------------------------------      
      end subroutine jac_constraints
      
     
!=======================================================================      

      subroutine prob_weights(X,state_in,Prob) !returns the prob weidhts

!=======================================================================      

      implicit none

      integer, intent(in) :: state_in
      real(prec), intent(in) :: X(nvars)
      real(prec), intent(out)   ::  Prob(no_integnodes)
      real(prec) ::  Prob_tmp(n_disc_state,no_integnodes)

      Prob_tmp(1,1) = 1 &
              & - X(1)/(1 &
              & + X(1))


      Prob(:) = Prob_tmp(state_in,:)
      

!-----------------------------------------------------------------------      
      end subroutine prob_weights
!-----------------------------------------------------------------------    


