#include <fstream>
#include <iostream>
#include <math.h>
//#include <mpi.h>


using namespace std;


//=====================================================================
/* Main Routine
 * 
 */
//=====================================================================

//Main Fortran routine
extern "C" { void main_fortran_();}  

//Parameter module interface
extern "C" { double __parameter_module_MOD_init_paramodule();}

extern "C" { double __parameter_module_MOD_init_process();} //init mpi
extern "C" { double __parameter_module_MOD_is_master(bool *ismaster);}

extern "C" int *debug_ptr;
extern "C" int *start_iter_ptr;
extern "C" int *dim_model_ptr;
extern "C" int *n_disc_state_ptr;



//=====================================================================  
int main(int argc, char *argv[]){

    //initialize MPI
    __parameter_module_MOD_init_process();
    bool ismaster;
    __parameter_module_MOD_is_master(&ismaster);


//============================================================================

    char* file_name = "BGMM_step_model"; //filename for output

    // time variables
    double t1, t2;

    

    //transfer settings over from parameter module
    __parameter_module_MOD_init_paramodule();
    int debug = *debug_ptr;
    int start_iter = *start_iter_ptr;
    int dim_model = *dim_model_ptr;
    int n_disc_state = *n_disc_state_ptr;

    //call main Fortran routine
    if(ismaster){
        cout << "=====================================================" << endl;
        cout << " Launching the value function iteration from main.cpp "<< endl;
        cout << "=====================================================" << endl;
    }

    main_fortran_();

 
/**********************************************************************/
    if(ismaster){
       cout << "=====================================================" << endl;
       cout << " model solved " << endl;
       cout << "=====================================================" << endl;
    }
    return 0;
  }
//=====================================================================
