#include <fstream>
#include <iostream>
#include <math.h>

//=====================================================================
/* Main Routine to simulate
 * 
 */
//=====================================================================

using namespace std;

//=====================================================================  
//Fortran routines
extern "C" { void sim_fortran_(const int *step,const int *n_iter,const int *optimize, const int *use_warmstart, const int *fix_shock);}  

//Parameter module interface
extern "C" { double __parameter_module_MOD_init_paramodule();}

extern "C" { double __parameter_module_MOD_init_process();} //init mpi
extern "C" { double __parameter_module_MOD_is_master(bool *ismaster);}

extern "C" int *debug_ptr;
extern "C" int *start_iter_ptr;
extern "C" int *dim_model_ptr;
extern "C" int *n_disc_state_ptr;


//=====================================================================  
int main(int argc, char *argv[]){

    //initialize MPI
    __parameter_module_MOD_init_process();
    bool ismaster;
    __parameter_module_MOD_is_master(&ismaster);

//============================================================================

    int step = 308; //step to simulate
    int n_iter = 10; //how many iterations
    int optimize = 1; //!0: no optimization during simulation; 1: optimization to help smooth policy
    int use_warmstart = 0;
    int fix_shock = 0; //if 0 random shocks will be drawn, if 1 shock is constant



    //call main Fortran routine
    cout << " Launching the simulation computation from main.cpp "<< endl;
    sim_fortran_(&step,&n_iter,&optimize,&use_warmstart,&fix_shock);

    
 
/**********************************************************************/
    cout << "error computation done " << endl;
    return 0;
  }
//=====================================================================

