(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     48049,        949]
NotebookOptionsPosition[     47634,        934]
NotebookOutlinePosition[     48001,        950]
CellTagsIndexPosition[     47958,        947]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "\"\<*\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6544450770169287`*^9, 3.654445077567218*^9}, {
   3.655735296931308*^9, 3.6557352973408623`*^9}, 
   3.658014976060871*^9},ExpressionUUID->"2bb75c11-dc9a-4193-9a08-\
12301d06dfa5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"filenamewrapper", "=", "\"\<Optimization_fortran_funcs.f90\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pathandfilenamec", "=", 
   RowBox[{"directorystr", "<>", "filenamewrapper"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ipoptwrapper", "=", 
   RowBox[{"OpenWrite", "[", "pathandfilenamec", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outstr", "=", "\"\<\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n      \n\
!=======================================================================      \
\n\n      subroutine solve_feas(grid_pt_box, X, N, DAT, IDAT)\n\n\
!=======================================================================      \
\n\n!.....returns an improved initial guess by solving for some of the \
variables\n      implicit none\n\n      integer, intent(in) :: N\n      \
real(prec), intent(in)   ::  grid_pt_box(dim_model)\n      real(prec) :: X(N)\
\n      real(prec) :: X_tmp(N)\n\n      integer                 ::  state_in\n\
\n      \n \n      real(prec),dimension(dim_sim) :: DAT\n      integer :: \
IDAT(*)     \n\n\
!-----------------------------------------------------------------------\n!   \
  compute random start points\n\n      state_in = IDAT(1)\n\n      X_tmp(:) = \
x(:)\n\n\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outstr", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"outstr", ",", "\"\<\n          \n\n\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"matsq", "=", 
       RowBox[{
        RowBox[{"ListofMats", "[", 
         RowBox[{"[", "indxm", "]"}], "]"}], ".", 
        RowBox[{"ListofMats", "[", 
         RowBox[{"[", "indxm", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"counter", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"outstr", "=", 
             RowBox[{"StringJoin", "[", 
              RowBox[{"outstr", ",", 
               RowBox[{"\"\<        \>\"", "<>", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{
                    RowBox[{"ListofSeq", "[", 
                    RowBox[{"[", 
                    RowBox[{"indxm", ",", "counter"}], "]"}], "]"}], ",", 
                    "FortranForm"}], "]"}], ",", "replacetonumerated"}], 
                 "]"}], "<>", "\"\< = \>\""}], ",", 
               RowBox[{"StringReplace", "[", 
                RowBox[{
                 RowBox[{"ToString", "[", 
                  RowBox[{
                   RowBox[{"matsq", "[", 
                    RowBox[{"[", 
                    RowBox[{"indxi", ",", "indxo"}], "]"}], "]"}], ",", 
                   "FortranForm"}], "]"}], ",", 
                 RowBox[{"Join", "[", 
                  RowBox[{
                  "addreplacerule", ",", "replacerulefixunderscore", ",", 
                   "replacerulenewline", ",", "replacetonumeratedtmp", ",", 
                   "replacerulenewlineF"}], "]"}]}], "]"}], ",", 
               "\"\<\n\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"counter", "=", 
             RowBox[{"counter", "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
           ",", 
           RowBox[{"{", 
            RowBox[{"indxi", ",", "indxo", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"ListofMats", "[", 
               RowBox[{"[", "indxm", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
         ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"indxo", ",", "1", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"ListofMats", "[", 
            RowBox[{"[", "indxm", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
      ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"indxm", ",", 
       RowBox[{"Length", "[", "ListofMats", "]"}]}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<        \>\"", ",", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"solvevars", "[", 
            RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
          "replacetonumerated"}], "]"}], ",", "\"\< = \>\"", ",", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"solvevars", "[", 
              RowBox[{"[", "indx", "]"}], "]"}], "/.", 
             RowBox[{"solfeas", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ",", "FortranForm"}], "]"}], 
          ",", 
          RowBox[{"Join", "[", 
           RowBox[{
           "addreplacerule", ",", "replacerulefixunderscore", ",", 
            "replacerulenewline", ",", "replacetonumerated", ",", 
            "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
         "]"}], ",", "\"\<\n\>\""}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", 
       RowBox[{"Length", "[", "solvevars", "]"}]}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outstr", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{
    "outstr", ",", 
     "\"\<\n      \n      return\n\
!=======================================================================   \n \
  \n      end subroutine solve_feas\n\n\
!======================================================================= \n\n\
\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outstr", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{
    "outstr", ",", 
     "\"\<\n!-----------------------------------------------------------------\
------      \n\n      subroutine next_cont_state(f_next_all,state_in,  X, N)\n\
\n!-----------------------------------------------------------------------    \
  \n\n!.....returns a matrix where the i-th row is the next continuous state \
given that state i will be the next discrete one\n      implicit none\n\n     \
 integer, intent(in) :: N\n      real(prec), intent(in)   ::  X(N)\n      \
real(prec), dimension(no_integnodes,dim_sim), intent(out) :: f_next_all \n\n  \
    integer :: indx\n\n      integer                 ::  state_in\n\n\n\n\
!-----------------------------------------------------------------------\n!   \
  compute random start points\n\n\n\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"outstr", "=", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"outstr", ",", 
          RowBox[{"\"\<\n      f_next_all(\>\"", "<>", 
           RowBox[{"ToString", "[", "indxs", "]"}], "<>", "\"\<,\>\"", "<>", 
           RowBox[{"ToString", "[", "indx", "]"}], "<>", "\"\<) = X(\>\""}], 
          ",", 
          RowBox[{"ToString", "[", 
           RowBox[{"ListofStateDynamicIndex", "[", 
            RowBox[{"[", 
             RowBox[{"indxs", ",", "indx"}], "]"}], "]"}], "]"}], ",", 
          "\"\<)\>\""}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"indx", ",", "1", ",", "ncontstates"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<\n\>\""}], "]"}]}], ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"indxs", ",", "1", ",", "nshocks"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"outstr", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{
    "outstr", ",", 
     "\"\<\n\n\n      return\n\
!-----------------------------------------------------------------------      \
\n      end subroutine next_cont_state\n\
!-----------------------------------------------------------------------  \n  \
    \n!-----------------------------------------------------------------------\
      \n\n      subroutine inv_next_cont_state(f_next_all, X, N)\n\n\
!-----------------------------------------------------------------------      \
\n\n      implicit none\n\n      integer, intent(in) :: N\n      real(prec), \
intent(out)   ::  X(N)\n      real(prec), dimension(no_integnodes,dim_sim), \
intent(in) :: f_next_all \n      \n\
!----------------------------------------------------------------------   \n\n\
!-----------------------------------------------------------------------\n!   \
  compute random start points\n\n\>\""}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"outstr", "=", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"outstr", ",", "\"\<\n      X(\>\"", ",", 
          RowBox[{"ToString", "[", 
           RowBox[{"ListofStateDynamicIndex", "[", 
            RowBox[{"[", 
             RowBox[{"indxs", ",", "indx"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"\"\<) = f_next_all(\>\"", "<>", 
           RowBox[{"ToString", "[", "indxs", "]"}], "<>", "\"\<,\>\"", "<>", 
           RowBox[{"ToString", "[", "indx", "]"}], "<>", "\"\<)\>\""}]}], 
         "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"indx", ",", "1", ",", "ncontstates"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<\n\>\""}], "]"}]}], ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"indxs", ",", "1", ",", "nshocks"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n      return\n\
!-----------------------------------------------------------------------      \
\n      end subroutine inv_next_cont_state\n\
!-----------------------------------------------------------------------  \n  \
    \n\n!=====================================================================\
========\n! \n!     Computation of objective \n! \n\
!=============================================================================\
\n\n      subroutine princ_utility(X, iu, DAT,util)\n        \n      implicit \
none\n      \n      real(prec), intent(out) :: util\n      real(prec), target \
  :: X(nvars)\n      real(prec),dimension(dim_sim) :: DAT\n      integer :: \
iu(*)\n\n      integer               ::  state_in, indxit\n\n      \
real(prec),dimension(dim_sim)  ::  grid_pt_box                \n      \
real(prec)   ::  Prob(no_integnodes)              \n      \n\
!----------------------------------------------------------------------   \n\n\
      state_in = iu(1)\n      do indxit =1,dim_sim      \n         \
grid_pt_box(indxit) = DAT(indxit)\n      enddo\n\n      call \
prob_weights(X,state_in,Prob)\n\n!.....compute current util\n\>\""}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{"outstr", ",", "\"\<      util = \>\"", ",", 
      RowBox[{"StringReplace", "[", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{
          RowBox[{"principalutilityU", "/.", "parameterssub"}], ",", 
          "FortranForm"}], "]"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{
         "replacerulefixunderscore", ",", "replacetonumerated", ",", 
          "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], "]"}],
       ",", "\"\<\n\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n      return\n      \n\
!-----------------------------------------------------------------------      \
\n      end subroutine princ_utility\n\
!-----------------------------------------------------------------------      \
   \n\n\n!====================================================================\
=========\n! \n!     Computation of constraints \n! \n\
!=============================================================================\
\n\n      subroutine constraints(N, X, M, G, IDAT, DAT)\n        \n      \
implicit none\n      \n      integer :: N, M\n      real(prec), target   :: \
X(N)\n      real(prec),dimension(dim_sim) :: DAT\n      integer :: IDAT(*)\n  \
    real(prec)              :: G(M)       \n\n      integer                 \
::   state_in, indxit\n\n      real(prec),dimension(dim_sim)  ::  grid_pt_box \
               \n      real(prec)   ::  Prob(no_integnodes)                  \
\n      \n!-------------------------------------------------------------------\
---   \n\n      state_in = IDAT(1)\n      do indxit =1,dim_sim      \n        \
 grid_pt_box(indxit) = DAT(indxit)\n      enddo\n\n      call \
prob_weights(X,state_in,Prob)\n\n\n!.....mapping the x to named pointers\n\
\>\""}], "]"}]}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<      G(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ListofConstraints", "[", 
               RowBox[{"[", "indx", "]"}], "]"}], "/.", 
              RowBox[{"beta2", "\[Rule]", "beta"}]}], "/.", "parameterssub"}],
             ",", "FortranForm"}], "]"}], ",", 
          RowBox[{"Join", "[", 
           RowBox[{
           "replacerulefixunderscore", ",", "replacetonumerated", ",", 
            "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
         "]"}], ",", "\"\<\n\>\""}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n      return\n      \n\
!-----------------------------------------------------------------------      \
\n      end subroutine constraints\n\
!-----------------------------------------------------------------------      \
\n \n \n\n!===================================================================\
====      \n\n      subroutine sparsity_pattern(ACON, AVAR, nnz) !returns the \
sparsity pattern\n\n\
!=======================================================================      \
\n\n!.....returns the sparsity pattern compatible for IPOPT\n      implicit \
none\n\n      integer, intent(in) :: nnz  !nonzero entries\n      integer, \
intent(out)   ::  ACON(nnz),AVAR(nnz)\n\n\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<      ACON(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"ToString", "[", 
         RowBox[{
          RowBox[{"indxjacnonzero", "[", 
           RowBox[{"[", 
            RowBox[{"indx", ",", "1"}], "]"}], "]"}], ",", "CForm"}], "]"}], 
        ",", "\"\< \n      AVAR(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"ToString", "[", 
         RowBox[{
          RowBox[{"indxjacnonzero", "[", 
           RowBox[{"[", 
            RowBox[{"indx", ",", "2"}], "]"}], "]"}], ",", "CForm"}], "]"}], 
        ",", "\"\<\n\>\""}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nnonzerojac"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n\n!--------------------------------------------------------------\
---------      \n      end subroutine sparsity_pattern\n\
!----------------------------------------------------------------------- \n\n\
!=======================================================================      \
\n\n      subroutine sparsity_pattern_obj(AVAR, nnz) !returns the sparsity \
pattern of the objective\n\n\
!=======================================================================      \
\n\n!.....returns the sparsity pattern of the objective for SNOPT\n      \
implicit none\n\n      integer, intent(in) :: nnz  !nonzero entries\n      \
integer, intent(out)   ::  AVAR(nnz)\n\n\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\< \n      AVAR(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"ToString", "[", 
         RowBox[{
          RowBox[{"indxobjnonzero", "[", 
           RowBox[{"[", "indx", "]"}], "]"}], ",", "CForm"}], "]"}], ",", 
        "\"\<\n\>\""}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nnonzeroobj"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n\n!--------------------------------------------------------------\
---------      \n      end subroutine sparsity_pattern_obj\n\
!----------------------------------------------------------------------- \n\n\
\n!=======================================================================    \
  \n\n      subroutine bounds(n,xlow, xhigh, m, flow, fhigh,bigbnd, &\n      \
& IDAT, DAT ) \n      !returns the bounds on variables and constraints\n\n\
!=======================================================================      \
\n\n      implicit none\n\n      real(prec),dimension(dim_sim) :: DAT\n      \
integer :: IDAT(*)\n\n      integer, intent(in) :: n,m \n      real(prec), \
intent(in) :: bigbnd\n      real(prec), intent(out)   ::  \
xlow(n),xhigh(n),flow(m),fhigh(m)\n\n      integer                 ::  \
state_in,indxit\n\n      real(prec),dimension(dim_sim)  ::  grid_pt_box       \
         \n\n            \n   \n!---------------------------------------------\
-------------------------   \n\n      state_in = IDAT(1)\n      do indxit \
=1,dim_sim      \n         grid_pt_box(indxit) = DAT(indxit)\n      enddo\n\n\
\n\n\n\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"outstr", "=", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"outstr", ",", "\"\<      xlow(\>\"", ",", 
       RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"LBvars", "[", 
            RowBox[{"[", "indx", "]"}], "]"}], ",", "FortranForm"}], "]"}], 
         ",", 
         RowBox[{"Join", "[", 
          RowBox[{
          "replacerulefixunderscore", ",", "replacetonumerated", ",", 
           "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
        "]"}], ",", "\"\< \n      xhigh(\>\"", ",", 
       RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"UBvars", "[", 
            RowBox[{"[", "indx", "]"}], "]"}], ",", "FortranForm"}], "]"}], 
         ",", 
         RowBox[{"Join", "[", 
          RowBox[{
          "replacerulefixunderscore", ",", "replacetonumerated", ",", 
           "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
        "]"}], ",", "\"\<\n\>\""}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<      flow(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{
            RowBox[{"LBconstraints", "[", 
             RowBox[{"[", "indx", "]"}], "]"}], ",", "FortranForm"}], "]"}], 
          ",", 
          RowBox[{"Join", "[", 
           RowBox[{
           "replacerulefixunderscore", ",", "replacetonumerated", ",", 
            "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
         "]"}], ",", "\"\< \n      fhigh(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{
            RowBox[{"UBconstraints", "[", 
             RowBox[{"[", "indx", "]"}], "]"}], ",", "FortranForm"}], "]"}], 
          ",", 
          RowBox[{"Join", "[", 
           RowBox[{
           "replacerulefixunderscore", ",", "replacetonumerated", ",", 
            "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
         "]"}], ",", "\"\<\n\>\""}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"outstr", "=", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"outstr", ",", 
         RowBox[{"\"\<      if(grid_pt_box(\>\"", "<>", 
          RowBox[{"ToString", "[", "indxa", "]"}], "<>", 
          "\"\<) .eq. 0.) then\n\>\""}]}], " ", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"outstr", "=", 
          RowBox[{"StringJoin", "[", 
           RowBox[{"outstr", ",", "\"\<            \>\""}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"outstr", "=", 
          RowBox[{"StringJoin", "[", 
           RowBox[{"outstr", ",", "\"\<xlow(\>\"", ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"VarsbyAgentpos", "[", 
              RowBox[{"[", 
               RowBox[{"indxa", ",", "indxv"}], "]"}], "]"}], "]"}], ",", 
            "\"\<) = 0.\>\"", ",", "\"\< \n            xhigh(\>\"", ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"VarsbyAgentpos", "[", 
              RowBox[{"[", 
               RowBox[{"indxa", ",", "indxv"}], "]"}], "]"}], "]"}], ",", 
            "\"\<) = 0.\>\"", ",", "\"\<\n\>\""}], "]"}]}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"indxv", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"VarsbyAgent", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"outstr", "=", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"outstr", ",", "\"\<      endif\n\>\""}], " ", "]"}]}], ";"}],
      "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{
     "outstr", ",", 
      "\"\<\n\n!--------------------------------------------------------------\
---------      \n      end subroutine bounds\n\
!----------------------------------------------------------------------- \n\n\
\n\n!=========================================================================\
====\n! \n!                 Computation of Jacobian of equality constraints\n\
! \n!=========================================================================\
====\n\n      subroutine jac_constraints(N, X, M, NZ, A, &\n     &     IDAT, \
DAT)\n\n      implicit none\n\n      integer ::  NZ\n      integer :: M, N\n  \
    real(prec), target :: X(N)\n      real(prec) :: A(NZ)\n      integer :: \
i, j, k\n      real(prec),dimension(dim_sim) :: DAT\n      integer :: IDAT(*)\
\n\n\n      real(prec),dimension(dim_sim)  ::  grid_pt_box                \n\n\
      integer :: indxit\n\
!-----------------------------------------------------------------------      \
\n\n      do indxit =1,dim_sim      \n         grid_pt_box(indxit) = \
DAT(indxit)\n      enddo\n\n\n\
!-----------------------------------------------------------------------\n\
\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"outstr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"outstr", ",", "\"\<      A(\>\"", ",", 
        RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1.", "*", 
              RowBox[{"jacconstraints", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"indxjacnonzero", "[", 
                  RowBox[{"[", 
                   RowBox[{"indx", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"indxjacnonzero", "[", 
                  RowBox[{"[", 
                   RowBox[{"indx", ",", "2"}], "]"}], "]"}]}], "]"}], "]"}]}],
              "/.", "parameterssub"}], ",", "FortranForm"}], "]"}], ",", 
          RowBox[{"Join", "[", 
           RowBox[{
           "replacerulefixunderscore", ",", "replacetonumerated", ",", 
            "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
         "]"}], ",", "\"\< \n\>\""}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nnonzerojac"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outstr", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{
    "outstr", ",", 
     "\"\<\n\n\n\
!-----------------------------------------------------------------------      \
\n      return\n\
!-----------------------------------------------------------------------      \
\n      end subroutine jac_constraints\n      \n     \n\
!=======================================================================      \
\n\n      subroutine prob_weights(X,state_in,Prob) !returns the prob weidhts\n\
\n!=======================================================================    \
  \n\n      implicit none\n\n      integer, intent(in) :: state_in\n      \
real(prec), intent(in) :: X(nvars)\n      real(prec), intent(out)   ::  \
Prob(no_integnodes)\n      real(prec) ::  \
Prob_tmp(n_disc_state,no_integnodes)\n\n\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"outstr", "=", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"outstr", ",", "\"\<      Prob_tmp(\>\"", ",", 
          RowBox[{"ToString", "[", "indxs", "]"}], ",", "\"\<,\>\"", ",", 
          RowBox[{"ToString", "[", "indx", "]"}], ",", "\"\<) = \>\"", ",", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"SigMat", "[", 
                RowBox[{
                 RowBox[{"aactionvec", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"otheragentaggregvec", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"indxs", ",", "indx"}], "]"}], "]"}], ",", 
              "FortranForm"}], "]"}], ",", 
            RowBox[{"Join", "[", 
             RowBox[{
             "replacerulefixunderscore", ",", "replacetonumerated", ",", 
              "replacerulenewlineF", ",", "replacerulesFortran"}], "]"}]}], 
           "]"}], ",", "\"\<\n\>\""}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"indx", ",", "1", ",", "nshocks"}], "}"}]}], "]"}], ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"indxs", ",", "1", ",", "nshocks"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outstr", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{
    "outstr", ",", 
     "\"\<\n\n      Prob(:) = Prob_tmp(state_in,:)\n      \n\n\
!-----------------------------------------------------------------------      \
\n      end subroutine prob_weights\n\
!-----------------------------------------------------------------------    \n\
\n\n\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WriteString", "[", 
    RowBox[{"ipoptwrapper", ",", "outstr"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outstr", "=", "\"\<\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "ipoptwrapper", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6642821564228067`*^9, 3.664282159928513*^9}, {
   3.665262073749722*^9, 3.665262094105341*^9}, {3.6652621268813353`*^9, 
   3.665262218892137*^9}, 3.665262255630974*^9, 3.66526229083991*^9, {
   3.666548458441778*^9, 3.6665484723523808`*^9}, 3.666549935283379*^9, {
   3.66655055218919*^9, 3.6665505548405*^9}, {3.666708172702653*^9, 
   3.666708173269723*^9}, {3.6668805010488796`*^9, 3.666880519524358*^9}, {
   3.6682818257526197`*^9, 3.6682818367874327`*^9}, {3.668282018013321*^9, 
   3.668282028002268*^9}, 3.668625138683674*^9, 3.668625178137476*^9, {
   3.668779499988714*^9, 3.6687795550956078`*^9}, {3.6720824063960247`*^9, 
   3.6720824269526453`*^9}, {3.673102374707094*^9, 3.673102388101306*^9}, {
   3.673102457127284*^9, 3.673102458714718*^9}, 3.6745009444801817`*^9, {
   3.674500976988474*^9, 3.674500994243696*^9}, {3.676751925410324*^9, 
   3.676751934923801*^9}, {3.676757086390227*^9, 3.676757091763796*^9}, {
   3.676757156036083*^9, 3.6767571944223075`*^9}, {3.676757506179165*^9, 
   3.676757517074604*^9}, {3.676806065239423*^9, 3.67680606951261*^9}, {
   3.6768398351483603`*^9, 3.676839869200111*^9}, {3.6768403728812*^9, 
   3.676840378706965*^9}, {3.676840549597075*^9, 3.676840555618363*^9}, {
   3.67684068800438*^9, 3.676840703144792*^9}, {3.6768409105353622`*^9, 
   3.676840919821699*^9}, 3.681128289175551*^9, 3.681130668878578*^9, {
   3.6811359378222103`*^9, 3.681135940473155*^9}, 3.681136275549459*^9, {
   3.681151630937599*^9, 3.681151659199695*^9}, {3.681151853527535*^9, 
   3.681151894164997*^9}, {3.681151924537294*^9, 3.681152088011779*^9}, {
   3.6811521549958878`*^9, 3.681152173422761*^9}, 3.681211071223021*^9, 
   3.681211680635119*^9, 3.681477912703475*^9, 3.681478043973572*^9, 
   3.681478127105544*^9, 3.6814782497421837`*^9, 3.681478291459869*^9, 
   3.681478331340391*^9, 3.681478367167206*^9, {3.681478482917321*^9, 
   3.681478483200727*^9}, {3.681478542454093*^9, 3.68147854882605*^9}, {
   3.681478700568672*^9, 3.6814787038492947`*^9}, {3.6821698057741737`*^9, 
   3.68216980636945*^9}, {3.68217999750603*^9, 3.6821800058142223`*^9}, {
   3.682211487710882*^9, 3.6822114901137495`*^9}, {3.6826010095356426`*^9, 
   3.6826010246483574`*^9}, {3.682601187393273*^9, 3.682601202673421*^9}, {
   3.6826016361789675`*^9, 3.682601658281378*^9}, {3.682711605281196*^9, 
   3.682711631972582*^9}, {3.6827116689794083`*^9, 3.682711687519804*^9}, {
   3.682712660492457*^9, 3.682712689209807*^9}, {3.682713230535129*^9, 
   3.682713234916184*^9}, {3.6827132705572233`*^9, 3.682713355632228*^9}, {
   3.6827134047762814`*^9, 3.682713437326886*^9}, {3.6827134877662897`*^9, 
   3.682713514750436*^9}, {3.682718887576712*^9, 3.6827189061076517`*^9}, {
   3.682720333163923*^9, 3.6827203403676996`*^9}, {3.682720657816943*^9, 
   3.682720658185862*^9}, {3.6827223066623735`*^9, 3.6827223115369644`*^9}, {
   3.6827223982136135`*^9, 3.682722432654525*^9}, {3.6827225090174637`*^9, 
   3.682722515245267*^9}, {3.6827225546109962`*^9, 3.6827226077131047`*^9}, {
   3.682778933182242*^9, 3.682778936145157*^9}, {3.682778981049836*^9, 
   3.682778982248146*^9}, {3.682779038826982*^9, 3.682779052171526*^9}, {
   3.682779106471977*^9, 3.6827792002998447`*^9}, {3.6827930864130898`*^9, 
   3.682793153173769*^9}, {3.682793184468502*^9, 3.682793204179389*^9}, {
   3.68279361292076*^9, 3.682793634670105*^9}, {3.682793701085018*^9, 
   3.6827937103651533`*^9}, 3.682799679783972*^9, {3.6828082160711412`*^9, 
   3.6828082187359104`*^9}, {3.684254314008964*^9, 3.684254324703393*^9}, {
   3.705417711457266*^9, 3.70541776724572*^9}, 3.705417853622716*^9, {
   3.705417942281803*^9, 3.7054179502379093`*^9}, {3.705418008458583*^9, 
   3.705418043870422*^9}, {3.705639544145938*^9, 3.705639547222807*^9}, {
   3.705639591466967*^9, 3.705639665711687*^9}, {3.705639775123372*^9, 
   3.705639778779723*^9}, {3.705639822580217*^9, 3.705639851635723*^9}, {
   3.7056414252421007`*^9, 3.705641449403309*^9}, 3.705641641108136*^9, 
   3.705641776763188*^9, {3.7056418723083267`*^9, 3.705641875800346*^9}, 
   3.7056419526764593`*^9, {3.705642142301549*^9, 3.705642184460692*^9}, {
   3.705642722332101*^9, 3.705642733016419*^9}, 3.70564276358246*^9, 
   3.705642794576331*^9, 3.7056428494474707`*^9, {3.7056428876087017`*^9, 
   3.7056428892948627`*^9}, {3.705644127475885*^9, 3.70564413448543*^9}, {
   3.7056442951825447`*^9, 3.7056443216790953`*^9}, {3.705645111698083*^9, 
   3.705645141929186*^9}, {3.705645293500719*^9, 3.705645298554821*^9}, {
   3.706499238084502*^9, 3.706499242515851*^9}, {3.706499286272355*^9, 
   3.706499421860177*^9}, {3.706499452172554*^9, 3.706499539704554*^9}, {
   3.706499704250798*^9, 3.706499781504394*^9}, {3.706499818765113*^9, 
   3.7064998523880787`*^9}, {3.706499937591045*^9, 3.706499948651197*^9}, {
   3.706500539471449*^9, 3.7065006616768913`*^9}, {3.7065015127760973`*^9, 
   3.7065015764980373`*^9}, {3.706505594636039*^9, 3.70650566150975*^9}, {
   3.706505772937443*^9, 3.706505798374776*^9}, {3.70650586588069*^9, 
   3.706505885650042*^9}, {3.706506640481194*^9, 3.7065066422702847`*^9}, {
   3.706506674753689*^9, 3.706506716640328*^9}, 3.706506751057562*^9, {
   3.70650697419663*^9, 3.706507009550585*^9}, {3.706507198061226*^9, 
   3.706507198446765*^9}, {3.7065072736345663`*^9, 3.70650731597814*^9}, {
   3.7065075904200172`*^9, 3.706507608345913*^9}, {3.706510242094388*^9, 
   3.706510314219282*^9}, {3.706510367102005*^9, 3.706510391099721*^9}, {
   3.706510594379798*^9, 3.706510596875668*^9}, {3.7065107356909237`*^9, 
   3.706510828684764*^9}, {3.706510861563189*^9, 3.706510906633671*^9}, {
   3.70651101137868*^9, 3.706511020128663*^9}, {3.706511058218225*^9, 
   3.706511128921289*^9}, {3.706511378457946*^9, 3.706511396819545*^9}, {
   3.706522994744708*^9, 3.706523006741725*^9}, 3.706523041052656*^9, {
   3.706524443784072*^9, 3.7065244750020323`*^9}, 3.706538938974313*^9, {
   3.706538982273341*^9, 3.7065391530459146`*^9}, {3.7065394162783957`*^9, 
   3.706539449933981*^9}, {3.7065396523319197`*^9, 3.706539658754384*^9}, {
   3.70653983065615*^9, 3.706539875743956*^9}, {3.70653994060748*^9, 
   3.7065399484350157`*^9}, {3.706540029581637*^9, 3.706540032188621*^9}, {
   3.7065402440644827`*^9, 3.706540261900576*^9}, {3.706540459068314*^9, 
   3.706540538386517*^9}, {3.706541709839239*^9, 3.7065417682688932`*^9}, {
   3.7065418115902777`*^9, 3.706541821750139*^9}, {3.706541946070055*^9, 
   3.706542043479128*^9}, 3.706591990729431*^9, {3.7065923766545887`*^9, 
   3.706592395579328*^9}, {3.706592488400702*^9, 3.7065925424741364`*^9}, {
   3.706592581065596*^9, 3.706592619237905*^9}, {3.706592666860106*^9, 
   3.706592792672823*^9}, {3.706592829225319*^9, 3.706592853927846*^9}, {
   3.7065928862964773`*^9, 3.706592925156395*^9}, {3.706592992455099*^9, 
   3.706592996041472*^9}, {3.706593367045636*^9, 3.706593369119471*^9}, {
   3.706594029360894*^9, 3.706594031471381*^9}, {3.7065981561115437`*^9, 
   3.7065981780773067`*^9}, {3.70659823967714*^9, 3.7065982405405397`*^9}, {
   3.7065990507767887`*^9, 3.706599056075994*^9}, {3.70660422293084*^9, 
   3.706604315343326*^9}, {3.7066043820971203`*^9, 3.70660442850976*^9}, 
   3.706604463599642*^9, 3.706604692369125*^9, {3.7066077032493343`*^9, 
   3.706607751553296*^9}, {3.7066081974443407`*^9, 3.7066082320000343`*^9}, 
   3.706608444813409*^9, {3.7066111290861263`*^9, 3.706611134461261*^9}, 
   3.706611300638317*^9, {3.7066113437287827`*^9, 3.706611346939752*^9}, {
   3.7066117359060917`*^9, 3.70661174581945*^9}, {3.7165390846958323`*^9, 
   3.7165390963408422`*^9}, {3.71653929234762*^9, 3.71653930932233*^9}, {
   3.716539450964897*^9, 3.716539459555983*^9}, {3.716552689907921*^9, 
   3.7165528761287394`*^9}, {3.7165529828181763`*^9, 3.716553015010477*^9}, {
   3.7165530493624287`*^9, 3.716553073345572*^9}, {3.716553106754427*^9, 
   3.716553172526114*^9}, {3.71655322756824*^9, 3.716553257918315*^9}, 
   3.7166249972047377`*^9, {3.716626075502233*^9, 3.716626103931492*^9}, {
   3.716626502659788*^9, 3.716626546546535*^9}, {3.716626798353155*^9, 
   3.716626806538166*^9}, {3.7195730154275703`*^9, 3.719573047306018*^9}, {
   3.719573341944023*^9, 3.7195733907437143`*^9}, {3.7195734933104973`*^9, 
   3.719573543033616*^9}, {3.71957357898657*^9, 3.7195735827622633`*^9}, {
   3.7195737279919987`*^9, 3.719573728647612*^9}, {3.7195737642550907`*^9, 
   3.719573766632333*^9}, 3.719581391523179*^9, {3.725277581458076*^9, 
   3.725277588227413*^9}, {3.725337483376165*^9, 3.725337487550015*^9}, {
   3.7324302197148123`*^9, 3.7324302854128723`*^9}, {3.732430401875922*^9, 
   3.732430415473604*^9}, 3.732430482705418*^9, 3.732430515907537*^9, {
   3.7324357100964327`*^9, 3.732435748270102*^9}, {3.73243578135753*^9, 
   3.73243578458816*^9}, {3.732435815358077*^9, 3.7324359164618063`*^9}, {
   3.732435977627713*^9, 3.732436052226289*^9}, {3.732436085116406*^9, 
   3.732436118974865*^9}, {3.732436150800418*^9, 3.732436214508275*^9}, {
   3.732436276892016*^9, 3.732436385563396*^9}, {3.732438106466034*^9, 
   3.732438148374226*^9}, {3.7324382026441727`*^9, 3.7324382082768908`*^9}, 
   3.732439721140801*^9, 3.732507973035429*^9, 3.7325081189193497`*^9, {
   3.739778983498831*^9, 3.739779048402362*^9}, {3.739779494942028*^9, 
   3.73977960460926*^9}, {3.7397796680846987`*^9, 3.739779741427924*^9}, {
   3.7397797719833593`*^9, 3.739779830625677*^9}, {3.739781457513764*^9, 
   3.7397814680672407`*^9}, {3.739781521437566*^9, 3.739781532953638*^9}, 
   3.73978190484488*^9, {3.7397821541745043`*^9, 3.739782195214383*^9}, 
   3.73978224120382*^9, {3.7397823959569263`*^9, 3.739782401707106*^9}, 
   3.739782862370512*^9, {3.741967013685038*^9, 3.741967014921483*^9}, 
   3.770697166784328*^9, 3.770700636766053*^9, {3.7707014363132143`*^9, 
   3.770701438798386*^9}, {3.7707025626115932`*^9, 3.770702564900075*^9}, {
   3.770702662153317*^9, 3.770702737302682*^9}, 3.770707480186406*^9, {
   3.770711049453994*^9, 3.770711059338479*^9}, {3.770711164417254*^9, 
   3.77071116788785*^9}, {3.770960946457699*^9, 3.770960953109915*^9}, {
   3.7709609831224737`*^9, 3.770961075778116*^9}, {3.770961107462551*^9, 
   3.770961226806822*^9}, {3.770961264633945*^9, 3.77096127740981*^9}, {
   3.770961727693863*^9, 3.7709617342529907`*^9}, {3.770961817585876*^9, 
   3.770961817965885*^9}, 3.770961884526696*^9, {3.7710434690684423`*^9, 
   3.771043578616283*^9}, {3.771044345736465*^9, 3.771044408519104*^9}, {
   3.771044454598527*^9, 3.771044464303648*^9}, {3.771044497900856*^9, 
   3.771044652058227*^9}, {3.7710446917044907`*^9, 3.771044704168715*^9}, 
   3.771129285540452*^9, {3.7711320007042313`*^9, 3.771132032522114*^9}, {
   3.771216318278138*^9, 3.7712165480967207`*^9}, {3.7712166753111887`*^9, 
   3.77121667643153*^9}, {3.771217992342902*^9, 3.77121800049914*^9}, {
   3.771218031054426*^9, 3.77121804110119*^9}, {3.772857753191934*^9, 
   3.7728577668070087`*^9}, {3.772857821259433*^9, 3.772857910680778*^9}, {
   3.772858085062455*^9, 3.772858121065452*^9}, {3.772858220648663*^9, 
   3.772858279255327*^9}, {3.772858315611397*^9, 3.772858345840232*^9}, {
   3.772866096328665*^9, 3.7728661530785093`*^9}, {3.772866233293893*^9, 
   3.7728663083449087`*^9}, {3.772866351796373*^9, 3.772866362749222*^9}, {
   3.772866393429241*^9, 3.7728665392414293`*^9}, {3.77287117497523*^9, 
   3.772871183965252*^9}, {3.772871250189157*^9, 3.772871250448648*^9}, {
   3.772872317218238*^9, 3.772872343051581*^9}, {3.772872670928587*^9, 
   3.772872671870771*^9}, {3.772873992327868*^9, 3.772874008232752*^9}, {
   3.772874081717408*^9, 3.772874121780341*^9}, {3.772877928819232*^9, 
   3.772877959054847*^9}, 3.772878489689115*^9, {3.77287877289491*^9, 
   3.772878801954907*^9}, {3.7728814922829323`*^9, 3.772881504699746*^9}, {
   3.772882220930232*^9, 3.772882223442623*^9}, {3.7730289915251102`*^9, 
   3.77302926700324*^9}, {3.773030084094597*^9, 3.773030198470952*^9}, {
   3.773030253990107*^9, 3.773030258400663*^9}, {3.7730303377256804`*^9, 
   3.773030350485219*^9}, {3.773030625799177*^9, 3.773030639091189*^9}, {
   3.773032201698655*^9, 3.7730322027189693`*^9}, {3.773036876432324*^9, 
   3.773036878568674*^9}, {3.773376241204072*^9, 3.773376280448102*^9}, {
   3.77337634610222*^9, 3.7733763767027407`*^9}, {3.773376409264855*^9, 
   3.773376412698264*^9}, {3.775539833938517*^9, 3.7755398406968517`*^9}, {
   3.7755398740349903`*^9, 3.775539876320448*^9}, {3.775540477280402*^9, 
   3.775540481167212*^9}, {3.7755405399669647`*^9, 3.775540552590613*^9}, {
   3.776408015084434*^9, 3.7764080473805637`*^9}, {3.776408095259391*^9, 
   3.7764081079816236`*^9}, 3.776495172074939*^9, 3.776495208622802*^9, 
   3.776495397098234*^9, {3.7764954822860823`*^9, 3.77649548617974*^9}, {
   3.776578101398716*^9, 3.7765781040229607`*^9}, {3.776587186779379*^9, 
   3.77658719499009*^9}, {3.776594745635449*^9, 3.776594791470089*^9}, {
   3.77659482456168*^9, 3.776594877369397*^9}, {3.776594959752326*^9, 
   3.7765949615414467`*^9}, {3.77659686512119*^9, 3.776596865741588*^9}, {
   3.77665869146817*^9, 3.7766586922651052`*^9}, {3.7771892834579477`*^9, 
   3.777189283612411*^9}, {3.7772775949729652`*^9, 3.777277670695538*^9}, {
   3.777280519708762*^9, 3.77728052845835*^9}, {3.777282199691485*^9, 
   3.777282203687954*^9}, {3.777282234860623*^9, 3.7772823555997143`*^9}, 
   3.777282393015984*^9, {3.777282482710547*^9, 3.777282496982276*^9}, 
   3.777282527422482*^9, {3.777282833951234*^9, 3.77728283439532*^9}, 
   3.7777876853287973`*^9, {3.777787715791325*^9, 3.777787734637665*^9}, {
   3.777788034306939*^9, 3.777788043566049*^9}, {3.777788285935811*^9, 
   3.7777883619174433`*^9}, {3.777788459487379*^9, 3.777788516461919*^9}, {
   3.777788562398946*^9, 3.777788562785355*^9}, {3.777788593501615*^9, 
   3.77778859751548*^9}, {3.777790033097665*^9, 3.777790035461487*^9}, 
   3.777790493588966*^9, {3.77779276146045*^9, 3.777792801315557*^9}, {
   3.77779696646989*^9, 3.777796976885203*^9}, {3.777800223596653*^9, 
   3.777800250741062*^9}, {3.777800361468514*^9, 3.777800388356306*^9}, {
   3.778218038819112*^9, 3.778218045486414*^9}, {3.778218477414901*^9, 
   3.7782184883037252`*^9}, {3.778219098739534*^9, 3.7782191422648363`*^9}, {
   3.778233777678219*^9, 3.778233827558346*^9}, {3.7782359715623627`*^9, 
   3.778235980270883*^9}, {3.7782360999862957`*^9, 3.778236112422669*^9}, {
   3.7782362466490726`*^9, 3.778236252169064*^9}, {3.778474197874646*^9, 
   3.778474213544856*^9}, 3.779422683321887*^9, {3.779423154398217*^9, 
   3.7794231621525793`*^9}, {3.7806573622940474`*^9, 3.780657368635927*^9}, {
   3.780657443085544*^9, 3.7806575416590776`*^9}, {3.7806579599528847`*^9, 
   3.780658110526033*^9}, 3.780658163310772*^9, 3.7806604156524973`*^9, 
   3.780725523935399*^9, {3.7807255910954103`*^9, 3.7807256113791857`*^9}, {
   3.78081121079177*^9, 3.7808112445841227`*^9}, {3.780812393196422*^9, 
   3.7808124562362823`*^9}, {3.781932214172224*^9, 3.7819322694440193`*^9}, {
   3.7825577579361362`*^9, 3.782557894475069*^9}, {3.782557927888988*^9, 
   3.782557955327971*^9}, 3.7825598541397657`*^9, {3.786775385590789*^9, 
   3.7867753871475563`*^9}, {3.786775557553801*^9, 3.786775583994834*^9}, {
   3.789487703767671*^9, 3.789487711892605*^9}, {3.789487754206653*^9, 
   3.789487755450673*^9}, {3.7894886534788837`*^9, 3.789488704322798*^9}, {
   3.789488755661818*^9, 3.789488776139144*^9}, {3.7894888087972593`*^9, 
   3.789488812730616*^9}, {3.78953261659125*^9, 3.789532635844428*^9}, {
   3.7987836750911837`*^9, 3.798783683143856*^9}, {3.798783819984374*^9, 
   3.7987838578576517`*^9}, {3.798783889956521*^9, 3.7987838998906813`*^9}, {
   3.7987839632333727`*^9, 3.79878401875884*^9}, {3.798784062876286*^9, 
   3.798784110977273*^9}, {3.798784322858767*^9, 3.798784366721386*^9}, {
   3.798784448847666*^9, 3.798784504486834*^9}, {3.798785781789072*^9, 
   3.798785783435912*^9}, {3.798785822030038*^9, 3.798785826960457*^9}, {
   3.798785881697916*^9, 3.7987858819635897`*^9}, {3.7987859133260403`*^9, 
   3.798785929778607*^9}, {3.7987860029977913`*^9, 3.798786009369597*^9}, {
   3.798786042469352*^9, 3.7987860427281837`*^9}, {3.7987860815709267`*^9, 
   3.798786086441348*^9}, {3.798786532092359*^9, 3.7987865487469482`*^9}, {
   3.798786601776376*^9, 3.798786602165937*^9}, {3.7987867374321136`*^9, 
   3.798786741748405*^9}, {3.798953330498439*^9, 3.798953431941544*^9}, {
   3.798953668933609*^9, 3.798953683026352*^9}, {3.799073677881428*^9, 
   3.799073691632259*^9}, {3.799073822082123*^9, 3.799073864722288*^9}, {
   3.79907630535458*^9, 3.799076416466851*^9}, {3.799076455875969*^9, 
   3.799076483489502*^9}, {3.799076536842605*^9, 3.799076560438764*^9}, {
   3.799076832269054*^9, 3.799076977762741*^9}, 
   3.7990771878157578`*^9},ExpressionUUID->"de096252-7a9b-46f7-8698-\
6a725b918ddf"]
},
WindowSize->{1377, 1143},
WindowMargins->{{124, Automatic}, {117, Automatic}},
Magnification:>2. Inherited,
FrontEndVersion->"12.0 for Linux x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 287, 6, 61, "Input",ExpressionUUID->"2bb75c11-dc9a-4193-9a08-12301d06dfa5"],
Cell[848, 28, 46782, 904, 23030, "Input",ExpressionUUID->"de096252-7a9b-46f7-8698-6a725b918ddf"]
}
]
*)

