(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    227476,       4249]
NotebookOptionsPosition[    225072,       4203]
NotebookOutlinePosition[    225436,       4219]
CellTagsIndexPosition[    225393,       4216]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "\"\<`*\>\"", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearSystemCache", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6544450770169287`*^9, 3.654445077567218*^9}, {
   3.655735296931308*^9, 3.6557352973408623`*^9}, 3.6663826957871513`*^9, 
   3.6666247724311934`*^9, {3.67931758654745*^9, 3.679317607266251*^9}, {
   3.777277460127008*^9, 3.7772774624449263`*^9}},
 CellLabel->
  "In[448]:=",ExpressionUUID->"ced6cdd9-cea4-4ef2-b681-e154a2c5beff"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"On", "[", "Assert", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Deg", "[", 
     RowBox[{"f_", ",", "var_"}], "]"}], ":=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Exponent", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MonomialList", "[", 
           RowBox[{"f", ",", "var", ",", "\"\<DegreeLexicographic\>\""}], 
           "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "var"}], "]"}], "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "var", "]"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "PrinicipalMinors", " ", "gives", " ", "the", " ", "k", " ", "times", " ", 
    "k", " ", "principal", " ", "minors", " ", "of", " ", "matrix", " ", 
    "M"}], "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PrincipalMinors", "[", 
     RowBox[{"M_", ",", "k_", ",", "eps_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "Mtmp", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Mtmp", "=", "M"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Mtmp", "[", 
            RowBox[{"[", 
             RowBox[{"indx", ",", "indx"}], "]"}], "]"}], "=", 
           RowBox[{
            RowBox[{"Mtmp", "[", 
             RowBox[{"[", 
              RowBox[{"indx", ",", "indx"}], "]"}], "]"}], "+", "eps"}]}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"indx", ",", 
            RowBox[{"Length", "[", "Mtmp", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TempT", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{
              RowBox[{"Dimensions", "[", 
               RowBox[{"M", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"IndexSets", "=", 
         RowBox[{"Subsets", "[", 
          RowBox[{"TempT", ",", 
           RowBox[{"{", "k", "}"}]}], "]"}]}], ";", 
        RowBox[{"Result", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "IndexSets", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"Result", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"Result", ",", 
             RowBox[{"Det", "[", 
              RowBox[{"Mtmp", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"IndexSets", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], ",", 
                 RowBox[{"IndexSets", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "]"}], "]"}]}], 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", "Result"}], ")"}]}],
      "]"}]}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
   "MonVec", " ", "returns", " ", "the", " ", "monomials", " ", "up", " ", 
    "to", " ", "degree", " ", "deg", " ", "in", " ", "the", " ", "variables", 
    " ", "ListofVars"}], "*)"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MonVec", "[", 
     RowBox[{"ListofVars_", ",", "deg_"}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"deg", "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", "1", "}"}], "}"}], ",", 
       RowBox[{"deg", "\[Equal]", "1"}], ",", 
       RowBox[{"{", 
        RowBox[{"Union", "[", 
         RowBox[{
          RowBox[{"{", "1", "}"}], ",", 
          RowBox[{"Flatten", "[", "ListofVars", "]"}]}], "]"}], "}"}], ",", 
       RowBox[{"deg", ">", "1"}], ",", 
       RowBox[{"{", 
        RowBox[{"DeleteDuplicates", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"MonVec", "[", 
             RowBox[{"ListofVars", ",", 
              RowBox[{"deg", "-", "1"}]}], "]"}], "]"}], ".", 
           RowBox[{"MonVec", "[", 
            RowBox[{"ListofVars", ",", "1"}], "]"}]}], "]"}], "]"}], "}"}]}], 
      "]"}], ")"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "MultIneq", " ", "returns", " ", "a", " ", "list", " ", "of", " ", 
     "repalcements", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"MultIneqSum", "\[Rule]", "x"}], ",", 
        RowBox[{"NewVarsIneq", "\[Rule]", "y"}], ",", 
        RowBox[{"ListofPosVarsIneq", "\[Rule]", "z"}]}], "}"}], ".", 
      "MultIneqSum"}], " ", "is", " ", "the", " ", "sum", " ", "over", " ", 
     "the", " ", "inequalities", " ", "in", " ", "ListofIneq", " ", "with", 
     " ", "thier", " ", "SOS", " ", "multipliers", " ", "in", " ", 
     RowBox[{"\[CapitalSigma]", "[", "ListofVars", "]"}]}], ",", 
    RowBox[{"whose", " ", "size", " ", "depends", " ", "on", " ", 
     RowBox[{"relaxord", ".", "NewVarsIneq"}], " ", "are", " ", "the", " ", 
     "additional", " ", "variables", " ", "introduced", " ", "by", " ", "the",
      " ", 
     RowBox[{"multipliers", ".", "ListofPosVarsIneq"}], " ", "are", " ", 
     "the", " ", "positive", " ", "variables", " ", "amongst", " ", 
     RowBox[{"them", "."}]}]}], "*)"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultIneq", "[", 
     RowBox[{
     "ListofIneq_", ",", "ListofVars_", ",", "relaxord_", ",", "agent_"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "ListofMultIneq", ",", "ListofMSeq", ",", "inxineq", ",", "ord", ",", 
        "v", ",", "Len", ",", "LTM", ",", "TempM", ",", "TempP", ",", 
        "Summation", ",", "ListofMMats", ",", "TempSeq", ",", 
        "ListofNewVars"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ListofMultIneq", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ListofMMats", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ListofMSeq", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ListofNewVars", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"inxineq", "=", "1"}], ",", 
          RowBox[{"inxineq", "\[LessEqual]", 
           RowBox[{"Length", "[", "ListofIneq", "]"}]}], ",", 
          RowBox[{"inxineq", "++"}], ",", 
          RowBox[{
           RowBox[{"ord", "=", 
            RowBox[{"Ceiling", "[", 
             RowBox[{"relaxord", "-", 
              RowBox[{
               RowBox[{"Deg", "[", 
                RowBox[{
                 RowBox[{"ListofIneq", "[", 
                  RowBox[{"[", "inxineq", "]"}], "]"}], ",", "ListofVars"}], 
                "]"}], "/", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"v", "=", 
            RowBox[{"MonVec", "[", 
             RowBox[{"ListofVars", ",", "ord"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Len", "=", 
            RowBox[{"Length", "[", 
             RowBox[{"v", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"TempM", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Which", "[", 
               RowBox[{
                RowBox[{"i", ">", "j"}], ",", 
                RowBox[{"ToExpression", "[", 
                 RowBox[{"\"\<S\>\"", "<>", 
                  RowBox[{"ToString", "[", "inxineq", "]"}], "<>", 
                  "\"\<T\>\"", "<>", 
                  RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<T\>\"", "<>", 
                  RowBox[{"ToString", "[", "j", "]"}], "<>", "\"\<A\>\"", "<>", 
                  RowBox[{"ToString", "[", "agent", "]"}], "<>", 
                  "\"\<E\>\""}], "]"}], ",", 
                RowBox[{"i", "==", "j"}], ",", 
                RowBox[{"ToExpression", "[", 
                 RowBox[{"\"\<S\>\"", "<>", 
                  RowBox[{"ToString", "[", "inxineq", "]"}], "<>", 
                  "\"\<T\>\"", "<>", 
                  RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<T\>\"", "<>", 
                  RowBox[{"ToString", "[", "j", "]"}], "<>", "\"\<A\>\"", "<>", 
                  RowBox[{"ToString", "[", "agent", "]"}], "<>", 
                  "\"\<E\>\""}], "]"}], ",", 
                RowBox[{"i", "<", "j"}], ",", 
                RowBox[{"ToExpression", "[", 
                 RowBox[{"\"\<S\>\"", "<>", 
                  RowBox[{"ToString", "[", "inxineq", "]"}], "<>", 
                  "\"\<T\>\"", "<>", 
                  RowBox[{"ToString", "[", "j", "]"}], "<>", "\"\<T\>\"", "<>", 
                  RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<A\>\"", "<>", 
                  RowBox[{"ToString", "[", "agent", "]"}], "<>", 
                  "\"\<E\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "Len"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "Len"}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"TempSeq", "=", 
            RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Do", "[", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"TempSeq", ",", 
                 RowBox[{"TempM", "[", 
                  RowBox[{"[", 
                   RowBox[{"j", ",", "i"}], "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "j", ",", "Len"}], "}"}]}], "]"}], 
             "\[IndentingNewLine]", ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "Len"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"ListofMMats", ",", "TempM"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"ListofMSeq", ",", "TempSeq"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ListofNewVars", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"ListofNewVars", ",", 
              RowBox[{"DeleteDuplicates", "[", 
               RowBox[{"Flatten", "[", "TempM", "]"}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"TempP", "=", 
            RowBox[{
             RowBox[{"v", ".", "TempM", ".", 
              RowBox[{"Transpose", "[", "v", "]"}]}], "*", 
             RowBox[{"ListofIneq", "[", 
              RowBox[{"[", "inxineq", "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ListofMultIneq", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"ListofMultIneq", ",", "TempP"}], "]"}]}], ";"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Summation", "=", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"ListofMultIneq", "[", 
            RowBox[{"[", "k", "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "1", ",", 
             RowBox[{"Length", "[", "ListofIneq", "]"}]}], "}"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"MultIneqSum", "\[Rule]", "Summation"}], ",", 
          RowBox[{"ListofNVars", "->", "ListofNewVars"}], ",", 
          RowBox[{"NewMmats", "\[Rule]", "ListofMMats"}], ",", 
          RowBox[{"NewListofMSeq", "->", "ListofMSeq"}]}], "}"}]}], ")"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "This", " ", "function", " ", "collects", " ", "the", " ", "output", " ", 
    "form", " ", "MultIneq", " ", "and", " ", "MultEq", " ", "and", " ", 
    "generates", " ", "the", " ", "equations", " ", "of", " ", "the", " ", 
    "Putinar", " ", 
    RowBox[{"relaxation", ".", "It"}], " ", "returns", " ", "a", " ", "list", 
    " ", "of", " ", "equations", " ", "and", " ", "inequalities", " ", 
    "that"}], "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"GenEqIneq", "[", 
     RowBox[{
     "IneqCurrentPlayer_", ",", "VarsCurrentPlayer_", ",", 
      "objectivefuncnum_", ",", "objectivefuncden_", ",", "relaxord_", ",", 
      "agent_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "L1", ",", "L2", ",", "S2", ",", "ListofVarsN", ",", "ListofPosVarsN", 
        ",", "S1", ",", "Coefflist"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"L1", "=", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "MultIneqSum", ",", "ListofNVars", ",", "NewMmats", ",", 
            "NewListofMSeq"}], "}"}], "/.", 
          RowBox[{"MultIneq", "[", 
           RowBox[{
            RowBox[{"Union", "[", 
             RowBox[{"IneqCurrentPlayer", ",", 
              RowBox[{"{", "1", "}"}]}], "]"}], ",", "VarsCurrentPlayer", ",",
             "relaxord", ",", "agent"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"S1", "=", 
         RowBox[{"L1", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ListofVarsN", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ListofVarsN", "=", 
         RowBox[{"Union", "[", 
          RowBox[{
           RowBox[{"L1", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"\"\<Rho\>\"", "<>", 
              RowBox[{"ToString", "[", "agent", "]"}], "<>", "\"\<E\>\""}], 
             "]"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "Putinar", " ", "representation", " ", "of", " ", "optimization", 
          " ", "problem"}], "*)"}], 
        RowBox[{"Coefflist", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"CoefficientList", "[", 
              RowBox[{
               RowBox[{"objectivefuncnum", "-", 
                RowBox[{
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<Rho\>\"", "<>", 
                   RowBox[{"ToString", "[", "agent", "]"}], "<>", 
                   "\"\<E\>\""}], "]"}], "*", "objectivefuncden"}], "+", 
                "S1"}], ",", "VarsCurrentPlayer"}], "]"}], "]"}], "]"}], ",", 
           
           RowBox[{"{", "0", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListofVarsPl", "\[Rule]", "ListofVarsN"}], ",", 
          RowBox[{"ListofMmats", "\[Rule]", 
           RowBox[{"L1", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], ",", 
          RowBox[{"ListofMSeq", "\[Rule]", 
           RowBox[{"L1", "[", 
            RowBox[{"[", "4", "]"}], "]"}]}], ",", 
          RowBox[{"ListofEqPl", "\[Rule]", "Coefflist"}], ",", 
          RowBox[{"ListofIneqPl", "\[Rule]", 
           RowBox[{"{", "}"}]}]}], "}"}]}], "\[IndentingNewLine]", ")"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"relaxord", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nshocks", "=", "2"}], ";"}], "\[IndentingNewLine]", 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nagents", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lowerconsumption", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"lowertransfer", "=", "0."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lowerlabor", "=", 
   RowBox[{"(", "0.", ")"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"upperlabor", "=", "0.9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"upperconsumption", "=", "10.0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"upperlongrunconsumption", "=", "2.0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uppertransfer", "=", "upperconsumption"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outsidemincon", "=", "0.1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uppermomentval", "=", "1000."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lowermomentval", "=", 
    RowBox[{"-", "1000."}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"parameterssub", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"cmin", "\[Rule]", "0.0001"}], ",", 
      RowBox[{"sigma", "\[Rule]", "0.5"}], ",", 
      RowBox[{"psi", "\[Rule]", "2"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"continuous", " ", "states"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListofContStateVars", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ToExpression", "[", 
       RowBox[{"\"\<currentutilpromise\>\"", "<>", 
        RowBox[{"ToString", "[", "indxa", "]"}], "<>", "\"\<EN\>\""}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LBstate", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"loweragentutil", "[", "indxa", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UBstate", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"upperagentutil", "[", "indxa", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ncontstates", "=", 
    RowBox[{"Length", "[", "ListofContStateVars", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{"ncontstates", "\[Equal]", 
      RowBox[{"Length", "[", "UBstate", "]"}]}], "&&", 
     RowBox[{"ncontstates", "\[Equal]", 
      RowBox[{"Length", "[", "LBstate", "]"}]}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"continuous", " ", "agent", " ", "states"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"consumptionvec", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ToExpression", "[", 
      RowBox[{"\"\<consumption\>\"", "<>", 
       RowBox[{"ToString", "[", "indxa", "]"}], "<>", "\"\<EN\>\""}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lowerconsumvec", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"lowerconsumption", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"upperconsumvec", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"upperconsumption", ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"upperlongrunconsumvec", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"upperlongrunconsumption", ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"continuation", "=", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"ToExpression", "[", 
        RowBox[{"\"\<continuationA\>\"", "<>", 
         RowBox[{"ToString", "[", "indxa", "]"}], "<>", "\"\<S\>\"", "<>", 
         RowBox[{"ToString", "[", "indxs2", "]"}], "<>", "\"\<EN\>\""}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Nextstate", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"continuation", "[", 
       RowBox[{"[", 
        RowBox[{"indx", ",", "indx2"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"indx", ",", "nagents"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"indx2", ",", "nshocks"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lowercontinuationvec", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"LBstate", "[", 
        RowBox[{"[", "indxa", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"uppercontinuationvec", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"UBstate", "[", 
         RowBox[{"[", "indxa", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "aggregated", " ", "actions", " ", "of", " ", "agents", " ", "without", 
    " ", "agent", " ", "indxa"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"otheragentaggregvec", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ToExpression", "[", 
      RowBox[{"\"\<otheragag\>\"", "<>", 
       RowBox[{"ToString", "[", "indxa", "]"}], "<>", "\"\<EN\>\""}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"loweragagvec", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"loweragag", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"upperagagvec", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"upperagag", ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListofAgentStateVars", "=", "\[IndentingNewLine]", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"consumptionvec", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}], ",", 
           RowBox[{"otheragentaggregvec", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"continuation", "[", 
            RowBox[{"[", 
             RowBox[{"indxa", ",", "indxs2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}]}], "]"}], ",", 
       
       RowBox[{"{", 
        RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LBagentstate", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lowerconsumvec", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}], ",", 
          RowBox[{"loweragagvec", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"lowercontinuationvec", "[", 
           RowBox[{"[", 
            RowBox[{"indxa", ",", "indxs2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UBagentstate", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"upperconsumption", ",", 
           RowBox[{"upperagagvec", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"uppercontinuationvec", "[", 
            RowBox[{"[", 
             RowBox[{"indxa", ",", "indxs2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}]}], "]"}], ",", 
       
       RowBox[{"{", 
        RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Dimensions", "[", "ListofAgentStateVars", "]"}], "\[Equal]", 
      RowBox[{"Dimensions", "[", "LBagentstate", "]"}]}], "&&", 
     RowBox[{
      RowBox[{"Dimensions", "[", "ListofAgentStateVars", "]"}], "\[Equal]", 
      RowBox[{"Dimensions", "[", "UBagentstate", "]"}]}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"variables", " ", "and", " ", "bounds"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"aactionvec", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ToExpression", "[", 
       RowBox[{"\"\<aaction\>\"", "<>", 
        RowBox[{"ToString", "[", "indxa", "]"}], "<>", "\"\<EN\>\""}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofAgentVars", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"aactionvec", "[", 
      RowBox[{"[", "indxa", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LBAgentvars", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"lowerlabor", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UBAgentvars", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"upperlabor", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Assert", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "ListofAgentVars", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "LBAgentvars", "]"}]}], "&&", 
    RowBox[{
     RowBox[{"Length", "[", "ListofAgentVars", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "UBAgentvars", "]"}]}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VarsbyAgent", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"consumptionvec", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}], ",", 
          RowBox[{"aactionvec", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"continuation", "[", 
           RowBox[{"[", 
            RowBox[{"indxa", ",", "indxs2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"indxs2", ",", "nshocks"}], "}"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";", 
   RowBox[{"(*", 
    RowBox[{
    "vars", " ", "that", " ", "need", " ", "to", " ", "be", " ", "set", " ", 
     "to", " ", "zero", " ", "at", " ", "the", " ", "boundary", " ", "of", 
     " ", "the", " ", "promise", " ", "space"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"utility", " ", "functions"}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"utilityprinc", "[", "x_", "]"}], ":=", "x"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"probdist", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x", "^", "3"}], "+", 
      RowBox[{"y", "^", "3"}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SigMat", "[", 
     RowBox[{"eff_", ",", "others_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"probdist", "[", 
          RowBox[{"eff", ",", "others"}], "]"}]}], ",", 
        RowBox[{"probdist", "[", 
         RowBox[{"eff", ",", "others"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"probdist", "[", 
          RowBox[{"eff", ",", "others"}], "]"}]}], ",", 
        RowBox[{"probdist", "[", 
         RowBox[{"eff", ",", "others"}], "]"}]}], "}"}]}], "}"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"loweragag", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"nagents", "-", "1"}], ")"}], "lowerlabor"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"upperagag", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"nagents", "-", "1"}], ")"}], "upperlabor"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Uconsumption", "[", "c_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c", "+", "cmin"}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"1.", "-", "sigma"}], ")"}]}], "-", 
   RowBox[{
    RowBox[{"(", "cmin", ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"1.", "-", "sigma"}], ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Uinv", "[", "util_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"util", "+", 
        RowBox[{
         RowBox[{"(", "cmin", ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"1.", "-", "sigma"}], ")"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"1.", "-", "sigma"}], ")"}]}], ")"}]}], "-", "cmin"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ulabor", "[", "a_", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", "a", ")"}], "^", "psi"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Uagent", "[", 
     RowBox[{"agent_", ",", "c_", ",", "a_"}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Uconsumption", "[", "c", "]"}], "-", 
      RowBox[{"Ulabor", "[", "a", "]"}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"loweragentutil", "[", "indxa", "]"}], "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Uagent", "[", 
           RowBox[{"indxa", ",", "outsidemincon", ",", "lowerlabor"}], "]"}], 
          "/", 
          RowBox[{"(", 
           RowBox[{"1.", "-", "beta"}], ")"}]}], ")"}], "/.", 
        "parameterssub"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"upperagentutil", "[", "indxa", "]"}], "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Uagent", "[", 
           RowBox[{"indxa", ",", 
            RowBox[{"upperlongrunconsumvec", "[", 
             RowBox[{"[", "indxa", "]"}], "]"}], ",", "lowerlabor"}], "]"}], 
          "/", 
          RowBox[{"(", 
           RowBox[{"1.", "-", "beta"}], ")"}]}], ")"}], "/.", 
        "parameterssub"}]}], ";"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Eutilityagent", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Uagent", "[", 
        RowBox[{"indxa", ",", 
         RowBox[{"consumptionvec", "[", 
          RowBox[{"[", "indxa", "]"}], "]"}], ",", 
         RowBox[{"aactionvec", "[", 
          RowBox[{"[", "indxa", "]"}], "]"}]}], "]"}], "+", 
       RowBox[{"beta", "*", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"SigMat", "[", 
             RowBox[{
              RowBox[{"aactionvec", "[", 
               RowBox[{"[", "indxa", "]"}], "]"}], ",", 
              RowBox[{"otheragentaggregvec", "[", 
               RowBox[{"[", "indxa", "]"}], "]"}]}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "indx"}], "]"}], "]"}], "*", 
           RowBox[{"continuation", "[", 
            RowBox[{"[", 
             RowBox[{"indxa", ",", "indx"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"indx", ",", "nshocks"}], "}"}]}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofPrincVars", "=", "ListofAgentStateVars"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LBPrincvars", "=", "LBagentstate"}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"UBPrincvars", "=", "UBagentstate"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sublst", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"sublst", "[", 
        RowBox[{"[", "indxa", "]"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"sublst", "[", 
          RowBox[{"[", "indxa", "]"}], "]"}], ",", 
         RowBox[{"GenEqIneq", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"lowerlabor", "-", 
               RowBox[{"aactionvec", "[", 
                RowBox[{"[", "indxa", "]"}], "]"}]}], ")"}], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"aactionvec", "[", 
                RowBox[{"[", "indxa", "]"}], "]"}], "-", "upperlabor"}], 
              ")"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"aactionvec", "[", 
             RowBox[{"[", "indxa", "]"}], "]"}], "}"}], ",", 
           RowBox[{"Eutilityagent", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}], ",", "1", ",", "relaxord", 
           ",", "indxa"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "Variables", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tmplst", "=", 
       RowBox[{"ListofVarsPl", "/.", 
        RowBox[{"sublst", "[", 
         RowBox[{"[", "indxa", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"upb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"uppermomentval", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "tmplst", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"lpb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"lowermomentval", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "tmplst", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ListofPrincVars", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"ListofPrincVars", ",", "tmplst"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LBPrincvars", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"LBPrincvars", ",", "lpb"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"UBPrincvars", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"UBPrincvars", ",", "upb"}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Assert", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "ListofPrincVars", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "LBPrincvars", "]"}]}], "&&", 
    RowBox[{
     RowBox[{"Length", "[", "ListofPrincVars", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "UBPrincvars", "]"}]}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofVars", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"ListofAgentVars", ",", "ListofPrincVars"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"noagentvars", "=", 
   RowBox[{"Length", "[", "ListofAgentVars", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nvars", "=", 
    RowBox[{"Length", "[", "ListofVars", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LBvars", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"LBAgentvars", ",", "LBPrincvars"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UBvars", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"UBAgentvars", ",", "UBPrincvars"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "LBvars", "]"}], "\[Equal]", "nvars"}], "&&", 
     RowBox[{
      RowBox[{"Length", "[", "UBvars", "]"}], "\[Equal]", "nvars"}]}], "]"}], 
   ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"state", " ", "dynamics"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofStateDynamicVars", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Nextstate", "[", 
      RowBox[{"[", 
       RowBox[{"indx", ",", "All"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "nshocks"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListofStateDynamicIndex", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{"ListofVars", ",", 
           RowBox[{"Nextstate", "[", 
            RowBox[{"[", 
             RowBox[{"indxs2", ",", "indx"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"indxs2", ",", "ncontstates"}], "}"}]}], "]"}], "]"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"indx", ",", "nshocks"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"principalutilityU", "=", 
    RowBox[{"utilityprinc", "[", 
     RowBox[{
      RowBox[{"outcomes", "[", "stateUSin", "]"}], "-", 
      RowBox[{"(", 
       RowBox[{"Total", "[", "consumptionvec", "]"}], ")"}]}], "]"}]}], ";"}],
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"principalutility", "=", 
    RowBox[{"principalutilityU", "+", 
     RowBox[{"beta", "*", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Prob", "[", "indx", "]"}], "*", 
         RowBox[{"Vp", "@@", 
          RowBox[{"Nextstate", "[", 
           RowBox[{"[", "indx", "]"}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "nshocks"}], "}"}]}], "]"}]}]}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"constraints", " ", "functions"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"promisekeeping", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ToExpression", "[", 
        RowBox[{"\"\<Rho\>\"", "<>", 
         RowBox[{"ToString", "[", "indxa", "]"}], "<>", "\"\<E\>\""}], "]"}], 
       "-", 
       RowBox[{"ListofContStateVars", "[", 
        RowBox[{"[", "indxa", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofEqPrinc", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"otheragentaggregvec", "[", 
       RowBox[{"[", "indxa", "]"}], "]"}], "-", 
      RowBox[{"Total", "[", "aactionvec", "]"}], "+", 
      RowBox[{"aactionvec", "[", 
       RowBox[{"[", "indxa", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofEqAgent", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofMats", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofSeq", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofIneqPrinc", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", "-", 
     RowBox[{"probdist", "[", 
      RowBox[{
       RowBox[{"aactionvec", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"otheragentaggregvec", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListofIneqAgent", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"tmplst", "=", 
       RowBox[{"ListofEqPl", "/.", 
        RowBox[{"sublst", "[", 
         RowBox[{"[", "indxa", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ListofEqPrinc", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"ListofEqPrinc", ",", 
         RowBox[{"{", 
          RowBox[{"promisekeeping", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}], "}"}], ",", "tmplst"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ListofEqAgent", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"tmplst", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"ListofMmats", "/.", 
         RowBox[{"sublst", "[", 
          RowBox[{"[", "indxa", "]"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListofMats", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"ListofMats", ",", 
         RowBox[{"ListofMmats", "/.", 
          RowBox[{"sublst", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmplst", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"ListofMSeq", "/.", 
         RowBox[{"sublst", "[", 
          RowBox[{"[", "indxa", "]"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListofSeq", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"ListofSeq", ",", 
         RowBox[{"ListofMSeq", "/.", 
          RowBox[{"sublst", "[", 
           RowBox[{"[", "indxa", "]"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"tmplst", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"ListofIneqPl", "/.", 
         RowBox[{"sublst", "[", 
          RowBox[{"[", "indxa", "]"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListofPrincM", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"AppendTo", "[", 
             RowBox[{"ListofPrincM", ",", 
              RowBox[{"PrincipalMinors", "[", 
               RowBox[{
                RowBox[{"ListofMats", "[", 
                 RowBox[{"[", "indx", "]"}], "]"}], ",", "indxin", ",", 
                "epsmat"}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"indxin", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"ListofMats", "[", 
               RowBox[{"[", "indx", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
         ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", 
          RowBox[{"Length", "[", "ListofMats", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListofIneqPrinc", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"ListofIneqPrinc", ",", "tmplst", ",", 
         RowBox[{"Flatten", "[", "ListofPrincM", "]"}]}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"noagentconstraints", " ", "=", 
    RowBox[{
     RowBox[{"Length", "[", "ListofIneqAgent", "]"}], "+", 
     RowBox[{"Length", "[", "ListofEqAgent", "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofEq", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"ListofEqAgent", ",", "ListofEqPrinc", ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ListofContStateVars", "[", 
         RowBox[{"[", "indxa", "]"}], "]"}], "-", 
        RowBox[{"Eutilityagent", "[", 
         RowBox[{"[", "indxa", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofIneq", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"ListofIneqAgent", ",", "ListofIneqPrinc"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VarsbyAgentpos", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"ListofVars", ",", 
          RowBox[{"VarsbyAgent", "[", 
           RowBox[{"[", 
            RowBox[{"indxa", ",", "indxv"}], "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indxv", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"VarsbyAgent", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.6544409250947657`*^9, 3.6544409734227953`*^9}, {
   3.6544410144469223`*^9, 3.654441115715564*^9}, {3.654445075233767*^9, 
   3.654445079743325*^9}, {3.654446294502448*^9, 3.654446368068095*^9}, {
   3.65445041314697*^9, 3.654450470200576*^9}, {3.654451350035762*^9, 
   3.654451410996511*^9}, {3.654451441083806*^9, 3.654451507368476*^9}, {
   3.6544518116152487`*^9, 3.654451847636984*^9}, {3.654451879262205*^9, 
   3.654451959973729*^9}, {3.654451995940658*^9, 3.654452000778598*^9}, {
   3.654452043799262*^9, 3.654452070519017*^9}, {3.654452147017791*^9, 
   3.654452190091302*^9}, {3.654452288758945*^9, 3.654452289846471*^9}, {
   3.654452595306117*^9, 3.654452595901387*^9}, {3.6544526274665937`*^9, 
   3.654452740960292*^9}, {3.654453807664064*^9, 3.654453973165852*^9}, 
   3.6544540123609123`*^9, {3.654454060403069*^9, 3.654454132995524*^9}, {
   3.6544549963345346`*^9, 3.65445500798081*^9}, 3.65445511197892*^9, {
   3.654460074771717*^9, 3.654460078512689*^9}, {3.654460247054359*^9, 
   3.654460250518911*^9}, {3.6544616428078814`*^9, 3.6544616492139874`*^9}, 
   3.6546132556021776`*^9, {3.6548613852221622`*^9, 3.654861480668332*^9}, {
   3.654883855717395*^9, 3.654883886919112*^9}, {3.654883978658173*^9, 
   3.654883985400238*^9}, {3.654888835224337*^9, 3.654888841982855*^9}, {
   3.654888886689806*^9, 3.654888893610799*^9}, {3.6549020725775857`*^9, 
   3.654902132001587*^9}, {3.654902371433601*^9, 3.654902426126623*^9}, {
   3.654902470519638*^9, 3.654902478527642*^9}, {3.654902585198639*^9, 
   3.6549026052986417`*^9}, {3.654902653562645*^9, 3.6549026536566453`*^9}, 
   3.654949248538973*^9, {3.654949288505146*^9, 3.654949332758762*^9}, 
   3.6549493996856318`*^9, {3.654949712182291*^9, 3.654949722432995*^9}, {
   3.654950036917951*^9, 3.654950038533908*^9}, 3.6549504948960114`*^9, {
   3.65495181417769*^9, 3.6549518747399893`*^9}, {3.6549519270218773`*^9, 
   3.6549519598552094`*^9}, {3.654952010697194*^9, 3.6549520150093203`*^9}, {
   3.6549521336551247`*^9, 3.654952191040197*^9}, 3.6549522798756123`*^9, {
   3.654952353438698*^9, 3.654952401447701*^9}, {3.654952447490664*^9, 
   3.654952484371131*^9}, 3.654952520029929*^9, {3.654957764186132*^9, 
   3.654957772481241*^9}, 3.654958570170106*^9, 3.654964495457591*^9, {
   3.654964527923617*^9, 3.654964613564633*^9}, {3.6549661938204412`*^9, 
   3.6549663393136463`*^9}, {3.654966580266096*^9, 3.654966602393415*^9}, {
   3.654966679789974*^9, 3.6549668102185173`*^9}, {3.654967342482338*^9, 
   3.654967369450646*^9}, {3.65496740240173*^9, 3.654967450146536*^9}, {
   3.6549784654630537`*^9, 3.654978516531575*^9}, {3.654979516424478*^9, 
   3.654979524997889*^9}, {3.6549796022398252`*^9, 3.654979728882175*^9}, {
   3.654979780758082*^9, 3.6549798146461277`*^9}, 3.6549800088960943`*^9, {
   3.654980116852178*^9, 3.654980196969624*^9}, {3.654980239972145*^9, 
   3.654980243760788*^9}, {3.654980377796852*^9, 3.6549804002571793`*^9}, 
   3.654980870498466*^9, {3.655041625575646*^9, 3.655041667662716*^9}, {
   3.655041711728589*^9, 3.6550417893635406`*^9}, {3.655041823951223*^9, 
   3.65504203954487*^9}, {3.655043258277049*^9, 3.6550432707047462`*^9}, {
   3.6550455833990088`*^9, 3.65504558486196*^9}, {3.655057660842276*^9, 
   3.655057671674284*^9}, {3.655057717147037*^9, 3.655057744533265*^9}, {
   3.655057780308468*^9, 3.65505780208607*^9}, {3.655057878185342*^9, 
   3.6550578782107773`*^9}, {3.6550579417775507`*^9, 3.655057949631001*^9}, {
   3.6550586361367826`*^9, 3.655058698160795*^9}, {3.6550587669164143`*^9, 
   3.6550587798832006`*^9}, {3.655058934922413*^9, 3.655058940962859*^9}, 
   3.65505906795297*^9, {3.6554042322333937`*^9, 3.655404268515394*^9}, 
   3.6554043817474027`*^9, {3.6554057914864945`*^9, 3.6554058009144955`*^9}, {
   3.655412465719987*^9, 3.6554124699849906`*^9}, {3.655412514773994*^9, 
   3.655412541282996*^9}, {3.655426645539649*^9, 3.655426648416649*^9}, {
   3.6556609095502768`*^9, 3.6556609380295153`*^9}, {3.655661302216823*^9, 
   3.655661450684963*^9}, 3.655661483322115*^9, {3.655661561550797*^9, 
   3.6556615622348557`*^9}, {3.655661597955711*^9, 3.6556616163593693`*^9}, {
   3.655680979909278*^9, 3.655680983277279*^9}, {3.6556812020056734`*^9, 
   3.6556812083582497`*^9}, {3.655681704942252*^9, 3.6556817109232497`*^9}, {
   3.655681761675254*^9, 3.6556817634442506`*^9}, 3.655681932588781*^9, {
   3.655682196809782*^9, 3.6556822883047824`*^9}, 3.655682354738783*^9, {
   3.6556828821418285`*^9, 3.655682887338828*^9}, 3.655687581975789*^9, {
   3.655687629627794*^9, 3.655687712703924*^9}, {3.655728378742003*^9, 
   3.655728379366827*^9}, {3.655728963077827*^9, 3.6557289640079317`*^9}, {
   3.655729068395742*^9, 3.655729081227166*^9}, {3.655730131052256*^9, 
   3.655730131218199*^9}, {3.6557331578833933`*^9, 3.6557331670734987`*^9}, {
   3.6557334535207233`*^9, 3.655733457983088*^9}, {3.6557337629537077`*^9, 
   3.655733773185658*^9}, 3.65573546492717*^9, 3.655735981611689*^9, {
   3.655736213363048*^9, 3.655736273877336*^9}, {3.655736378809211*^9, 
   3.655736382646139*^9}, {3.655736570671447*^9, 3.655736570937729*^9}, {
   3.655756767638937*^9, 3.6557567822220383`*^9}, {3.65575682093003*^9, 
   3.655756858939345*^9}, {3.6557569077087317`*^9, 3.65575692861697*^9}, {
   3.655756959527362*^9, 3.655756971502672*^9}, {3.655757014615741*^9, 
   3.655757037188549*^9}, {3.655757248684635*^9, 3.655757249189691*^9}, {
   3.6557581024366007`*^9, 3.6557582054332*^9}, {3.655758289028564*^9, 
   3.6557582910387774`*^9}, {3.6557703028320932`*^9, 
   3.6557703312573614`*^9}, {3.6557703878971148`*^9, 3.65577041222789*^9}, {
   3.655770507843734*^9, 3.6557705347843776`*^9}, {3.6558251535930977`*^9, 
   3.6558252364748363`*^9}, {3.6558273922963963`*^9, 3.655827409036475*^9}, {
   3.655834256514324*^9, 3.655834261561359*^9}, {3.6558554820483027`*^9, 
   3.6558555107983027`*^9}, 3.655902970292062*^9, {3.655918424434437*^9, 
   3.655918460192438*^9}, 3.655918597364437*^9, 3.6559213685821676`*^9, 
   3.6559214105791683`*^9, {3.6559274092383614`*^9, 3.655927500991356*^9}, {
   3.6559363032335434`*^9, 3.655936311524541*^9}, {3.656018645506837*^9, 
   3.656018666858837*^9}, {3.6560187187258396`*^9, 3.656018748092842*^9}, {
   3.65601878377684*^9, 3.656018814256837*^9}, {3.656018850143838*^9, 
   3.6560189467118397`*^9}, {3.656018981257842*^9, 3.656019015310832*^9}, {
   3.65601908618183*^9, 3.6560191675908337`*^9}, {3.656031055561102*^9, 
   3.656031061643101*^9}, 3.656031102318101*^9, 3.656031173641105*^9, {
   3.656031284110104*^9, 3.6560312985391016`*^9}, 3.6560314292281017`*^9, 
   3.6560315156391015`*^9, {3.656032103885623*^9, 3.656032133425623*^9}, {
   3.6560322459066515`*^9, 3.656032247100653*^9}, 3.656079874925416*^9, {
   3.6560855849155283`*^9, 3.656085586760901*^9}, {3.656092639696776*^9, 
   3.6560927085247393`*^9}, {3.656094052762156*^9, 3.656094057727889*^9}, 
   3.6561165189216056`*^9, {3.65612002861133*^9, 3.6561200295203295`*^9}, {
   3.656165498877757*^9, 3.656165509821459*^9}, {3.656178450704172*^9, 
   3.656178458871098*^9}, 3.656178864439578*^9, {3.656180699400906*^9, 
   3.656180710756708*^9}, {3.656182150515965*^9, 3.656182194983488*^9}, {
   3.656182550086588*^9, 3.65618256383558*^9}, 3.656182664661023*^9, 
   3.656182850687191*^9, 3.656246714872766*^9, 3.656246809627934*^9, {
   3.6562712039964457`*^9, 3.6562712151478167`*^9}, {3.656271279412887*^9, 
   3.656271411665676*^9}, {3.656271465227536*^9, 3.656271466004999*^9}, {
   3.656271529048176*^9, 3.65627156723906*^9}, {3.656271631230789*^9, 
   3.656271639603671*^9}, 3.6562718390742397`*^9, {3.656272932198148*^9, 
   3.6562729857259274`*^9}, {3.656273041075227*^9, 3.6562730816352987`*^9}, {
   3.656277824594982*^9, 3.65627783871043*^9}, {3.656278048610874*^9, 
   3.656278067269821*^9}, 3.6562782736081257`*^9, {3.65629487376392*^9, 
   3.6562948757069206`*^9}, {3.6562950167045145`*^9, 
   3.6562950169975157`*^9}, {3.656295047718515*^9, 3.656295070627513*^9}, 
   3.656360132828603*^9, {3.6563601692944202`*^9, 3.656360212623777*^9}, {
   3.656360249048944*^9, 3.65636026596775*^9}, {3.6563603088494062`*^9, 
   3.6563603493644543`*^9}, {3.65636131372585*^9, 3.6563614952641163`*^9}, {
   3.656361874115122*^9, 3.6563618893506823`*^9}, {3.656361928123554*^9, 
   3.656362045349842*^9}, {3.6563718806110697`*^9, 3.656371919684074*^9}, {
   3.656372110287069*^9, 3.6563721139480715`*^9}, {3.656373036681772*^9, 
   3.656373040429776*^9}, 3.65642454276011*^9, 3.6564258290857773`*^9, {
   3.656444281348731*^9, 3.656444320388792*^9}, 3.6564443542342167`*^9, {
   3.656444540328191*^9, 3.6564445440444527`*^9}, {3.656444594585898*^9, 
   3.656444604575564*^9}, 3.656444681963995*^9, {3.656445075179738*^9, 
   3.656445075761491*^9}, {3.656445388920258*^9, 3.656445417536398*^9}, {
   3.6565345890211873`*^9, 3.6565346819861875`*^9}, {3.6565347203191876`*^9, 
   3.656534806232187*^9}, 3.656609215759948*^9, {3.6566980915211983`*^9, 
   3.656698133009981*^9}, 3.656699981172552*^9, {3.656701011366679*^9, 
   3.656701028733576*^9}, {3.656704002896762*^9, 3.656704003322794*^9}, {
   3.656704560831588*^9, 3.6567045614780807`*^9}, {3.6567073407499437`*^9, 
   3.656707447378718*^9}, {3.656708574205476*^9, 3.6567085792110662`*^9}, {
   3.65677491981981*^9, 3.656774928458465*^9}, {3.656774961387898*^9, 
   3.6567751404493713`*^9}, {3.656775398404743*^9, 3.656775504359262*^9}, {
   3.6567755701950903`*^9, 3.656775573723682*^9}, {3.6567757280801067`*^9, 
   3.656775815434937*^9}, {3.6567760119471493`*^9, 3.6567760156048317`*^9}, {
   3.656776762808885*^9, 3.656776765679167*^9}, {3.656777109813661*^9, 
   3.656777134168915*^9}, {3.6567771911695843`*^9, 3.6567771942145452`*^9}, {
   3.6567948306972637`*^9, 3.656794917136092*^9}, {3.65679617011549*^9, 
   3.6567961804291162`*^9}, 3.656796247520451*^9, {3.656809952956559*^9, 
   3.6568099748405724`*^9}, 3.656810048312599*^9, {3.656810104063607*^9, 
   3.6568101096666155`*^9}, 3.656810150760622*^9, {3.6568104874643717`*^9, 
   3.6568105900104065`*^9}, {3.656810633423421*^9, 3.6568106486894293`*^9}, {
   3.656810695954452*^9, 3.6568107199834538`*^9}, {3.656810812509487*^9, 
   3.656810830757489*^9}, {3.656810866135498*^9, 3.656810896844513*^9}, {
   3.656810930751526*^9, 3.6568109672095385`*^9}, {3.6568110307605953`*^9, 
   3.6568110584606113`*^9}, 3.656811143375634*^9, {3.6568113225796947`*^9, 
   3.656811330165697*^9}, {3.656811712787472*^9, 3.6568117162924747`*^9}, {
   3.656957364666416*^9, 3.6569573914334373`*^9}, {3.6569574727184343`*^9, 
   3.6569574730733147`*^9}, {3.656957601966394*^9, 3.6569576387084217`*^9}, {
   3.656957675749868*^9, 3.656957676915332*^9}, {3.656957709145605*^9, 
   3.656957711153798*^9}, {3.656958482255911*^9, 3.6569585136379347`*^9}, 
   3.65695856549872*^9, {3.656958721267836*^9, 3.656958729803269*^9}, {
   3.6569592818982267`*^9, 3.656959375878381*^9}, 3.656959575042894*^9, {
   3.657047173966771*^9, 3.657047227614812*^9}, {3.657047342925067*^9, 
   3.657047345722211*^9}, {3.65704739735143*^9, 3.6570474097107687`*^9}, {
   3.657311843999606*^9, 3.657311900567316*^9}, {3.658085820947823*^9, 
   3.6580858459862127`*^9}, {3.6638841416667604`*^9, 3.663884142239341*^9}, {
   3.6638844373780117`*^9, 3.6638844377217617`*^9}, {3.6649946841909175`*^9, 
   3.664994702657919*^9}, {3.6649961883551283`*^9, 3.664996189644125*^9}, {
   3.66499626394727*^9, 3.6649962642652707`*^9}, {3.6649963222872844`*^9, 
   3.6649963226832848`*^9}, {3.6649964423853207`*^9, 3.664996472400325*^9}, 
   3.664997764375035*^9, {3.6649987178427615`*^9, 3.6649987192357626`*^9}, {
   3.664998780038779*^9, 3.66499878229478*^9}, {3.665000023231394*^9, 
   3.6650000637487516`*^9}, {3.6650002553778005`*^9, 3.665000278784795*^9}, 
   3.665001355973727*^9, {3.665001584623186*^9, 3.6650016481617208`*^9}, {
   3.6650019127225437`*^9, 3.665001955918665*^9}, {3.6650020373915205`*^9, 
   3.6650020845469065`*^9}, 3.6650024819071608`*^9, {3.6650107827597575`*^9, 
   3.6650107845877557`*^9}, {3.6650112449578753`*^9, 
   3.6650112451968756`*^9}, {3.665011785485013*^9, 3.6650117963050184`*^9}, 
   3.665012522493362*^9, 3.665012784277429*^9, {3.665012836383443*^9, 
   3.665012850582446*^9}, {3.6650129186984634`*^9, 3.6650129306404667`*^9}, 
   3.6650129935854836`*^9, {3.6650132554535503`*^9, 3.6650132618315516`*^9}, 
   3.6650134796446085`*^9, {3.6650135210856194`*^9, 3.6650135223606186`*^9}, {
   3.6650147527159333`*^9, 3.6650147787329407`*^9}, {3.665015232535057*^9, 
   3.6650152334460573`*^9}, 3.665015460735117*^9, {3.6650155496021404`*^9, 
   3.665015550910139*^9}, {3.6650181637868085`*^9, 3.66501819984982*^9}, {
   3.665018447302883*^9, 3.6650184552688856`*^9}, 3.665018898408002*^9, 
   3.6650804726010656`*^9, 3.6650807926881447`*^9, {3.665195398800275*^9, 
   3.665195410647608*^9}, {3.665233343281661*^9, 3.665233345728423*^9}, {
   3.6655102868012342`*^9, 3.665510301001162*^9}, {3.665515858364964*^9, 
   3.665515861050783*^9}, 3.6655159689646463`*^9, 3.665845124814749*^9, 
   3.665845883801133*^9, 3.66610417560672*^9, {3.66610427842703*^9, 
   3.666104294175249*^9}, {3.6662764213534584`*^9, 3.666276450103147*^9}, {
   3.6663826674220133`*^9, 3.666382687897172*^9}, {3.666383273262789*^9, 
   3.666383276511312*^9}, {3.66638564283419*^9, 3.666385656051724*^9}, {
   3.666443475956477*^9, 3.666443484494068*^9}, {3.666444214077115*^9, 
   3.666444214443721*^9}, 3.666444511258848*^9, {3.66644671287954*^9, 
   3.666446720218314*^9}, 3.6664494036111517`*^9, {3.666450567489452*^9, 
   3.666450567647951*^9}, 3.666450735071813*^9, {3.666450780953603*^9, 
   3.666450794607396*^9}, 3.6664509185984983`*^9, {3.6664513074501047`*^9, 
   3.666451322708456*^9}, {3.6664525074546547`*^9, 3.666452507664151*^9}, {
   3.666452548679965*^9, 3.6664525526613407`*^9}, {3.666452776422695*^9, 
   3.6664527769129066`*^9}, {3.6664529942910757`*^9, 3.666453016422635*^9}, 
   3.666453050090966*^9, {3.666460254493812*^9, 3.6664602648688*^9}, {
   3.666465984534548*^9, 3.666466008692327*^9}, {3.666468599274931*^9, 
   3.66646860912423*^9}, {3.66646869466005*^9, 3.666468703698369*^9}, {
   3.666468779749848*^9, 3.666468795055455*^9}, 3.666468829724472*^9, {
   3.666473067697016*^9, 3.666473128602305*^9}, {3.666473177182564*^9, 
   3.666473193413327*^9}, {3.6664732552656193`*^9, 3.666473262712378*^9}, {
   3.666486226603752*^9, 3.66648622723276*^9}, {3.6665319553940487`*^9, 
   3.666531956474757*^9}, {3.66655593057992*^9, 3.666555931219413*^9}, 
   3.6666236577936363`*^9, 3.6666249579499826`*^9, {3.6666435725641203`*^9, 
   3.666643701375688*^9}, {3.66664380780131*^9, 3.666643815790669*^9}, {
   3.6667074136672163`*^9, 3.6667074201939077`*^9}, {3.666709699891224*^9, 
   3.6667097035662327`*^9}, {3.666722633142879*^9, 3.6667226345447063`*^9}, {
   3.666899547623906*^9, 3.6668995485347433`*^9}, {3.6669004512983513`*^9, 
   3.666900564076951*^9}, {3.666962928897726*^9, 3.6669629420353403`*^9}, {
   3.66696302120179*^9, 3.666963033304843*^9}, {3.6669631582519283`*^9, 
   3.666963175302526*^9}, {3.666968179252975*^9, 3.666968216597683*^9}, {
   3.666980855115056*^9, 3.6669808578265676`*^9}, 3.666981919585392*^9, {
   3.66698775489203*^9, 3.666987760041688*^9}, {3.666987805333894*^9, 
   3.666987810941557*^9}, {3.667128856727255*^9, 3.667128882249158*^9}, 
   3.6673040803251667`*^9, {3.667307572544722*^9, 3.667307620392928*^9}, {
   3.667312068754767*^9, 3.667312113431128*^9}, {3.667312437334115*^9, 
   3.667312441013588*^9}, {3.667319220461334*^9, 3.667319225708226*^9}, {
   3.66731988851663*^9, 3.667319926696497*^9}, {3.6673297170096903`*^9, 
   3.667329721895527*^9}, {3.667580028897194*^9, 3.6675800483491583`*^9}, {
   3.667580176142973*^9, 3.667580176458905*^9}, {3.667582789948092*^9, 
   3.667582808283037*^9}, {3.6676482131156683`*^9, 3.667648242488542*^9}, {
   3.667653456223813*^9, 3.667653456382473*^9}, {3.667665547114304*^9, 
   3.6676655475038347`*^9}, {3.667665579279086*^9, 3.667665579664309*^9}, {
   3.6676662361071453`*^9, 3.6676662600986843`*^9}, {3.667690205285183*^9, 
   3.6676902336328487`*^9}, 3.667737914793152*^9, 3.668268762005948*^9, {
   3.6682780249185143`*^9, 3.66827804394704*^9}, {3.668279499701762*^9, 
   3.668279499885098*^9}, {3.6684305712823753`*^9, 3.668430610805917*^9}, {
   3.668431117681344*^9, 3.668431119528954*^9}, {3.668601579836854*^9, 
   3.6686016243337603`*^9}, {3.669039891207288*^9, 3.669039893400547*^9}, {
   3.6690399632591553`*^9, 3.669039992026335*^9}, 3.669040124040894*^9, {
   3.6690410410346603`*^9, 3.6690410412083683`*^9}, {3.6690572394856043`*^9, 
   3.6690572414607677`*^9}, {3.669139208275364*^9, 3.669139249056224*^9}, 
   3.669144097709279*^9, 3.669144433084963*^9, 3.6691444992145433`*^9, {
   3.669146021768196*^9, 3.669146038629964*^9}, {3.6691468795025797`*^9, 
   3.669146881039077*^9}, {3.6691647648299365`*^9, 3.6691647690792823`*^9}, 
   3.669374993597889*^9, {3.6693816601113863`*^9, 3.6693816604557047`*^9}, 
   3.669394691779759*^9, {3.669401159847015*^9, 3.669401188547971*^9}, 
   3.6695584091210213`*^9, {3.66998387265331*^9, 3.669983872939992*^9}, {
   3.669984707960484*^9, 3.66998470879879*^9}, 3.670242816758279*^9, {
   3.670242904040311*^9, 3.670243097681147*^9}, {3.670243170972752*^9, 
   3.670243177379064*^9}, {3.6702433483761797`*^9, 3.670243355841508*^9}, {
   3.6702434077156887`*^9, 3.670243417458612*^9}, 3.6702436060912333`*^9, {
   3.670243747048266*^9, 3.670243755632608*^9}, 3.6702442718805447`*^9, {
   3.6702572846607637`*^9, 3.670257365641458*^9}, {3.670258217849465*^9, 
   3.6702582584869833`*^9}, {3.670258797064334*^9, 3.6702588319739437`*^9}, {
   3.670259198547266*^9, 3.670259213634923*^9}, {3.670259352713544*^9, 
   3.670259356395109*^9}, {3.670259483987455*^9, 3.670259496668247*^9}, {
   3.670259526873498*^9, 3.67025952844483*^9}, {3.670259564185347*^9, 
   3.67025959392231*^9}, 3.670261691216057*^9, {3.670270946471909*^9, 
   3.670270956964476*^9}, {3.6703259088775597`*^9, 3.670326017148847*^9}, {
   3.6703264065216846`*^9, 3.6703264072713203`*^9}, 3.670336557026669*^9, {
   3.670351129886901*^9, 3.670351130060409*^9}, {3.670355477602997*^9, 
   3.670355508274076*^9}, {3.670357053485498*^9, 3.670357093137104*^9}, {
   3.670357149784754*^9, 3.6703572387424088`*^9}, {3.6703574180592213`*^9, 
   3.670357512739068*^9}, {3.670359875120803*^9, 3.670359898433881*^9}, {
   3.670424397383816*^9, 3.6704244041231923`*^9}, {3.6704244720499516`*^9, 
   3.670424483180256*^9}, {3.6704246621471972`*^9, 3.6704246636592264`*^9}, {
   3.6704246957738314`*^9, 3.6704246959614296`*^9}, {3.670501194948164*^9, 
   3.6705012033068743`*^9}, {3.6705012393424797`*^9, 3.670501267034807*^9}, {
   3.67052110558185*^9, 3.6705211277370305`*^9}, {3.6705211656163807`*^9, 
   3.670521176985258*^9}, {3.670521465828684*^9, 3.6705214836591463`*^9}, {
   3.670521516030881*^9, 3.6705215417450285`*^9}, {3.6705215808621693`*^9, 
   3.670521581931938*^9}, {3.6705217627014847`*^9, 3.670521775903427*^9}, 
   3.6705238014649844`*^9, 3.670523843524561*^9, {3.6707043821551113`*^9, 
   3.670704401870614*^9}, 3.6707079046775694`*^9, {3.6707620169594173`*^9, 
   3.6707620474182568`*^9}, {3.670933306661343*^9, 3.6709333373805647`*^9}, {
   3.6712778182012663`*^9, 3.671277841075718*^9}, {3.6712779697559643`*^9, 
   3.6712779736547832`*^9}, {3.671278007086458*^9, 3.671278008147369*^9}, {
   3.671553457989704*^9, 3.671553475673379*^9}, 3.671564697527712*^9, {
   3.671582107093876*^9, 3.6715821218239207`*^9}, {3.6720724905423803`*^9, 
   3.6720725135178547`*^9}, {3.672075120914113*^9, 3.672075122109542*^9}, {
   3.6720751531574306`*^9, 3.672075248180863*^9}, {3.672075667773328*^9, 
   3.672075669175378*^9}, 3.672075778644862*^9, {3.672077930107401*^9, 
   3.672077931099115*^9}, {3.672078079225088*^9, 3.6720780931008368`*^9}, {
   3.672081513148282*^9, 3.672081537150279*^9}, {3.6720816152956448`*^9, 
   3.672081639994935*^9}, {3.6720818794973993`*^9, 3.6720818820042963`*^9}, {
   3.6721405177512827`*^9, 3.672140540230979*^9}, {3.6721430977694597`*^9, 
   3.672143099271894*^9}, {3.672144311455586*^9, 3.67214431286865*^9}, {
   3.672146029995915*^9, 3.672146031378345*^9}, 3.672150910848209*^9, {
   3.672150955415247*^9, 3.672150958924932*^9}, 3.6721565635703993`*^9, 
   3.672160932156619*^9, {3.672169527155707*^9, 3.672169588279603*^9}, {
   3.6722310867953725`*^9, 3.672231116702361*^9}, 3.672317407880517*^9, {
   3.672317471914317*^9, 3.672317479199213*^9}, 3.672317523579851*^9, {
   3.672317616128209*^9, 3.672317633207341*^9}, {3.6723203791610928`*^9, 
   3.672320381481459*^9}, {3.672321738076622*^9, 3.6723217385600176`*^9}, {
   3.6723218125023465`*^9, 3.6723218357632804`*^9}, {3.6723266314408674`*^9, 
   3.6723266389991693`*^9}, {3.672326689969467*^9, 3.672326699192855*^9}, {
   3.672327662830439*^9, 3.672327673988409*^9}, {3.6723278810428395`*^9, 
   3.6723278958114386`*^9}, 3.67232801235616*^9, 3.672328786160348*^9, {
   3.6723429572734222`*^9, 3.6723429732609043`*^9}, 3.67251290631837*^9, {
   3.6725130272417507`*^9, 3.672513062893979*^9}, {3.672513154602244*^9, 
   3.672513158294167*^9}, {3.672513194251183*^9, 3.672513197222042*^9}, 
   3.6725133489763813`*^9, 3.672513422089986*^9, {3.672513540807477*^9, 
   3.672513555092976*^9}, 3.6725729233699293`*^9, {3.67257295675165*^9, 
   3.6725729574822598`*^9}, {3.672573405189938*^9, 3.672573411700145*^9}, 
   3.6725790175047817`*^9, 3.672579723068873*^9, {3.672592138423238*^9, 
   3.672592142353815*^9}, {3.672592184481779*^9, 3.6725922621041*^9}, 
   3.672609997488072*^9, {3.672610407134513*^9, 3.672610407442685*^9}, 
   3.672610554466503*^9, {3.6726106067593546`*^9, 3.6726106075886593`*^9}, 
   3.672746770887186*^9, {3.672746822879388*^9, 3.67274684003514*^9}, 
   3.6727573326126003`*^9, 3.672922096107675*^9, 3.672924021333509*^9, 
   3.6729240792955427`*^9, 3.673026074255866*^9, {3.673035787497121*^9, 
   3.673035807539215*^9}, 3.673036137815894*^9, {3.6731144729162483`*^9, 
   3.673114486251515*^9}, 3.673114541469352*^9, {3.673114578532992*^9, 
   3.673114584647257*^9}, {3.673114686342716*^9, 3.673114687443721*^9}, {
   3.673115322024254*^9, 3.673115322996777*^9}, 3.673115380658777*^9, 
   3.673119373071773*^9, {3.6731994443041887`*^9, 3.673199472394844*^9}, {
   3.673199592454295*^9, 3.673199601333192*^9}, {3.673199688742777*^9, 
   3.673199699978077*^9}, {3.67441606279471*^9, 3.674416111144175*^9}, {
   3.674474280261613*^9, 3.67447433960736*^9}, {3.674474583388316*^9, 
   3.674474635553865*^9}, {3.674475355922696*^9, 3.67447535698201*^9}, {
   3.674477074024935*^9, 3.674477086675848*^9}, 3.6744772008403263`*^9, {
   3.674477250945022*^9, 3.6744772666891212`*^9}, {3.674477297560164*^9, 
   3.674477363886492*^9}, {3.674478515454603*^9, 3.674478585603571*^9}, {
   3.6744803143148947`*^9, 3.6744803164456263`*^9}, {3.674480569966221*^9, 
   3.674480575218775*^9}, {3.674482767214732*^9, 3.674482772846758*^9}, {
   3.674482911745249*^9, 3.674482922047943*^9}, 3.674483480189649*^9, 
   3.674483690074975*^9, {3.674483861538452*^9, 3.6744838825115747`*^9}, 
   3.674484308644558*^9, {3.6744867864443502`*^9, 3.674486793736784*^9}, {
   3.674487945950794*^9, 3.674487949909939*^9}, {3.674488131615698*^9, 
   3.674488159562504*^9}, 3.674488231538536*^9, 3.674488613062389*^9, 
   3.674490107985635*^9, {3.674494812717988*^9, 3.674494879874339*^9}, {
   3.67449561967533*^9, 3.67449563250404*^9}, {3.674501203120761*^9, 
   3.674501241878283*^9}, {3.674503390997239*^9, 3.674503403621876*^9}, {
   3.674503466216277*^9, 3.6745034693466873`*^9}, 3.67450391238588*^9, {
   3.674504317371583*^9, 3.674504336966196*^9}, {3.674505052095421*^9, 
   3.674505057046073*^9}, {3.674505386739799*^9, 3.674505403640579*^9}, 
   3.6745655489650927`*^9, {3.6745656121205997`*^9, 3.674565612425126*^9}, 
   3.6745656439263144`*^9, {3.674565679989403*^9, 3.67456572620782*^9}, {
   3.674565777528458*^9, 3.674565789306097*^9}, 3.674565834571903*^9, {
   3.6745660734786987`*^9, 3.674566081191485*^9}, {3.674566266062129*^9, 
   3.674566267961671*^9}, {3.674566303101914*^9, 3.674566422496683*^9}, 
   3.674566507639545*^9, 3.6745665709284897`*^9, {3.6745666647930183`*^9, 
   3.6745666659291973`*^9}, {3.674566780869274*^9, 3.674566781790113*^9}, {
   3.674567914346827*^9, 3.674567918475649*^9}, {3.674568426429516*^9, 
   3.674568446660591*^9}, 3.674569044173661*^9, {3.674569958860821*^9, 
   3.6745699645734262`*^9}, {3.674570023624816*^9, 3.67457003402721*^9}, 
   3.674570466677833*^9, 3.674571213873165*^9, {3.6745712780379333`*^9, 
   3.674571318042224*^9}, {3.674575775348873*^9, 3.6745758326702967`*^9}, {
   3.6745764870722837`*^9, 3.674576500153008*^9}, {3.674576780802228*^9, 
   3.674576796548945*^9}, {3.674576908627068*^9, 3.674576952686974*^9}, {
   3.674578174899169*^9, 3.6745781767651243`*^9}, {3.674578585880042*^9, 
   3.67457864311477*^9}, {3.674578682622938*^9, 3.67457869143052*^9}, {
   3.674578744473814*^9, 3.67457875600762*^9}, {3.674579021369659*^9, 
   3.6745790282879677`*^9}, {3.6745795806052856`*^9, 3.674579590402362*^9}, 
   3.674591221027112*^9, {3.6745912924040728`*^9, 3.6745912965294952`*^9}, 
   3.674591332050029*^9, {3.674591367966511*^9, 3.67459137372442*^9}, {
   3.6746050262739944`*^9, 3.6746052340162387`*^9}, {3.674655761603865*^9, 
   3.674655762258259*^9}, 3.67465939370277*^9, {3.674818440938951*^9, 
   3.674818445988419*^9}, {3.6748185090409403`*^9, 3.674818580954867*^9}, {
   3.6748189843747*^9, 3.674819042082909*^9}, {3.6748232847301683`*^9, 
   3.674823285999206*^9}, {3.674825793360235*^9, 3.674825794642023*^9}, {
   3.6748260146416607`*^9, 3.6748260193350363`*^9}, {3.674826188519806*^9, 
   3.6748261912948647`*^9}, 3.6748263491565742`*^9, {3.674937303465557*^9, 
   3.674937308151478*^9}, {3.6750874691071978`*^9, 3.6750874716058683`*^9}, {
   3.675087746159554*^9, 3.6750877476724234`*^9}, 3.675211712753961*^9, {
   3.6753047419143476`*^9, 3.675304746070629*^9}, 3.675305401930544*^9, {
   3.675319560326757*^9, 3.675319560995318*^9}, {3.675321096049986*^9, 
   3.675321097562748*^9}, {3.6753212111008673`*^9, 3.675321228382619*^9}, {
   3.675321814785347*^9, 3.675321816992365*^9}, 3.67533391031924*^9, 
   3.675334066572133*^9, 3.675334124958467*^9, {3.6755928743964443`*^9, 
   3.675592874754137*^9}, {3.6755940338260317`*^9, 3.6755940693415833`*^9}, {
   3.6755949495794764`*^9, 3.675594950801564*^9}, {3.6756977354277887`*^9, 
   3.6756977469067383`*^9}, 3.6757404992787733`*^9, 3.676004580166773*^9, {
   3.676009877657589*^9, 3.676009877764669*^9}, {3.6764637693171997`*^9, 
   3.6764637746689825`*^9}, {3.676717801035771*^9, 3.676717833234683*^9}, {
   3.6767182078332043`*^9, 3.676718214742838*^9}, {3.676720184913785*^9, 
   3.676720227296891*^9}, {3.676720411582749*^9, 3.676720432761002*^9}, {
   3.676742424953289*^9, 3.6767424287825108`*^9}, {3.676742698459297*^9, 
   3.6767427640692463`*^9}, {3.6767430598087893`*^9, 
   3.6767431306905746`*^9}, {3.676743638171391*^9, 3.6767436383965178`*^9}, {
   3.676743669631112*^9, 3.676743671978245*^9}, {3.6767438417017603`*^9, 
   3.676743939062365*^9}, {3.67674464874988*^9, 3.6767447360186157`*^9}, {
   3.676746849532687*^9, 3.67674701895634*^9}, {3.676749154078476*^9, 
   3.676749175657915*^9}, {3.6767492725139523`*^9, 3.676749300810422*^9}, 
   3.67674939750504*^9, {3.676749715779045*^9, 3.676749740146825*^9}, {
   3.676751197341467*^9, 3.676751229683009*^9}, {3.6767518133782263`*^9, 
   3.676751889427915*^9}, {3.676751955637471*^9, 3.6767519619509563`*^9}, {
   3.6767582477330217`*^9, 3.6767582496280403`*^9}, {3.6767593317270637`*^9, 
   3.6767593367613983`*^9}, {3.676805316529158*^9, 3.676805331924028*^9}, {
   3.676805533330599*^9, 3.6768055638898687`*^9}, {3.676806290964172*^9, 
   3.676806308019199*^9}, 3.6768076115538607`*^9, {3.6768256411260777`*^9, 
   3.6768257607300787`*^9}, {3.676826621966031*^9, 3.676826623208432*^9}, {
   3.6768266633544807`*^9, 3.676826664057239*^9}, {3.6768269088487587`*^9, 
   3.67682692291998*^9}, {3.6768288693240337`*^9, 3.676828892384741*^9}, {
   3.676830918563222*^9, 3.676830940685853*^9}, {3.67683325209179*^9, 
   3.676833297521096*^9}, {3.676833500829494*^9, 3.6768335015031137`*^9}, {
   3.67683365209931*^9, 3.676833653745085*^9}, 3.676833700790563*^9, {
   3.6768339122056923`*^9, 3.676834069315384*^9}, {3.6768341043154087`*^9, 
   3.676834105789672*^9}, {3.6768345363847113`*^9, 3.676834536741618*^9}, {
   3.676834696176589*^9, 3.6768347020708227`*^9}, {3.676836543577083*^9, 
   3.676836654398036*^9}, {3.6768366963358393`*^9, 3.676836813278646*^9}, {
   3.676836885536007*^9, 3.676836897116065*^9}, {3.6768372250391397`*^9, 
   3.676837229432287*^9}, {3.676839289619388*^9, 3.6768393264708223`*^9}, {
   3.676840146265995*^9, 3.6768401800455914`*^9}, {3.6768402871681213`*^9, 
   3.676840325020689*^9}, {3.676841130770425*^9, 3.676841144515896*^9}, {
   3.676890494402298*^9, 3.67689050128969*^9}, {3.6768905625884542`*^9, 
   3.676890676695578*^9}, {3.6769004725917873`*^9, 3.6769004824176407`*^9}, {
   3.6769007372862186`*^9, 3.6769007466759*^9}, {3.6769008888004007`*^9, 
   3.67690089068524*^9}, {3.676900992277626*^9, 3.676901012937373*^9}, 
   3.676901149923641*^9, {3.67690122156924*^9, 3.676901222250224*^9}, {
   3.676901322337366*^9, 3.676901329099387*^9}, {3.676901417023974*^9, 
   3.6769014177390203`*^9}, {3.676901448188418*^9, 3.6769014488252172`*^9}, 
   3.676901891879724*^9, {3.676901946372774*^9, 3.676901976185792*^9}, {
   3.676915157078494*^9, 3.6769151603271437`*^9}, {3.6769176715613956`*^9, 
   3.676917674503574*^9}, {3.6769219288467283`*^9, 3.676921944350861*^9}, {
   3.6769223918655243`*^9, 3.676922425282954*^9}, {3.676922545324534*^9, 
   3.6769225517545357`*^9}, {3.6769226197623367`*^9, 3.676922628684128*^9}, 
   3.676922680887776*^9, {3.676923116191136*^9, 3.676923126425988*^9}, {
   3.6769233583883038`*^9, 3.676923410593049*^9}, {3.676923538918269*^9, 
   3.676923551759121*^9}, 3.6769242655066957`*^9, 3.6769327707330813`*^9, 
   3.6769808655499487`*^9, {3.676980949013595*^9, 3.676980951504376*^9}, {
   3.676981055937841*^9, 3.676981061260144*^9}, {3.676982579005673*^9, 
   3.6769826233326807`*^9}, {3.676982666313376*^9, 3.676982674274537*^9}, {
   3.6769827104049807`*^9, 3.676982733539154*^9}, {3.67698349143137*^9, 
   3.676983505002836*^9}, {3.6769835673952923`*^9, 3.6769836341685247`*^9}, {
   3.6769838526806927`*^9, 3.676983857664125*^9}, {3.676984042754141*^9, 
   3.676984044823044*^9}, {3.676985152829063*^9, 3.676985168536572*^9}, {
   3.676985898933888*^9, 3.6769859096586018`*^9}, 3.676993347447474*^9, {
   3.6769934036885242`*^9, 3.6769934087829313`*^9}, {3.6769934509532633`*^9, 
   3.6769934527040033`*^9}, 3.676994918998872*^9, 3.676997186995623*^9, 
   3.677000967696612*^9, 3.6770075712534103`*^9, {3.677007859236977*^9, 
   3.677007865893957*^9}, 3.6770114348849287`*^9, 3.6770184355573964`*^9, {
   3.677018543447647*^9, 3.6770185449727554`*^9}, 3.6770185868873825`*^9, {
   3.677018627144105*^9, 3.6770186279908295`*^9}, 3.677018665165584*^9, {
   3.6770187319587603`*^9, 3.677018742202157*^9}, 3.6770187973393393`*^9, {
   3.6770188412102947`*^9, 3.6770188452798243`*^9}, 3.677062950550679*^9, {
   3.6770632680021462`*^9, 3.6770632685611734`*^9}, 3.677066021054966*^9, {
   3.6770661914569874`*^9, 3.6770661919734316`*^9}, 3.6770677228387566`*^9, 
   3.6770677607867346`*^9, {3.677067870465952*^9, 3.677067871900248*^9}, {
   3.677067980884956*^9, 3.677067986677613*^9}, {3.6770684521031437`*^9, 
   3.6770684544955263`*^9}, {3.677068572675465*^9, 3.677068573207279*^9}, 
   3.6770686289734983`*^9, 3.6770686724802427`*^9, {3.6770687148518333`*^9, 
   3.6770687184468117`*^9}, 3.6770688121927123`*^9, 3.677158289677258*^9, {
   3.677243122875242*^9, 3.677243128356783*^9}, {3.677497313108018*^9, 
   3.677497355294594*^9}, {3.677497503167198*^9, 3.677497504519739*^9}, {
   3.677497822485001*^9, 3.677497894437955*^9}, 3.677497949393856*^9, {
   3.6774980252324257`*^9, 3.6774980441513853`*^9}, 3.6774983917533627`*^9, {
   3.677498446284545*^9, 3.6774984475986*^9}, {3.677498527496173*^9, 
   3.677498535194929*^9}, {3.677500939588986*^9, 3.677501009717465*^9}, {
   3.6775014174954853`*^9, 3.67750151131809*^9}, 3.6775016276910763`*^9, {
   3.677501675839581*^9, 3.677501679184173*^9}, {3.677501885287458*^9, 
   3.6775018865205097`*^9}, {3.677501940778698*^9, 3.6775019541635103`*^9}, {
   3.677501993502612*^9, 3.677501995730851*^9}, {3.677502393618286*^9, 
   3.677502443209968*^9}, 3.6775026678675013`*^9, {3.677503049512474*^9, 
   3.677503103592445*^9}, {3.677503159653027*^9, 3.677503177097879*^9}, {
   3.6775070623504467`*^9, 3.6775070648037157`*^9}, {3.677507112882778*^9, 
   3.677507143955432*^9}, {3.677507193674172*^9, 3.6775072076533947`*^9}, {
   3.677507381977747*^9, 3.677507384369927*^9}, {3.677507418962144*^9, 
   3.677507505686618*^9}, {3.677507649019026*^9, 3.677507650399091*^9}, 
   3.677520987687715*^9, 3.677585447671122*^9, {3.67758547873925*^9, 
   3.6775854985724163`*^9}, 3.6775857504177217`*^9, {3.677585848183919*^9, 
   3.677585849655737*^9}, {3.677585992253439*^9, 3.677586001067493*^9}, {
   3.677586246742035*^9, 3.6775862515864887`*^9}, {3.677587247565703*^9, 
   3.677587249548029*^9}, {3.677591694871688*^9, 3.677591697297274*^9}, 
   3.6776113821743183`*^9, {3.67761144857057*^9, 3.677611449482223*^9}, {
   3.677611485767852*^9, 3.677611487501775*^9}, {3.677611532001452*^9, 
   3.677611532892798*^9}, {3.677611585646474*^9, 3.6776115882939177`*^9}, 
   3.6776116408541527`*^9, 3.677611673695314*^9, {3.67761170802311*^9, 
   3.6776117086744347`*^9}, {3.6776153465324697`*^9, 3.677615347918886*^9}, 
   3.6778835744845977`*^9, {3.6779319392982187`*^9, 3.6779319394875937`*^9}, {
   3.67805238965318*^9, 3.6780524435029984`*^9}, 3.6780571706501894`*^9, {
   3.678057393752201*^9, 3.678057394427688*^9}, {3.6780574724388366`*^9, 
   3.678057474287451*^9}, {3.6780575417940845`*^9, 3.678057542637401*^9}, {
   3.678057691678587*^9, 3.6780576923920035`*^9}, 3.6780577868786635`*^9, 
   3.678057820709447*^9, {3.678057924308292*^9, 3.678057925161637*^9}, {
   3.678129676294243*^9, 3.678129677721382*^9}, {3.678188951423135*^9, 
   3.678188974607729*^9}, {3.678189039562602*^9, 3.678189073326515*^9}, {
   3.6781915156822243`*^9, 3.678191542554455*^9}, {3.678191598531251*^9, 
   3.678191603067175*^9}, {3.678191668403439*^9, 3.678191686530643*^9}, {
   3.678191747235273*^9, 3.678191766214037*^9}, {3.6781918521093683`*^9, 
   3.678191863225751*^9}, {3.678191927589074*^9, 3.678191928378839*^9}, 
   3.678192234575614*^9, 3.678192347406549*^9, {3.678192444398765*^9, 
   3.6781924757860394`*^9}, 3.678192507079591*^9, {3.678192569639146*^9, 
   3.678192571639248*^9}, {3.678192620399851*^9, 3.678192621079976*^9}, 
   3.678192746311314*^9, {3.6789705363303547`*^9, 3.6789705616253633`*^9}, {
   3.678970598073762*^9, 3.678970600293047*^9}, 3.6789706909403696`*^9, {
   3.6789707622141314`*^9, 3.6789708041313653`*^9}, {3.6789893370776343`*^9, 
   3.678989338552162*^9}, {3.6789964189259243`*^9, 3.678996426397713*^9}, {
   3.67899749813381*^9, 3.678997507958583*^9}, {3.6789981038610272`*^9, 
   3.6789981041933246`*^9}, {3.6790007657724967`*^9, 3.6790007863748674`*^9}, 
   3.6790014448068876`*^9, 3.6790529240318336`*^9, 3.679075703836755*^9, {
   3.6791024339210196`*^9, 3.6791024426572385`*^9}, 3.679141925889654*^9, 
   3.679146128860064*^9, {3.679146189118256*^9, 3.679146191848049*^9}, {
   3.67914622988799*^9, 3.679146230801506*^9}, {3.679146276445094*^9, 
   3.679146280172792*^9}, {3.67914636384021*^9, 3.679146405770585*^9}, {
   3.6791464932557173`*^9, 3.6791465269700003`*^9}, {3.679156709257657*^9, 
   3.679156714761088*^9}, {3.679316714430574*^9, 3.6793167162410927`*^9}, {
   3.679316785194874*^9, 3.679316789886929*^9}, {3.679317335307646*^9, 
   3.679317364021592*^9}, {3.679317684807385*^9, 3.679317685460928*^9}, 
   3.679319356917696*^9, {3.679331461410412*^9, 3.679331462374858*^9}, {
   3.679331608651194*^9, 3.679331612001812*^9}, 3.679339921972744*^9, {
   3.679422617690125*^9, 3.67942262284881*^9}, {3.679422659160862*^9, 
   3.679422665259609*^9}, {3.679663394726564*^9, 3.679663396453784*^9}, {
   3.6796782529396257`*^9, 3.679678283937331*^9}, {3.679678341540503*^9, 
   3.679678369166901*^9}, {3.6796786348010197`*^9, 3.6796787063741703`*^9}, {
   3.6796844767064543`*^9, 3.679684498057824*^9}, {3.679747457089991*^9, 
   3.6797474808142233`*^9}, 3.679938726780188*^9, {3.6801052807130637`*^9, 
   3.680105291375001*^9}, {3.680105550347142*^9, 3.6801055904905014`*^9}, {
   3.6801070875313272`*^9, 3.6801070892256923`*^9}, {3.6801319349106674`*^9, 
   3.68013194895863*^9}, {3.680524529284171*^9, 3.680524580327553*^9}, {
   3.680549702772368*^9, 3.680549743953185*^9}, {3.680783338404785*^9, 
   3.680783343163166*^9}, {3.680906721712349*^9, 3.6809067287959785`*^9}, {
   3.680906785355186*^9, 3.6809068204912367`*^9}, 3.6809068603711257`*^9, {
   3.680906939471785*^9, 3.6809069415789247`*^9}, {3.68095437007159*^9, 
   3.680954370239352*^9}, {3.680954635904106*^9, 3.680954677460269*^9}, {
   3.680954740170985*^9, 3.680954756261424*^9}, {3.6809554592454967`*^9, 
   3.680955501213772*^9}, 3.6809559572324944`*^9, {3.680957768480299*^9, 
   3.680957769828334*^9}, {3.680960324624963*^9, 3.68096033099354*^9}, {
   3.680975558679069*^9, 3.68097555990661*^9}, {3.680975647121369*^9, 
   3.6809756474296007`*^9}, {3.681058415230318*^9, 3.6810584197603292`*^9}, {
   3.6810584607659397`*^9, 3.681058516441296*^9}, {3.681063775680439*^9, 
   3.681063836232195*^9}, {3.681067382908498*^9, 3.681067467019492*^9}, {
   3.681067540299765*^9, 3.681067603673518*^9}, {3.681068143356575*^9, 
   3.6810681660467787`*^9}, {3.681068224222892*^9, 3.681068239970833*^9}, {
   3.681072093303048*^9, 3.681072224226459*^9}, {3.681127986902697*^9, 
   3.68112801263878*^9}, {3.681128061720244*^9, 3.6811281119715357`*^9}, 
   3.681130237167029*^9, {3.681130340581523*^9, 3.6811303546303596`*^9}, 
   3.681131344034565*^9, {3.681134414460803*^9, 3.6811344815136127`*^9}, {
   3.6811347658919363`*^9, 3.681134801661964*^9}, {3.681134850543273*^9, 
   3.681134912600525*^9}, 3.681135193655077*^9, 3.681135230762905*^9, {
   3.681136053645445*^9, 3.681136060901497*^9}, {3.681149426212574*^9, 
   3.681149464664383*^9}, {3.6811502200704412`*^9, 3.68115022739915*^9}, {
   3.681150261441814*^9, 3.68115032438556*^9}, {3.6811525234136353`*^9, 
   3.681152568636643*^9}, {3.6811536404542923`*^9, 3.6811536686709948`*^9}, {
   3.6811537373582773`*^9, 3.681153767949049*^9}, 3.681154454693203*^9, {
   3.681155097974024*^9, 3.6811552831850767`*^9}, 3.681156747298152*^9, {
   3.6811570404961967`*^9, 3.681157080690916*^9}, {3.681157122736679*^9, 
   3.681157139078845*^9}, {3.6811571985144367`*^9, 3.681157291017478*^9}, {
   3.6811687008600435`*^9, 3.681168706130663*^9}, {3.681171950648218*^9, 
   3.6811719949508233`*^9}, {3.681174079636347*^9, 3.6811741021268415`*^9}, {
   3.681214426856955*^9, 3.681214452937799*^9}, {3.6812145737962112`*^9, 
   3.681214604896832*^9}, {3.681214768979464*^9, 3.681214774450029*^9}, {
   3.6812207548744907`*^9, 3.6812207591427937`*^9}, {3.6813165567757497`*^9, 
   3.6813166130744524`*^9}, {3.681326882696083*^9, 3.681326893227831*^9}, {
   3.681326952516321*^9, 3.681326957966701*^9}, 3.6813269920429425`*^9, 
   3.6813439419781523`*^9, {3.6813887869941363`*^9, 3.6813888018726764`*^9}, {
   3.6814753772412*^9, 3.6814754014507093`*^9}, {3.6814754656150093`*^9, 
   3.681475471369567*^9}, {3.681476533175366*^9, 3.681476540566132*^9}, 
   3.681476912527108*^9, {3.681502701327312*^9, 3.681502727286826*^9}, {
   3.681502787627903*^9, 3.6815027943650923`*^9}, {3.681562313293725*^9, 
   3.681562320938757*^9}, {3.681562363505815*^9, 3.6815623750936317`*^9}, {
   3.681562593336895*^9, 3.681562596568323*^9}, {3.681563537240066*^9, 
   3.681563550506468*^9}, {3.68156358616256*^9, 3.681563597488222*^9}, 
   3.6839197254878397`*^9, {3.683919788597327*^9, 3.6839198194132442`*^9}, {
   3.6839198593068247`*^9, 3.6839198613395023`*^9}, {3.6839199120465918`*^9, 
   3.6839200161581984`*^9}, {3.684778166346057*^9, 3.6847781942811728`*^9}, {
   3.684778364170203*^9, 3.6847784594465933`*^9}, {3.684782725390925*^9, 
   3.684782737492852*^9}, 3.684784094876824*^9, {3.6847842873573523`*^9, 
   3.684784288241427*^9}, 3.6847947005823607`*^9, {3.6848022868760853`*^9, 
   3.6848022944928083`*^9}, 3.6848024347842617`*^9, 3.684802580054804*^9, 
   3.6848029362455626`*^9, {3.6848029970084453`*^9, 3.684802997566717*^9}, 
   3.684803068803011*^9, 3.6848033224283752`*^9, {3.6848033855604267`*^9, 
   3.6848033869842978`*^9}, 3.684840784588031*^9, {3.6848725970112677`*^9, 
   3.6848726054732113`*^9}, {3.684874789690764*^9, 3.6848747937460623`*^9}, 
   3.684878698190635*^9, 3.6848787858625207`*^9, 3.684879791801221*^9, {
   3.684880051946439*^9, 3.6848800541778803`*^9}, {3.68488358524682*^9, 
   3.684883585875762*^9}, {3.684886677913991*^9, 3.684886679254119*^9}, {
   3.685308747391366*^9, 3.6853087538429394`*^9}, {3.6853158361013966`*^9, 
   3.6853158365808*^9}, {3.6854765245033693`*^9, 3.68547653144525*^9}, {
   3.6859872236201963`*^9, 3.6859872521536007`*^9}, 3.686055324703802*^9, {
   3.6860572161853523`*^9, 3.686057238341516*^9}, {3.68605753505891*^9, 
   3.686057555622951*^9}, 3.686060619232757*^9, {3.6863377437962303`*^9, 
   3.686337746270623*^9}, {3.686339044969253*^9, 3.6863390464853477`*^9}, {
   3.686505662030088*^9, 3.686505693902092*^9}, {3.686505738781989*^9, 
   3.686505741637665*^9}, {3.686512898573475*^9, 3.686512901355894*^9}, {
   3.6865803531669416`*^9, 3.686580354697195*^9}, {3.699255621897216*^9, 
   3.699255649626058*^9}, {3.6992557891000977`*^9, 3.6992557920234337`*^9}, {
   3.699272362344844*^9, 3.699272365799533*^9}, 3.699272467287039*^9, 
   3.6994252680881844`*^9, 3.699428304314887*^9, {3.703329515135598*^9, 
   3.703329522506565*^9}, {3.703329578141865*^9, 3.703329578378098*^9}, 
   3.7033298822578707`*^9, {3.703330047439876*^9, 3.7033300496256866`*^9}, {
   3.703330112617696*^9, 3.703330153772373*^9}, 3.703330381560884*^9, {
   3.703330413779385*^9, 3.703330418624124*^9}, {3.703333512313899*^9, 
   3.703333512502562*^9}, {3.703402740768899*^9, 3.703402749561689*^9}, {
   3.703404605234152*^9, 3.703404614206209*^9}, {3.703406745296116*^9, 
   3.7034067523976603`*^9}, 3.703428767269353*^9, {3.7034288980019827`*^9, 
   3.703428907089744*^9}, {3.70342894659212*^9, 3.7034289737800303`*^9}, {
   3.703429030769732*^9, 3.7034290560170803`*^9}, {3.703429133598694*^9, 
   3.7034291381453648`*^9}, 3.703433522213748*^9, {3.703435161113171*^9, 
   3.703435164261578*^9}, {3.703476439487144*^9, 3.7034764429177923`*^9}, {
   3.703479220040099*^9, 3.7034792234747562`*^9}, {3.7034797234919167`*^9, 
   3.703479726179582*^9}, {3.703505623614017*^9, 3.703505626444146*^9}, {
   3.703506363597169*^9, 3.703506367177709*^9}, {3.703516694937777*^9, 
   3.7035166995875883`*^9}, {3.703560264482478*^9, 3.7035602681579647`*^9}, {
   3.703828465339909*^9, 3.703828478033411*^9}, 3.703828586620489*^9, 
   3.70383074599887*^9, 3.7038342543140163`*^9, {3.703923890269329*^9, 
   3.703923909812685*^9}, {3.703927062656151*^9, 3.703927075383923*^9}, {
   3.703927663822242*^9, 3.703927667375022*^9}, {3.703950099902264*^9, 
   3.703950124628845*^9}, {3.70399254742778*^9, 3.703992582579582*^9}, {
   3.703992722631901*^9, 3.703992724358034*^9}, 3.703994690955072*^9, {
   3.7040168816183*^9, 3.7040168831347313`*^9}, {3.704024751819209*^9, 
   3.704024753986227*^9}, {3.70402506344915*^9, 3.704025065646306*^9}, {
   3.704025116659831*^9, 3.704025135239605*^9}, {3.704082603963031*^9, 
   3.704082605179125*^9}, {3.704082786864127*^9, 3.704082789149124*^9}, {
   3.704083889830536*^9, 3.7040838926267433`*^9}, {3.70408950241288*^9, 
   3.704089505468977*^9}, {3.7040900214478188`*^9, 3.7040900216221724`*^9}, {
   3.705141379885021*^9, 3.705141401722096*^9}, {3.705143531818925*^9, 
   3.705143532085795*^9}, {3.705143567927712*^9, 3.705143598007625*^9}, {
   3.7051443476557617`*^9, 3.705144459750148*^9}, 3.705144526344123*^9, {
   3.705144566432293*^9, 3.705144615201857*^9}, {3.7051454798495197`*^9, 
   3.705145632182578*^9}, {3.70514682980604*^9, 3.705146855579054*^9}, {
   3.705146911212381*^9, 3.705146967997033*^9}, {3.705147145131419*^9, 
   3.705147252634678*^9}, {3.7051472997442636`*^9, 3.705147302669154*^9}, {
   3.705147346335104*^9, 3.7051474149870157`*^9}, {3.7051475032609167`*^9, 
   3.705147546137457*^9}, {3.705148085178341*^9, 3.7051481598238277`*^9}, {
   3.705156566904132*^9, 3.705156599300144*^9}, {3.7051568958212433`*^9, 
   3.705156928715736*^9}, {3.705203381147861*^9, 3.7052033818062983`*^9}, {
   3.705203456541482*^9, 3.7052034695161543`*^9}, {3.7052035029862223`*^9, 
   3.705203536027768*^9}, {3.7052036142285*^9, 3.7052037203730993`*^9}, {
   3.705203982315176*^9, 3.705204022266286*^9}, {3.705204513229267*^9, 
   3.705204516918578*^9}, 3.7052045608882093`*^9, 3.705204612956295*^9, {
   3.705204707244131*^9, 3.705204708533128*^9}, {3.705204746214718*^9, 
   3.705204777665308*^9}, {3.705204980542512*^9, 3.705205032838587*^9}, {
   3.7052050646078777`*^9, 3.705205068260549*^9}, {3.70520513445446*^9, 
   3.705205175489542*^9}, {3.705205299877146*^9, 3.705205364960182*^9}, {
   3.705205508853239*^9, 3.705205529315772*^9}, {3.705291003208447*^9, 
   3.705291005394244*^9}, {3.7052910417843*^9, 3.7052910568995943`*^9}, {
   3.705291092916196*^9, 3.7052910944354687`*^9}, 3.7052911342008877`*^9, {
   3.705296101343667*^9, 3.7052961611299953`*^9}, {3.705296388653956*^9, 
   3.705296390841146*^9}, {3.705296423643943*^9, 3.7052964547298317`*^9}, {
   3.705296522440961*^9, 3.705296727257937*^9}, {3.705296789145569*^9, 
   3.705296790041759*^9}, {3.705296854025313*^9, 3.705296876072044*^9}, {
   3.705308921700204*^9, 3.70530893690795*^9}, {3.705309253725596*^9, 
   3.7053092625417547`*^9}, 3.7053817848033543`*^9, {3.7053862610185747`*^9, 
   3.7053862812764*^9}, {3.7053864093543577`*^9, 3.705386412280147*^9}, {
   3.705387138648315*^9, 3.705387153480096*^9}, {3.7053872511729317`*^9, 
   3.705387252228815*^9}, {3.7053872863438063`*^9, 3.705387286660503*^9}, {
   3.7053874079419327`*^9, 3.705387408212015*^9}, {3.7056351160278177`*^9, 
   3.705635213417992*^9}, {3.705635697017447*^9, 3.705635724266123*^9}, {
   3.7056362532063704`*^9, 3.7056362691771793`*^9}, {3.7056370742899*^9, 
   3.705637105665955*^9}, {3.705646027343808*^9, 3.705646030030652*^9}, {
   3.705646061249444*^9, 3.705646091025049*^9}, {3.70565031232893*^9, 
   3.705650314286447*^9}, {3.705651422983494*^9, 3.705651423476982*^9}, 
   3.705651457076215*^9, {3.7056517832534723`*^9, 3.70565181771513*^9}, {
   3.706007828031067*^9, 3.706007835566288*^9}, {3.706014212795939*^9, 
   3.706014216443672*^9}, {3.7060200750866337`*^9, 3.706020080582778*^9}, {
   3.706336551976164*^9, 3.706336561286887*^9}, {3.706413038402671*^9, 
   3.7064130473723392`*^9}, {3.706413686558622*^9, 3.7064137161582623`*^9}, {
   3.706762849842581*^9, 3.70676290894587*^9}, {3.706775234607148*^9, 
   3.706775253325343*^9}, {3.707190502979989*^9, 3.7071906321614933`*^9}, {
   3.707190914828102*^9, 3.707190922155017*^9}, {3.707190991904043*^9, 
   3.707190996383771*^9}, {3.7071912626718197`*^9, 3.707191264815465*^9}, {
   3.707191324544235*^9, 3.7071913318059063`*^9}, {3.7071915195034027`*^9, 
   3.70719154503852*^9}, {3.707191613008003*^9, 3.707191632234941*^9}, {
   3.707191688784795*^9, 3.7071917240131474`*^9}, {3.7071920575632067`*^9, 
   3.7071920689720373`*^9}, {3.7071922231805973`*^9, 3.707192227002005*^9}, {
   3.707192286602597*^9, 3.707192310058147*^9}, {3.707195793859433*^9, 
   3.707195796159688*^9}, {3.707195875857469*^9, 3.707195924224041*^9}, 
   3.70737078538037*^9, 3.707370837333816*^9, {3.708409851991447*^9, 
   3.7084098662872458`*^9}, {3.708749403633182*^9, 3.7087495355812607`*^9}, {
   3.708874759192068*^9, 3.708874766269629*^9}, {3.708874830588396*^9, 
   3.708874840137478*^9}, {3.708874998568503*^9, 3.70887502526724*^9}, {
   3.7092711637473297`*^9, 3.709271175319593*^9}, {3.709362595410198*^9, 
   3.709362626514847*^9}, {3.7093638783696117`*^9, 3.709363901285945*^9}, 
   3.709363935005178*^9, {3.709363980670282*^9, 3.709363982077084*^9}, {
   3.710893587400772*^9, 3.7108936381317945`*^9}, {3.7110293129118233`*^9, 
   3.71102937694057*^9}, {3.71102941882167*^9, 3.711029419093621*^9}, {
   3.713161512093514*^9, 3.713161516379463*^9}, {3.713161776315884*^9, 
   3.7131618630838842`*^9}, {3.713162110586276*^9, 3.713162133034213*^9}, {
   3.7131628551440773`*^9, 3.71316287589419*^9}, {3.713162934294841*^9, 
   3.713162946503318*^9}, {3.713163235429295*^9, 3.7131632709489613`*^9}, 
   3.7131633026283503`*^9, {3.713163362101972*^9, 3.713163385464327*^9}, {
   3.713163450117017*^9, 3.7131635234281054`*^9}, {3.713168936653665*^9, 
   3.7131689390378017`*^9}, {3.713349475671928*^9, 3.713349567126498*^9}, {
   3.713349597845543*^9, 3.713349602373456*^9}, {3.713350083782516*^9, 
   3.7133500871828337`*^9}, {3.713414130758155*^9, 3.713414144620476*^9}, {
   3.716736786816511*^9, 3.71673679163186*^9}, {3.716736943936707*^9, 
   3.716736944798617*^9}, {3.71673704804679*^9, 3.716737076782929*^9}, {
   3.7167390451925707`*^9, 3.716739144199259*^9}, {3.716739359720871*^9, 
   3.716739363351315*^9}, {3.716739493735491*^9, 3.716739746039909*^9}, 
   3.716739777851166*^9, {3.716739826488757*^9, 3.7167398611935053`*^9}, {
   3.716740002664555*^9, 3.716740086750114*^9}, {3.716740125387467*^9, 
   3.716740136908022*^9}, {3.722096237272066*^9, 3.722096240231883*^9}, {
   3.72209639218154*^9, 3.722096392469585*^9}, 3.722096446724934*^9, {
   3.72209653551908*^9, 3.722096548005187*^9}, {3.7220966873161707`*^9, 
   3.722096725264423*^9}, {3.725277864769004*^9, 3.725277868480027*^9}, 
   3.725342197288137*^9, 3.725345585635573*^9, {3.7253456298291187`*^9, 
   3.7253456542000637`*^9}, {3.725788651180253*^9, 3.7257886552586*^9}, {
   3.72629761652848*^9, 3.7262976328945932`*^9}, {3.72629768191267*^9, 
   3.726297737679706*^9}, {3.726297769404726*^9, 3.726297810607733*^9}, {
   3.7262978796653967`*^9, 3.7262978833952017`*^9}, {3.726899841962462*^9, 
   3.726899963640974*^9}, {3.726900117283592*^9, 3.726900131395677*^9}, {
   3.726900470745215*^9, 3.7269005215915813`*^9}, 3.726900615403373*^9, {
   3.7269006508373413`*^9, 3.7269006531360598`*^9}, {3.726901519959568*^9, 
   3.726901568000638*^9}, 3.726901781344577*^9, {3.7269018184807253`*^9, 
   3.726901894433589*^9}, {3.726902270719585*^9, 3.726902282830936*^9}, 
   3.7269024907014112`*^9, {3.7269027431964407`*^9, 3.7269027472715*^9}, {
   3.726902808620146*^9, 3.726902811836092*^9}, {3.726902847469756*^9, 
   3.726902870109231*^9}, {3.72690319687635*^9, 3.726903239193502*^9}, {
   3.7269053410123796`*^9, 3.726905356450437*^9}, 3.726917488033698*^9, {
   3.7269175669299498`*^9, 3.726917575247785*^9}, 3.726917891199779*^9, {
   3.7269180052624817`*^9, 3.726918040201058*^9}, {3.7269183227002077`*^9, 
   3.726918368973209*^9}, {3.7269184343329887`*^9, 3.7269184349098053`*^9}, {
   3.726930528325099*^9, 3.726930586623904*^9}, {3.726930750212008*^9, 
   3.72693075276941*^9}, 3.726930952487707*^9, 3.72693098731678*^9, 
   3.726980847835496*^9, {3.726981091201473*^9, 3.726981097266535*^9}, {
   3.732332256535686*^9, 3.732332266911256*^9}, {3.73233236153907*^9, 
   3.732332479935461*^9}, {3.732332624128137*^9, 3.7323327340304403`*^9}, {
   3.732334847411635*^9, 3.732334891941454*^9}, {3.732335033857017*^9, 
   3.732335228147167*^9}, {3.732335258370697*^9, 3.732335326818326*^9}, {
   3.7323353948359623`*^9, 3.732335443154241*^9}, {3.732335683282221*^9, 
   3.732335692467684*^9}, {3.732335733602934*^9, 3.732335777457335*^9}, {
   3.732335838080203*^9, 3.732335839202684*^9}, {3.732335960305994*^9, 
   3.732335987326872*^9}, {3.7323360233433123`*^9, 3.732336076238559*^9}, {
   3.7323361335196733`*^9, 3.732336246510848*^9}, {3.73233635372725*^9, 
   3.7323363602866077`*^9}, {3.732336393599553*^9, 3.732336452140135*^9}, {
   3.732336515358857*^9, 3.7323365344252253`*^9}, {3.732338679928035*^9, 
   3.7323387011563997`*^9}, {3.732338799238105*^9, 3.732338935540695*^9}, {
   3.7323395812514973`*^9, 3.732339605522294*^9}, {3.732339898130912*^9, 
   3.73233991571245*^9}, {3.732339994898987*^9, 3.732340043569306*^9}, {
   3.7323401212171307`*^9, 3.732340354384729*^9}, 3.732340397872134*^9, {
   3.732343517394949*^9, 3.732343528993782*^9}, {3.732343709362239*^9, 
   3.732343731696456*^9}, 3.732343761969425*^9, 3.732343849796362*^9, {
   3.732343884212843*^9, 3.732343922660227*^9}, {3.7323440764089737`*^9, 
   3.732344082881263*^9}, {3.7323494406591883`*^9, 3.732349478984593*^9}, {
   3.732349510091243*^9, 3.732349514731358*^9}, {3.732349759887457*^9, 
   3.732349826956636*^9}, {3.732350176032915*^9, 3.732350268750698*^9}, {
   3.73235210672736*^9, 3.732352126216543*^9}, {3.732352266531605*^9, 
   3.732352268496044*^9}, {3.73235234630742*^9, 3.7323524082658*^9}, {
   3.7323525579565983`*^9, 3.7323525899047537`*^9}, {3.732352760323349*^9, 
   3.732352767220924*^9}, {3.732352900979164*^9, 3.732352910863998*^9}, {
   3.7323530239630337`*^9, 3.73235306913931*^9}, {3.732353198160666*^9, 
   3.732353206891809*^9}, {3.732353285440988*^9, 3.732353290637622*^9}, {
   3.732353793326421*^9, 3.732353823883622*^9}, 3.732356871079426*^9, {
   3.732357030787643*^9, 3.732357032285973*^9}, 3.732357072348158*^9, 
   3.732357168713912*^9, {3.732357453696588*^9, 3.73235747016518*^9}, {
   3.7323606447481337`*^9, 3.732360649376297*^9}, {3.741963892193869*^9, 
   3.7419638973230352`*^9}, 3.741966183309104*^9, {3.741966658585*^9, 
   3.741966664488268*^9}, {3.7420207949552794`*^9, 3.7420208018829412`*^9}, {
   3.747541195781797*^9, 3.747541228627346*^9}, {3.750765369698763*^9, 
   3.750765398434978*^9}, {3.7507656292182426`*^9, 3.750765649201885*^9}, {
   3.750765824573423*^9, 3.7507658263844967`*^9}, {3.750766142868485*^9, 
   3.750766148386533*^9}, {3.7507663527571163`*^9, 3.750766371217904*^9}, {
   3.750930673212504*^9, 3.75093069821659*^9}, {3.7509307385794973`*^9, 
   3.750930741545121*^9}, {3.750931095712509*^9, 3.7509312300451803`*^9}, 
   3.750931485382594*^9, 3.7509315451700172`*^9, 3.7509320109946213`*^9, {
   3.7509391886371326`*^9, 3.750939189536161*^9}, {3.750939847072343*^9, 
   3.7509399246871853`*^9}, {3.750940228929294*^9, 3.750940298890264*^9}, {
   3.7509403431962233`*^9, 3.7509403493751583`*^9}, 3.750940408630127*^9, {
   3.7509987314437532`*^9, 3.7509987792248363`*^9}, 3.750999962819724*^9, {
   3.751024307151*^9, 3.751024309470372*^9}, 3.751024361710606*^9, {
   3.7510264644306192`*^9, 3.7510264646161633`*^9}, {3.7513841341779346`*^9, 
   3.751384235439025*^9}, 3.75138467115139*^9, 3.7513853391903753`*^9, {
   3.7513878049899597`*^9, 3.751387931547016*^9}, {3.751440439844035*^9, 
   3.751440440145767*^9}, {3.7514562068503437`*^9, 3.751456288105328*^9}, {
   3.751456460666254*^9, 3.751456478462647*^9}, {3.751456523323703*^9, 
   3.75145652860114*^9}, {3.751456592105451*^9, 3.751456592898061*^9}, {
   3.751458728731292*^9, 3.751458735061153*^9}, {3.75145878310046*^9, 
   3.751458789785336*^9}, {3.751947651788106*^9, 3.751947685034683*^9}, {
   3.769915650117337*^9, 3.769915670765832*^9}, {3.7699157080009403`*^9, 
   3.769915719722954*^9}, {3.7699157589047623`*^9, 3.769915778250825*^9}, {
   3.769915831911254*^9, 3.769915864785261*^9}, {3.76991590501722*^9, 
   3.769915915549295*^9}, 3.769916080846011*^9, {3.7699161611038027`*^9, 
   3.7699161741807623`*^9}, {3.769916223181188*^9, 3.7699162295019417`*^9}, {
   3.769916325805192*^9, 3.769916331184072*^9}, {3.7699164260670433`*^9, 
   3.769916450583782*^9}, {3.769916644587496*^9, 3.769916710902203*^9}, 
   3.769918724261853*^9, {3.7699207453045187`*^9, 3.769920748543888*^9}, {
   3.769920791999179*^9, 3.769920806204439*^9}, {3.769925682205124*^9, 
   3.769925682684964*^9}, {3.7699257602195883`*^9, 3.769925760867461*^9}, 
   3.769928306770832*^9, {3.769930896256421*^9, 3.7699309343052063`*^9}, {
   3.769931240065056*^9, 3.769931280899517*^9}, {3.7699313726785517`*^9, 
   3.769931404108214*^9}, {3.769932557466256*^9, 3.7699326083569403`*^9}, {
   3.769941620491746*^9, 3.769941664871655*^9}, 3.769941789855598*^9, {
   3.7704442423924847`*^9, 3.770444252071046*^9}, {3.770444289621085*^9, 
   3.770444386290024*^9}, {3.770445656885276*^9, 3.770445723004174*^9}, {
   3.7704458933791447`*^9, 3.7704460651204853`*^9}, {3.770446227541376*^9, 
   3.770446228772562*^9}, {3.770446271761713*^9, 3.7704462921767187`*^9}, 
   3.770447398515161*^9, {3.770447474601489*^9, 3.77044748362885*^9}, {
   3.7704476162390833`*^9, 3.7704476330193996`*^9}, {3.770447670604604*^9, 
   3.770447753181077*^9}, {3.770447940590724*^9, 3.770447946186908*^9}, {
   3.770447990747992*^9, 3.770448024940854*^9}, {3.770448063211775*^9, 
   3.7704481074511557`*^9}, {3.770448141948276*^9, 3.770448167642263*^9}, {
   3.770460005382432*^9, 3.770460043157279*^9}, {3.770460335445983*^9, 
   3.7704603448997498`*^9}, {3.7704604625652943`*^9, 3.770460473651042*^9}, {
   3.770460525390768*^9, 3.7704605314897738`*^9}, {3.770461128308325*^9, 
   3.770461159291395*^9}, {3.770544029413275*^9, 3.770544086017205*^9}, {
   3.77054435166706*^9, 3.7705443773917103`*^9}, {3.7705444560510187`*^9, 
   3.770544456894931*^9}, {3.770544528097691*^9, 3.770544528831181*^9}, {
   3.770547913911644*^9, 3.7705481854149437`*^9}, 3.770563843447214*^9, {
   3.77056449032885*^9, 3.77056449114187*^9}, {3.770564696116837*^9, 
   3.770564702349476*^9}, {3.770564855729203*^9, 3.77056487380836*^9}, {
   3.7705650384479*^9, 3.770565096669511*^9}, {3.770565191963543*^9, 
   3.770565293358585*^9}, {3.770565350847746*^9, 3.770565356993881*^9}, {
   3.77056603191057*^9, 3.770566045626512*^9}, {3.77060627678482*^9, 
   3.770606308794443*^9}, {3.770606342062133*^9, 3.770606348107377*^9}, 
   3.770607510427443*^9, {3.7706084966199303`*^9, 3.7706085023445168`*^9}, {
   3.7706085526172733`*^9, 3.770608602821835*^9}, {3.770608873491349*^9, 
   3.77060887694588*^9}, {3.770609028269561*^9, 3.770609074243793*^9}, {
   3.770609212427781*^9, 3.7706092593292427`*^9}, 3.7706092990197372`*^9, {
   3.770609335280684*^9, 3.770609336927973*^9}, {3.770609367911469*^9, 
   3.770609394687834*^9}, 3.7706101031233273`*^9, {3.7706218613841476`*^9, 
   3.770621883849251*^9}, {3.7706219374473333`*^9, 3.7706219707542467`*^9}, {
   3.77062210434332*^9, 3.770622126141918*^9}, {3.770622643865171*^9, 
   3.7706226620377207`*^9}, {3.7706232104986763`*^9, 3.770623221235283*^9}, {
   3.770623570132615*^9, 3.770623639746572*^9}, {3.770623851073551*^9, 
   3.770623882721464*^9}, {3.7706255315720797`*^9, 3.770625559579007*^9}, {
   3.770626053697339*^9, 3.77062605583321*^9}, {3.770626238621241*^9, 
   3.770626264712648*^9}, {3.770626719081197*^9, 3.770626820906143*^9}, {
   3.7706280253476143`*^9, 3.77062805955764*^9}, {3.770628119776149*^9, 
   3.770628135267305*^9}, {3.770628204513875*^9, 3.770628246500401*^9}, {
   3.770628294054401*^9, 3.77062829606947*^9}, {3.770628427772647*^9, 
   3.770628440241724*^9}, {3.770628530020137*^9, 3.770628557426957*^9}, {
   3.770628853124976*^9, 3.770628943203004*^9}, {3.7706296313710747`*^9, 
   3.7706298176146307`*^9}, {3.770629896239802*^9, 3.770629911279099*^9}, {
   3.770630111162889*^9, 3.770630131726843*^9}, {3.770630187069878*^9, 
   3.770630203502202*^9}, {3.770631361195793*^9, 3.770631456667727*^9}, {
   3.7706315915262117`*^9, 3.770631601656764*^9}, {3.770631653313271*^9, 
   3.7706316550371428`*^9}, {3.770631688938622*^9, 3.770631894136829*^9}, {
   3.770631927675275*^9, 3.7706319290972023`*^9}, {3.770633390313117*^9, 
   3.770633413268136*^9}, {3.770633488948867*^9, 3.770633489652925*^9}, {
   3.7706335208511677`*^9, 3.7706335692041893`*^9}, 3.770633677909124*^9, {
   3.7706337081981688`*^9, 3.770633780203926*^9}, {3.770634260990364*^9, 
   3.770634269080514*^9}, {3.770634384546647*^9, 3.770634413059016*^9}, {
   3.7706344961354637`*^9, 3.7706345021233883`*^9}, 3.7706346027271023`*^9, {
   3.770634638428022*^9, 3.7706346757143517`*^9}, {3.770635031137519*^9, 
   3.770635033666316*^9}, {3.770635067252014*^9, 3.770635067490129*^9}, {
   3.770635155026003*^9, 3.7706351772822027`*^9}, {3.770635309043057*^9, 
   3.7706353270401297`*^9}, {3.770635909792574*^9, 3.770635914633698*^9}, 
   3.7706361047313747`*^9, {3.770693717996867*^9, 3.770693737431067*^9}, 
   3.7706964236470203`*^9, {3.7706971037837276`*^9, 3.770697127840947*^9}, {
   3.770701016060801*^9, 3.770701061819765*^9}, {3.770701100940233*^9, 
   3.770701110841695*^9}, {3.770953726160076*^9, 3.770953758518969*^9}, {
   3.770954127932321*^9, 3.770954129784314*^9}, 3.770958845899969*^9, {
   3.770958905611396*^9, 3.770958906424426*^9}, {3.770960690341432*^9, 
   3.770960690592718*^9}, {3.7709652855088673`*^9, 3.7709652997525673`*^9}, {
   3.770965865683608*^9, 3.770965892287567*^9}, {3.7709663620353394`*^9, 
   3.770966368766835*^9}, {3.770967382637854*^9, 3.7709673875800667`*^9}, {
   3.7709674519176073`*^9, 3.77096745398071*^9}, 3.770981373475038*^9, {
   3.770981584467924*^9, 3.7709815875842733`*^9}, 3.7710420535726767`*^9, {
   3.7710484607343903`*^9, 3.77104846621745*^9}, 3.771049510092897*^9, 
   3.771049889020701*^9, {3.7710523852094793`*^9, 3.7710523955252028`*^9}, {
   3.771068483098259*^9, 3.7710684859561663`*^9}, 3.7711273708758993`*^9, {
   3.7711285489795218`*^9, 3.7711285675054903`*^9}, {3.7711287364406853`*^9, 
   3.771128778580453*^9}, {3.7711288193482037`*^9, 3.771128824049837*^9}, {
   3.7711289421643867`*^9, 3.771128989553549*^9}, {3.7711290278595963`*^9, 
   3.771129033839775*^9}, {3.771129897962204*^9, 3.771129906124576*^9}, {
   3.771130608771523*^9, 3.771130649422463*^9}, {3.7711329003905563`*^9, 
   3.771132932724846*^9}, 3.771134413320252*^9, {3.771134511190634*^9, 
   3.771134515059491*^9}, {3.771134641410544*^9, 3.771134641713276*^9}, 
   3.7711346941182613`*^9, {3.7711348667774773`*^9, 3.7711348779679737`*^9}, {
   3.771150347194726*^9, 3.771150366633872*^9}, {3.771152029282967*^9, 
   3.771152039155856*^9}, {3.771152168795424*^9, 3.7711521851404247`*^9}, {
   3.771152216949213*^9, 3.7711522737159243`*^9}, {3.771153122128511*^9, 
   3.771153329396926*^9}, {3.771153883249567*^9, 3.7711539055905437`*^9}, {
   3.771154137204262*^9, 3.771154140447566*^9}, {3.771214526484314*^9, 
   3.7712145388830223`*^9}, {3.771214596179781*^9, 3.7712146033148823`*^9}, {
   3.7712146514768257`*^9, 3.7712146898412323`*^9}, {3.771214727797791*^9, 
   3.771214736723488*^9}, {3.771214787138341*^9, 3.771214791731248*^9}, {
   3.771215653187399*^9, 3.771215736443634*^9}, 3.77121656194796*^9, {
   3.771216847238698*^9, 3.7712168491059427`*^9}, {3.771217672097403*^9, 
   3.771217684461912*^9}, 3.771218478497649*^9, 3.771218637010212*^9, {
   3.771301547891178*^9, 3.7713016073615503`*^9}, {3.7714799135090017`*^9, 
   3.7714799198054047`*^9}, {3.7727716384757147`*^9, 3.772771707978911*^9}, {
   3.7727722286986732`*^9, 3.772772242681706*^9}, {3.772772358569373*^9, 
   3.772772376073077*^9}, {3.7727724241541033`*^9, 3.772772434298717*^9}, {
   3.772772943463234*^9, 3.7727729730578737`*^9}, {3.772774946291541*^9, 
   3.77277495873862*^9}, {3.7727750556343737`*^9, 3.7727750850734453`*^9}, {
   3.772775120845269*^9, 3.7727751384332867`*^9}, {3.7727752430616407`*^9, 
   3.772775272642611*^9}, {3.772874402134577*^9, 3.772874470064176*^9}, {
   3.773376027724361*^9, 3.77337610217047*^9}, {3.77339370252347*^9, 
   3.773393768785898*^9}, 3.7735481657905693`*^9, 3.7735482911355658`*^9, 
   3.7737434850653954`*^9, {3.7739938631074677`*^9, 3.773993866413862*^9}, {
   3.7739939308016987`*^9, 3.773993952367133*^9}, {3.773994047089769*^9, 
   3.773994088784334*^9}, {3.773994355474989*^9, 3.7739944057452307`*^9}, {
   3.773994462947027*^9, 3.7739944870892353`*^9}, {3.7739947487411003`*^9, 
   3.773994749215948*^9}, {3.773998807484192*^9, 3.773998855934038*^9}, {
   3.7739993034046917`*^9, 3.773999351812043*^9}, {3.7739995907633877`*^9, 
   3.7739996269048223`*^9}, {3.7739997984112673`*^9, 3.773999805879629*^9}, {
   3.7739999987916193`*^9, 3.774000085190261*^9}, {3.7740006914933977`*^9, 
   3.774000859525279*^9}, {3.774001465192697*^9, 3.77400147318513*^9}, {
   3.774001503604403*^9, 3.774001579201108*^9}, {3.77400332338456*^9, 
   3.774003371738964*^9}, {3.774003412524181*^9, 3.774003540249487*^9}, {
   3.7740036254520082`*^9, 3.774003632189269*^9}, {3.774065312555586*^9, 
   3.774065325750874*^9}, {3.774067097363679*^9, 3.7740671029295073`*^9}, {
   3.774067230101651*^9, 3.7740672396045856`*^9}, {3.774067338594885*^9, 
   3.7740673960984087`*^9}, {3.774067793651643*^9, 3.774067801362118*^9}, {
   3.7740679381959887`*^9, 3.77406798472152*^9}, {3.7740693880329113`*^9, 
   3.774069388752726*^9}, {3.7740694727037582`*^9, 3.774069544175234*^9}, {
   3.774070599420149*^9, 3.774070637661207*^9}, {3.774071083096936*^9, 
   3.774071091225132*^9}, {3.774073797698905*^9, 3.774073802864483*^9}, {
   3.774078790487076*^9, 3.774078802820352*^9}, {3.774078919906137*^9, 
   3.774078932801816*^9}, {3.774084635860691*^9, 3.774084643330924*^9}, {
   3.774084802114896*^9, 3.774084809314341*^9}, {3.77408827824785*^9, 
   3.77408830369869*^9}, {3.774089432980933*^9, 3.774089485007031*^9}, {
   3.774089610010429*^9, 3.774089611511705*^9}, {3.7741582499166813`*^9, 
   3.774158258514187*^9}, {3.774158322772017*^9, 3.774158340188373*^9}, 
   3.77415854428329*^9, 3.7741585988464212`*^9, {3.774159872903071*^9, 
   3.774159877861328*^9}, {3.774160165327474*^9, 3.774160167500901*^9}, {
   3.774160205918799*^9, 3.774160218188918*^9}, {3.774160282833362*^9, 
   3.774160286835672*^9}, {3.774160328699779*^9, 3.774160447191737*^9}, {
   3.7741604987920437`*^9, 3.774160524594853*^9}, {3.774160615388722*^9, 
   3.774160620411789*^9}, {3.774160670821083*^9, 3.774160697000072*^9}, {
   3.77416075163978*^9, 3.774160755958375*^9}, {3.774161985575403*^9, 
   3.7741620023495417`*^9}, {3.7741620348127213`*^9, 3.774162042436183*^9}, {
   3.7741620868377438`*^9, 3.774162087570155*^9}, {3.7741626605416327`*^9, 
   3.774162664449594*^9}, {3.77416637010254*^9, 3.774166374441414*^9}, {
   3.774166564904935*^9, 3.774166574075637*^9}, {3.7741689723499107`*^9, 
   3.774168982864306*^9}, {3.7741690527604847`*^9, 3.774169054938694*^9}, 
   3.774169162259758*^9, {3.774169693033792*^9, 3.774169721479052*^9}, {
   3.774169939577614*^9, 3.774169939838874*^9}, {3.774170079763075*^9, 
   3.774170086299828*^9}, 3.7741701505550327`*^9, {3.774181078504801*^9, 
   3.7741810860469427`*^9}, 3.7741811775852137`*^9, {3.775450305893507*^9, 
   3.7754503332373543`*^9}, {3.775450382678691*^9, 3.7754504079491253`*^9}, {
   3.7754504755247297`*^9, 3.775450476500216*^9}, {3.775454223087091*^9, 
   3.775454295050631*^9}, {3.7754564663403063`*^9, 3.775456491843478*^9}, {
   3.775456817271493*^9, 3.7754568224397593`*^9}, 3.775456863959487*^9, 
   3.775459965077673*^9, {3.775883164708712*^9, 3.775883182527956*^9}, {
   3.776155010536336*^9, 3.7761550551735373`*^9}, 3.7764043246692047`*^9, 
   3.776404817308243*^9, 3.776697208866789*^9, 3.776697267447403*^9, {
   3.777188503029991*^9, 3.7771885120370483`*^9}, {3.777188542110148*^9, 
   3.7771885455086117`*^9}, {3.777188830152309*^9, 3.777188880705778*^9}, {
   3.7772731966355658`*^9, 3.777273242078272*^9}, {3.777273287646892*^9, 
   3.777273293245183*^9}, {3.777273586158099*^9, 3.777273597667781*^9}, {
   3.777277163608542*^9, 3.777277185576687*^9}, {3.777277273991568*^9, 
   3.7772772820552063`*^9}, 3.7772773154769793`*^9, {3.777277450902306*^9, 
   3.7772774514281807`*^9}, {3.777387710802286*^9, 3.777387768963999*^9}, {
   3.777630710339115*^9, 3.777630741216403*^9}, {3.777630874755054*^9, 
   3.777630894895136*^9}, {3.777630951937538*^9, 3.7776309716333942`*^9}, {
   3.777631063173023*^9, 3.777631119642494*^9}, {3.777631232225861*^9, 
   3.7776312417991877`*^9}, {3.777631922957018*^9, 3.777631924135964*^9}, {
   3.7776319731833*^9, 3.777631986733696*^9}, {3.77763392323524*^9, 
   3.777633929901328*^9}, {3.777634294259962*^9, 3.777634321588562*^9}, {
   3.777636205812961*^9, 3.777636354799841*^9}, {3.7776364924052687`*^9, 
   3.7776365099723577`*^9}, {3.7776939600569277`*^9, 3.777693961094734*^9}, {
   3.7776942767775927`*^9, 3.777694327527117*^9}, {3.7776943909181957`*^9, 
   3.777694397670931*^9}, 3.777694429687202*^9, {3.777694612630118*^9, 
   3.777694613396843*^9}, {3.777694651988255*^9, 3.7776947003242683`*^9}, {
   3.777694736279387*^9, 3.7776947861469193`*^9}, {3.777694871445126*^9, 
   3.7776948837628508`*^9}, {3.777695442933867*^9, 3.777695475840465*^9}, {
   3.777695525498046*^9, 3.777695529135301*^9}, {3.7776955951123047`*^9, 
   3.777695595444113*^9}, {3.777696115811738*^9, 3.777696151378759*^9}, {
   3.777696223731901*^9, 3.777696287547131*^9}, {3.777696347040001*^9, 
   3.777696410136302*^9}, {3.7776964920935593`*^9, 3.777696616013859*^9}, 
   3.777697758153219*^9, {3.7776980628748083`*^9, 3.777698076845386*^9}, 
   3.7776983127463913`*^9, {3.777698349939509*^9, 3.77769842156875*^9}, {
   3.777698489555996*^9, 3.7776985006073627`*^9}, {3.7776985315393553`*^9, 
   3.777698553106923*^9}, {3.777698632165584*^9, 3.777698641777328*^9}, {
   3.77769869554793*^9, 3.777698700319339*^9}, {3.777698746492847*^9, 
   3.777698785628222*^9}, {3.7776988632183104`*^9, 3.777698880273828*^9}, 
   3.7776989138808813`*^9, {3.77770067577043*^9, 3.7777006767278557`*^9}, {
   3.777700773175362*^9, 3.777700778485588*^9}, 3.777700821800563*^9, {
   3.777700867352849*^9, 3.7777009035260143`*^9}, {3.777701233649387*^9, 
   3.777701241893961*^9}, {3.777701364775681*^9, 3.7777013778945847`*^9}, {
   3.77770141724967*^9, 3.777701418416217*^9}, {3.777702104532062*^9, 
   3.777702105264421*^9}, 3.777702157784216*^9, {3.7777024107077017`*^9, 
   3.777702413518779*^9}, {3.777717827735786*^9, 3.777717828214115*^9}, {
   3.777717925595213*^9, 3.777717940317911*^9}, {3.777718196311571*^9, 
   3.77771820502722*^9}, {3.777719849873506*^9, 3.777719868384338*^9}, {
   3.7777199110263567`*^9, 3.777719913257348*^9}, {3.777720023582004*^9, 
   3.777720026714426*^9}, {3.777736699350569*^9, 3.777736699754524*^9}, {
   3.777736856686267*^9, 3.777736866767187*^9}, {3.7777376936076317`*^9, 
   3.7777377006835127`*^9}, 3.777779196898326*^9, 3.7777805256940737`*^9, {
   3.777780635067334*^9, 3.7777806589544086`*^9}, {3.7777888714046297`*^9, 
   3.777788875419449*^9}, {3.777789024923684*^9, 3.777789029099824*^9}, {
   3.777789089931292*^9, 3.777789094864678*^9}, {3.777886998962513*^9, 
   3.777887048798473*^9}, 3.7778871262133303`*^9, 3.777887157373787*^9, {
   3.778214142413589*^9, 3.778214244231997*^9}, {3.778214363960647*^9, 
   3.7782143686456337`*^9}, {3.7782144111747704`*^9, 3.778214444389749*^9}, {
   3.778214746887478*^9, 3.778214804979823*^9}, {3.778214958103807*^9, 
   3.7782149657500973`*^9}, {3.778216954145484*^9, 3.778216957855442*^9}, {
   3.778221348035087*^9, 3.778221350208249*^9}, {3.778221965199644*^9, 
   3.778221974543646*^9}, {3.7782268396510363`*^9, 3.7782270380311337`*^9}, {
   3.7782270774406433`*^9, 3.778227079996685*^9}, {3.778233290883534*^9, 
   3.778233330038781*^9}, 3.778235251184287*^9, 3.778235403527527*^9, 
   3.7782986403759527`*^9, {3.7782987135875597`*^9, 3.778298742097329*^9}, 
   3.7782990850070887`*^9, {3.778303850226036*^9, 3.7783038620819607`*^9}, {
   3.778303893012459*^9, 3.778303926951223*^9}, {3.778304181956665*^9, 
   3.778304182545293*^9}, {3.778304277700087*^9, 3.7783042943064537`*^9}, {
   3.778304356645731*^9, 3.778304413202038*^9}, {3.778305941504534*^9, 
   3.778305980140414*^9}, {3.778310757189398*^9, 3.778310757425251*^9}, 
   3.7783110089030533`*^9, 3.778311387908914*^9, {3.778311583442898*^9, 
   3.778311583633531*^9}, 3.778311616448901*^9, 3.778311662741007*^9, {
   3.7783127759902143`*^9, 3.778312816809394*^9}, 3.7783133008143053`*^9, 
   3.778313386594831*^9, {3.7783134820806093`*^9, 3.778313509428225*^9}, {
   3.778314844572625*^9, 3.778314853032652*^9}, {3.778402922467944*^9, 
   3.7784029298598137`*^9}, {3.7784073048435497`*^9, 3.77840730501903*^9}, {
   3.7784724536720133`*^9, 3.778472464407346*^9}, {3.778472578600465*^9, 
   3.77847263038766*^9}, {3.778472661451503*^9, 3.7784726754330053`*^9}, {
   3.778472819769293*^9, 3.778472822758871*^9}, {3.77847391387506*^9, 
   3.778473936315654*^9}, 3.778487194877119*^9, {3.77907560838861*^9, 
   3.779075639667218*^9}, {3.779075672004354*^9, 3.779075732256742*^9}, {
   3.779075765695368*^9, 3.779075797694821*^9}, {3.7790758442740917`*^9, 
   3.779075844623003*^9}, {3.779423393558709*^9, 3.779423397639172*^9}, 
   3.7795977976146517`*^9, {3.779597836170474*^9, 3.779597854404875*^9}, {
   3.77959799976093*^9, 3.7795980208700314`*^9}, 3.77959809622199*^9, 
   3.7795991005716343`*^9, {3.7795991354090357`*^9, 3.7795991363366957`*^9}, {
   3.779599199937505*^9, 3.7795992567193613`*^9}, {3.7801185984272757`*^9, 
   3.780118601849226*^9}, {3.7801186908929033`*^9, 3.7801187404117413`*^9}, 
   3.780118913989653*^9, {3.780119016308773*^9, 3.780119023868408*^9}, {
   3.7801190558145313`*^9, 3.780119100870948*^9}, {3.780119155397502*^9, 
   3.780119187174766*^9}, {3.78011921895678*^9, 3.780119223899794*^9}, {
   3.7801193362165956`*^9, 3.780119352095544*^9}, {3.780119413887499*^9, 
   3.780119418410961*^9}, 3.780123995329904*^9, {3.7801240494076433`*^9, 
   3.780124095599513*^9}, {3.780131594235093*^9, 3.780131648092434*^9}, 
   3.78013168426051*^9, {3.7801322709419327`*^9, 3.7801322728117037`*^9}, {
   3.7801400245667973`*^9, 3.7801400443746567`*^9}, {3.780223618195568*^9, 
   3.7802237034275618`*^9}, {3.7802237387032957`*^9, 3.780223742977817*^9}, {
   3.7802237895875797`*^9, 3.780223821074649*^9}, {3.7802238831375*^9, 
   3.780223987218525*^9}, 3.780224817648608*^9, {3.78022525335896*^9, 
   3.780225262094185*^9}, {3.7802256830387087`*^9, 3.780225687379023*^9}, {
   3.780225728925283*^9, 3.780225849229797*^9}, {3.7802260097412167`*^9, 
   3.780226022092559*^9}, {3.7802260550058107`*^9, 3.78022607590254*^9}, {
   3.780226108669739*^9, 3.780226222605521*^9}, {3.780226288334136*^9, 
   3.7802264114594517`*^9}, {3.780286391606691*^9, 3.780286428197988*^9}, {
   3.7802873812627487`*^9, 3.780287393306594*^9}, 3.780287452955017*^9, {
   3.7802874948757753`*^9, 3.7802875193233347`*^9}, {3.780287561277339*^9, 
   3.780287613739111*^9}, {3.780288724746704*^9, 3.780288754917802*^9}, {
   3.780290000563389*^9, 3.780290036003192*^9}, {3.78029010078745*^9, 
   3.780290127282217*^9}, {3.780290344337551*^9, 3.780290404416862*^9}, {
   3.780290507905459*^9, 3.780290541793013*^9}, 3.7802954102821198`*^9, {
   3.78029586267947*^9, 3.7802958856550198`*^9}, {3.780301514712069*^9, 
   3.780301526087037*^9}, 3.780301575785892*^9, {3.780321461983601*^9, 
   3.78032147200627*^9}, {3.780719517558299*^9, 3.7807195204314137`*^9}, {
   3.780724003918674*^9, 3.780724050782095*^9}, {3.7808114279292517`*^9, 
   3.780811444567342*^9}, {3.780811476358585*^9, 3.780811476678112*^9}, {
   3.780811506970069*^9, 3.780811510889814*^9}, {3.780811839328516*^9, 
   3.780811873702714*^9}, {3.780811951622819*^9, 3.780811987572503*^9}, {
   3.78081203915978*^9, 3.780812044102104*^9}, {3.780812664969015*^9, 
   3.7808126838142853`*^9}, {3.780813064279953*^9, 3.7808130646213512`*^9}, {
   3.780830779019125*^9, 3.7808307976764708`*^9}, {3.780830901187375*^9, 
   3.780830907475918*^9}, {3.780830944859584*^9, 3.780830988118705*^9}, {
   3.780831085648768*^9, 3.780831147485074*^9}, {3.780893781714446*^9, 
   3.78089378241451*^9}, {3.780895154519806*^9, 3.780895162336801*^9}, {
   3.780895230485869*^9, 3.780895266987362*^9}, 3.780897704048855*^9, {
   3.7808978036212177`*^9, 3.780898014074498*^9}, {3.780898044102319*^9, 
   3.780898045874755*^9}, {3.780899658047965*^9, 3.780899665439414*^9}, 
   3.780899736368678*^9, 3.780899827009449*^9, {3.780989481934155*^9, 
   3.780989562730287*^9}, {3.7809898506122627`*^9, 3.780990049371998*^9}, {
   3.780990091642016*^9, 3.780990135670164*^9}, {3.780994912811348*^9, 
   3.780994972795412*^9}, 3.780995918938291*^9, 3.781932341708025*^9, {
   3.781932618985907*^9, 3.781932633096937*^9}, {3.781932710793726*^9, 
   3.781932721959609*^9}, {3.781932983516816*^9, 3.78193298370364*^9}, {
   3.7820235111560507`*^9, 3.782023666501527*^9}, {3.782024651607725*^9, 
   3.782024837398952*^9}, {3.782190916645553*^9, 3.782190920850762*^9}, 
   3.782190967982024*^9, {3.7824722814721737`*^9, 3.782472286158885*^9}, 
   3.782557369117579*^9, {3.782559727785037*^9, 3.78255974554035*^9}, {
   3.783832615176901*^9, 3.783832653343801*^9}, {3.7838326888682013`*^9, 
   3.7838327225125504`*^9}, {3.783832757437253*^9, 3.7838327644161367`*^9}, 
   3.783853885626322*^9, 3.78677598828062*^9, 3.786780927681284*^9, 
   3.787565206262536*^9, 3.7875664171430607`*^9, 3.7875672851681623`*^9, 
   3.787567376604545*^9, {3.789190389993541*^9, 3.7891903943270884`*^9}, {
   3.7891909089528313`*^9, 3.789191093020266*^9}, {3.789191165318503*^9, 
   3.789191170611924*^9}, {3.789191255334977*^9, 3.7891912567073193`*^9}, {
   3.789191363152388*^9, 3.789191418174234*^9}, {3.789191458192589*^9, 
   3.789191492142247*^9}, 3.789194333502844*^9, {3.7891943848120413`*^9, 
   3.7891943872140837`*^9}, {3.789362145982909*^9, 3.789362149645544*^9}, {
   3.789362192686974*^9, 3.789362193300383*^9}, {3.789453112315995*^9, 
   3.789453123340247*^9}, {3.789486437304441*^9, 3.789486455819769*^9}, {
   3.789486492637023*^9, 3.78948654118252*^9}, {3.789486586940839*^9, 
   3.7894866174950657`*^9}, {3.789486721789855*^9, 3.789486749710884*^9}, 
   3.7894867869289103`*^9, {3.78948691744239*^9, 3.789486919541544*^9}, {
   3.789486970371553*^9, 3.789486978582425*^9}, 3.7894870096358128`*^9, 
   3.789487125713607*^9, {3.789531323568222*^9, 3.78953137571453*^9}, {
   3.789531486585123*^9, 3.789531506910573*^9}, {3.789531543465417*^9, 
   3.789531544189788*^9}, {3.789531637303443*^9, 3.78953178698559*^9}, {
   3.7895323674621277`*^9, 3.7895324061481743`*^9}, {3.7895371272139587`*^9, 
   3.789537163148877*^9}, 3.7895372405708323`*^9, 3.789537414775676*^9, {
   3.789537933500628*^9, 3.7895379389818487`*^9}, {3.7895379756205673`*^9, 
   3.789537986618903*^9}, 3.789539934571829*^9, 3.7897273125707617`*^9, {
   3.795091470939971*^9, 3.795091499181878*^9}, {3.795091768338127*^9, 
   3.79509182718172*^9}, {3.795091870528042*^9, 3.7950919451355867`*^9}, {
   3.795092562835516*^9, 3.795092563335492*^9}, {3.798774278837233*^9, 
   3.798774283352354*^9}, {3.798774327907156*^9, 3.798774356171821*^9}, 
   3.7987744638109303`*^9, {3.7987745174244213`*^9, 3.798774595554069*^9}, {
   3.798775438449539*^9, 3.7987754622479486`*^9}, 3.798775587108611*^9, 
   3.798775624969371*^9, 3.7987759077397738`*^9, {3.798775942040119*^9, 
   3.7987759675034018`*^9}, {3.798776115479396*^9, 3.7987761164338408`*^9}, {
   3.798776146628439*^9, 3.79877622073838*^9}, {3.7987763884883833`*^9, 
   3.7987764547613907`*^9}, {3.7987764850737247`*^9, 3.7987764969525957`*^9}, 
   3.798776533806592*^9, {3.798776646123786*^9, 3.7987766727497377`*^9}, {
   3.7987767566938267`*^9, 3.798776803246462*^9}, {3.798776979868903*^9, 
   3.798777003975152*^9}, {3.798777042277166*^9, 3.798777046656394*^9}, {
   3.7987771268167257`*^9, 3.798777131590246*^9}, {3.798777280769174*^9, 
   3.798777329484036*^9}, {3.798777374551261*^9, 3.79877746952035*^9}, {
   3.7987775540587463`*^9, 3.798777556125214*^9}, {3.7987776075334377`*^9, 
   3.7987776254999027`*^9}, {3.798777666103079*^9, 3.798777714176778*^9}, {
   3.798779306565881*^9, 3.798779390883626*^9}, {3.798779476207356*^9, 
   3.798779501502996*^9}, {3.798779689123973*^9, 3.798779700182083*^9}, {
   3.798779742526094*^9, 3.7987798143457193`*^9}, {3.798779873709667*^9, 
   3.798779881782379*^9}, {3.798779966486923*^9, 3.798780001413888*^9}, {
   3.798780130265847*^9, 3.798780135724193*^9}, {3.798780182048148*^9, 
   3.7987801940279093`*^9}, {3.7987802383533297`*^9, 3.79878045798076*^9}, {
   3.798780498392425*^9, 3.7987805575681458`*^9}, {3.7987806250812683`*^9, 
   3.798780757377097*^9}, {3.7987808040991707`*^9, 3.798780813906022*^9}, {
   3.798781790354279*^9, 3.7987818306876163`*^9}, 3.798781922929598*^9, {
   3.798782033659403*^9, 3.798782035207271*^9}, {3.798782071228621*^9, 
   3.798782092209754*^9}, {3.798782309548655*^9, 3.798782311214789*^9}, 
   3.798785179208172*^9, {3.798786230754416*^9, 3.798786243064991*^9}, {
   3.798786569347035*^9, 3.798786588349101*^9}, {3.798902544336319*^9, 
   3.798902592298132*^9}, {3.7989027040668497`*^9, 3.7989027555351553`*^9}, 
   3.798902794213839*^9, {3.798952814907031*^9, 3.7989528207288446`*^9}, 
   3.798953098731641*^9, 3.798953130301948*^9, {3.798978390749317*^9, 
   3.798978453832593*^9}, {3.798978540789618*^9, 3.7989785577237997`*^9}, {
   3.798978683113784*^9, 3.798978698460318*^9}, {3.798980143133834*^9, 
   3.798980152769936*^9}, 3.799076793319377*^9, {3.799120733703332*^9, 
   3.799120734210723*^9}},ExpressionUUID->"d94ef849-a0da-49b1-8261-\
6b5c237d2bbe"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ninequalities", "=", 
   RowBox[{"Length", "[", "ListofIneq", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nequalities", "=", 
    RowBox[{"Length", "[", "ListofEq", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nequations", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Flatten", "[", "ListofEq", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ninequalities", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Flatten", "[", "ListofIneq", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListofConstraints", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"ListofEq", ",", "ListofIneq"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nconstraints", "=", 
    RowBox[{"Length", "[", "ListofConstraints", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LBconstraints", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"0.", ",", 
     RowBox[{"{", 
      RowBox[{"indxc", ",", "nconstraints"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UBeqconstraints", "=", 
   RowBox[{"LBconstraints", "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "nequalities"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UBineqconstraints", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"bigBnd", ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "ninequalities"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UBconstraints", "=", 
    RowBox[{"Join", "[", 
     RowBox[{"UBeqconstraints", ",", "UBineqconstraints"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Determining", " ", "gradients", " ", "and", " ", "hessians"}], 
   "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gradobjfunc", "=", 
   RowBox[{"D", "[", 
    RowBox[{"principalutility", ",", 
     RowBox[{"{", "ListofVars", "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"multipliers", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ToExpression", "[", 
      RowBox[{"\"\<lambda\>\"", "<>", 
       RowBox[{"ToString", "[", "indx", "]"}], "<>", "\"\<E\>\""}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replacemulttonumerated", "=", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"multipliers", "[", 
          RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}]}], "]"}], 
      "\[Rule]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"\"\<LAM(\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"indx", ",", "InputForm"}], "]"}], "<>", "\"\<)\>\""}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}]}], "]"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "compute", " ", "the", " ", "jacobian", " ", "of", " ", "the", " ", 
    "constraints", " ", "and", " ", "the", " ", "sparsity", " ", "pattern"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"jacconstraints", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"0.", ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"jacconstraints", "=", 
    RowBox[{"D", "[", 
     RowBox[{"ListofConstraints", ",", 
      RowBox[{"{", "ListofVars", "}"}]}], "]"}]}], ";"}], " ", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"the", " ", "sparsity", " ", "patterns"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indxjacnonzero", "=", 
   RowBox[{"Complement", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"indxr", ",", "indxc"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"indxr", ",", "1", ",", "nconstraints"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"indxc", ",", "1", ",", "nvars"}], "}"}]}], "]"}], ",", 
       "1"}], "]"}], ",", 
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"jacconstraints", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "nconstraints"}], ",", 
          RowBox[{"1", ";;", "nvars"}]}], "]"}], "]"}], ",", "0"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nnonzerojac", "=", 
    RowBox[{"Length", "[", "indxjacnonzero", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indxobjnonzero", "=", 
   RowBox[{"Complement", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "indxc", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"indxc", ",", "1", ",", "nvars"}], "}"}]}], "]"}], ",", 
       "1"}], "]"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"gradobjfunc", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", "nvars"}], "]"}], "]"}], ",", "0", ",", "1"}], 
       "]"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nnonzeroobj", "=", 
    RowBox[{"Length", "[", "indxobjnonzero", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Hessian", " ", "of", " ", "lagrangian"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lagrangian", "=", 
   RowBox[{
    RowBox[{"objfact", "*", "principalutility"}], "+", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"multipliers", "[", 
        RowBox[{"[", "indx", "]"}], "]"}], "*", 
       RowBox[{"ListofConstraints", "[", 
        RowBox[{"[", "indx", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"indx", ",", "1", ",", "nconstraints"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hessianlagrangian", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"0.", ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"hessianlagrangian", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "nvars"}], ",", 
       RowBox[{"1", ";;", "nvars"}]}], "]"}], "]"}], "=", 
    RowBox[{"D", "[", 
     RowBox[{"lagrangian", ",", 
      RowBox[{"{", 
       RowBox[{"ListofVars", ",", "2"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indxhessnonzero", "=", 
   RowBox[{"Complement", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"indxr", ",", "indxc"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"indxr", ",", "1", ",", "nvars"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"indxc", ",", "1", ",", "indxr"}], "}"}]}], "]"}], ",", 
       "1"}], "]"}], ",", 
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"hessianlagrangian", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "nvars"}], ",", 
          RowBox[{"1", ";;", "nvars"}]}], "]"}], "]"}], ",", "0"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nnonzerohess", " ", "=", " ", 
   RowBox[{"Length", "[", "indxhessnonzero", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"indxhessnonzero", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"indxhessnonzero", "+", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"indx", "*", "nvars"}], ",", 
             RowBox[{"indx", "*", "nvars"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"indxr", ",", 
             RowBox[{"Length", "[", "indxhessnonzero", "]"}]}], "}"}]}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "0", ",", 
          RowBox[{"1", "-", "1"}]}], "}"}]}], "]"}], ",", "1"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "mapping", " ", "the", " ", "variables", " ", "into", " ", "a", " ", 
    "vector", " ", "with", " ", "indices", " ", "and", " ", "vice", " ", 
    "versa"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacetonumerated", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"ListofVars", "[", 
          RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}], "\[Rule]", 
      
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"\"\<X(\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"indx", ",", "InputForm"}], "]"}], "<>", "\"\<)\>\""}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacetonumeratedtmp", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"ListofVars", "[", 
          RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}], "\[Rule]", 
      
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"\"\<X_tmp(\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"indx", ",", "InputForm"}], "]"}], "<>", "\"\<)\>\""}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulesFortran", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Thread", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{"ListofContStateVars", "[", 
           RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"indx", ",", "1", ",", "ncontstates"}], "}"}]}], "]"}], 
       "\[Rule]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"\"\<grid_pt_box(\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"indx", ",", "InputForm"}], "]"}], "<>", "\"\<)\>\""}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"indx", ",", "1", ",", "ncontstates"}], "}"}]}], "]"}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\</E**(\>\"", "\[Rule]", "\"\<*E**(-\>\""}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replacetonumeratedC", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"ListofVars", "[", 
            RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}], 
        "\[Rule]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"\"\<u[\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{
             RowBox[{"indx", "-", "1"}], ",", "InputForm"}], "]"}], "<>", 
           "\"\<]\>\""}], ",", 
          RowBox[{"{", 
           RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], "]"}], 
      ",", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"ListofContStateVars", "[", 
            RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"indx", ",", "1", ",", "ncontstates"}], "}"}]}], "]"}], 
        "\[Rule]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"\"\<x[\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{
             RowBox[{"indx", "-", "1"}], ",", "InputForm"}], "]"}], "<>", 
           "\"\<]\>\""}], ",", 
          RowBox[{"{", 
           RowBox[{"indx", ",", "1", ",", "ncontstates"}], "}"}]}], "]"}]}], 
       "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replacetonumeratedxAdj", "=", 
    RowBox[{"Join", "[", 
     RowBox[{"Thread", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{"ListofVars", "[", 
           RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}], "\[Rule]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"\"\<xAdj(\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"indx", ",", "InputForm"}], "]"}], "<>", "\"\<)\>\""}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], "]"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replacereversed", "=", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"\"\<X(\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"indx", ",", "InputForm"}], "]"}], "<>", "\"\<)\>\""}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}], "\[Rule]", 
      
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"ListofVars", "[", 
          RowBox[{"[", "indx", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indx", ",", "1", ",", "nvars"}], "}"}]}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "replace", " ", "rules", " ", "to", " ", "format", " ", "output"}], ",", 
    " ", 
    RowBox[{
    "set", " ", "initial", " ", "conditions", " ", "and", " ", "define", " ", 
     "derivatives"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulef", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulefd", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulefdd", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulesqd", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replacerulesqdd", "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replaceruleFunctions", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
    "replacerulef", ",", "replacerulefd", ",", "replacerulefdd", ",", 
     "replacerulesqd", ",", "replacerulesqdd", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Derivative", "[", "1", "]"}], "[", "exp", "]"}], "[", "x_", 
        "]"}], "\[RuleDelayed]", 
       RowBox[{"exp", "[", "x", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"addreplacerule", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<Power\>\"", "\[Rule]", "\"\<pow\>\""}], ",", 
     RowBox[{"\"\<Sqrt\>\"", "\[Rule]", "\"\<sqrt\>\""}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"addreplacerulePY", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<Sqrt\>\"", "\[Rule]", "\"\<np.sqrt\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulenewlineF", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\< Sqrt\>\"", "\[Rule]", "\"\<&\n              & Sqrt\>\""}], 
     ",", 
     RowBox[{"\"\< + \>\"", "\[Rule]", "\"\< &\n              & + \>\""}], 
     ",", 
     RowBox[{"\"\< - \>\"", "\[Rule]", "\"\< &\n              & - \>\""}], 
     ",", 
     RowBox[{
     "\"\<Coord\>\"", "\[Rule]", "\"\< &\n              & Coord\>\""}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulenewline", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<1.*(\>\"", "\[Rule]", "\"\<1.*(&\n              &   \>\""}],
      ",", 
     RowBox[{
     "\"\<(0.5*lambda_down\>\"", "\[Rule]", "\"\<&\n&(0.5*lambda_down\>\""}], 
     ",", 
     RowBox[{"\"\<Log\>\"", "\[Rule]", "\"\<&\n              &   Log\>\""}], 
     ",", 
     RowBox[{"\"\<) +\>\"", "\[Rule]", "\"\<)&\n              &   +\>\""}], 
     ",", 
     RowBox[{"\"\<) -\>\"", "\[Rule]", "\"\<)&\n              &   -\>\""}], 
     ",", 
     RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<&\n              &   + (\>\""}], 
     ",", 
     RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<&\n              &   - (\>\""}], 
     ",", 
     RowBox[{
     "\"\<Min(0,\>\"", "\[Rule]", "\"\<&\n              &   Min(0.0,\>\""}], 
     ",", 
     RowBox[{"\"\<Max(0,\>\"", "\[Rule]", "\"\<Max(0.0,\>\""}], ",", 
     RowBox[{"\"\<Max\>\"", "\[Rule]", "\"\<&\n              &   Max\>\""}], 
     ",", 
     RowBox[{"\"\</\>\"", "\[Rule]", "\"\</ &\n              &  \>\""}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulejac", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"replacetonumerated", ",", "addreplacerule"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"replacerulehess", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
    "replacetonumerated", ",", "replacemulttonumerated", ",", 
     "addreplacerule"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replacerulefixunderscore", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<zshock\>\"", "\[Rule]", "\"\<z_shock\>\""}], ",", 
      RowBox[{"\"\<currentstate\>\"", "\[Rule]", "\"\<current_state\>\""}], 
      ",", 
      RowBox[{"\"\<probstate\>\"", "\[Rule]", "\"\<prob_state\>\""}], ",", 
      RowBox[{"\"\<US\>\"", "\[Rule]", "\"\<_\>\""}]}], "}"}]}], ";"}], "\n", 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"directorystr", "=", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "<>", "\"\<CPP/\>\""}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"solvevars", "=", 
   RowBox[{"{", 
    RowBox[{
    "otheragag1EN", ",", "otheragag2EN", ",", "Rho1E", ",", "consumption1EN", 
     ",", "continuationA1S1EN", ",", "Rho2E", ",", "consumption2EN", ",", 
     "continuationA2S1EN"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"solfeas", "=", 
   RowBox[{"Quiet", "[", 
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{"ListofEq", "[", 
          RowBox[{"[", 
           RowBox[{"{", 
            RowBox[{
            "1", ",", "2", ",", "3", ",", "4", ",", "8", ",", "9", ",", "10", 
             ",", "14"}], "}"}], "]"}], "]"}], "\[Equal]", "0"}], "]"}], "/.",
        "parameterssub"}], ",", "solvevars"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.654950968807351*^9, 3.654950993448121*^9}, {
   3.654958868394607*^9, 3.654958887459243*^9}, 3.6549628937633247`*^9, {
   3.6549629527839737`*^9, 3.6549629530592413`*^9}, {3.6549629919962378`*^9, 
   3.654963034761365*^9}, {3.654963070806025*^9, 3.654963161526556*^9}, {
   3.654963198466097*^9, 3.654963205470996*^9}, {3.654963247508512*^9, 
   3.654963377444442*^9}, 3.654963446219308*^9, {3.654964044430524*^9, 
   3.654964069171672*^9}, {3.654964313766795*^9, 3.654964362710924*^9}, 
   3.654975421580859*^9, {3.6549793311734657`*^9, 3.654979347008975*^9}, 
   3.6549795888184958`*^9, {3.654988309941083*^9, 3.6549883601960945`*^9}, {
   3.654988413595087*^9, 3.6549885058000946`*^9}, {3.654988576150097*^9, 
   3.654988693349109*^9}, 3.654989145684304*^9, 3.6549893807313213`*^9, 
   3.654989416477545*^9, {3.654989887932562*^9, 3.654989892066569*^9}, {
   3.654990051649253*^9, 3.6549900521222525`*^9}, {3.655038174691744*^9, 
   3.6550382845991707`*^9}, {3.6550383849966087`*^9, 3.655038418956952*^9}, {
   3.6550576156901207`*^9, 3.655057619096415*^9}, {3.655398901317727*^9, 
   3.6553989200587287`*^9}, {3.6553993425747657`*^9, 3.655399407671767*^9}, {
   3.6553996840007772`*^9, 3.6553996894367747`*^9}, {3.6556516660407677`*^9, 
   3.6556516746066923`*^9}, {3.655652625580862*^9, 3.655652633085099*^9}, {
   3.655670140686823*^9, 3.6556701857195387`*^9}, {3.65573605734398*^9, 
   3.6557360875854073`*^9}, 3.655736125695709*^9, {3.655756620411442*^9, 
   3.655756629616417*^9}, {3.655756668151726*^9, 3.655756694908778*^9}, {
   3.655756794011197*^9, 3.655756799550457*^9}, {3.6557577298251657`*^9, 
   3.655757747165833*^9}, {3.655757840818081*^9, 3.655757854065583*^9}, 
   3.655758309769582*^9, {3.655758347617063*^9, 3.6557584002288847`*^9}, {
   3.6557587665221663`*^9, 3.655758770363154*^9}, {3.655770592336254*^9, 
   3.655770592711471*^9}, 3.655827456850328*^9, {3.655840088333603*^9, 
   3.6558400921379423`*^9}, 3.655855439801302*^9, 3.655902970292062*^9, 
   3.655936353334132*^9, {3.656116530904604*^9, 3.656116572266605*^9}, {
   3.656182026425568*^9, 3.656182029622666*^9}, {3.656182089210012*^9, 
   3.656182112553369*^9}, 3.656258566883801*^9, {3.6562781734548903`*^9, 
   3.656278214219743*^9}, {3.6562783987323017`*^9, 3.656278415066531*^9}, {
   3.6562957246584673`*^9, 3.6562957334274693`*^9}, {3.656774756638444*^9, 
   3.656774819420537*^9}, {3.656774876569471*^9, 3.656774907004833*^9}, 
   3.6567758285609283`*^9, 3.656775860255035*^9, {3.6567759183236322`*^9, 
   3.656776004442384*^9}, {3.656776204397895*^9, 3.656776216205451*^9}, 
   3.656776596755384*^9, {3.65677681528106*^9, 3.656776844091867*^9}, {
   3.65677697714227*^9, 3.656776989157361*^9}, {3.6568115051427593`*^9, 
   3.656811604510435*^9}, 3.6569574144057693`*^9, 3.656959167800393*^9, 
   3.657045407397772*^9, {3.6570472540204277`*^9, 3.657047284367772*^9}, {
   3.657047461231882*^9, 3.657047481278446*^9}, 3.6570482821130037`*^9, {
   3.657054101114448*^9, 3.657054125867573*^9}, {3.658092771432742*^9, 
   3.6580927740738897`*^9}, 3.664282274221613*^9, 3.664283074345099*^9, {
   3.6650130379044943`*^9, 3.6650130599814997`*^9}, {3.665013125505515*^9, 
   3.665013134970519*^9}, {3.665013556812626*^9, 3.665013592548637*^9}, 
   3.665014725030931*^9, {3.666451542028569*^9, 3.6664515475938377`*^9}, 
   3.666451612921835*^9, {3.666451842282557*^9, 3.6664518621932364`*^9}, {
   3.666451927301997*^9, 3.666451948941863*^9}, {3.666468855126835*^9, 
   3.666468865059902*^9}, {3.666644681968811*^9, 3.6666447169868927`*^9}, {
   3.6666447731816397`*^9, 3.666644780469796*^9}, {3.666644830263308*^9, 
   3.6666448635342827`*^9}, 3.670326601256568*^9, {3.670523715866449*^9, 
   3.670523723774944*^9}, {3.67208201714849*^9, 3.672082059148017*^9}, {
   3.673115382831225*^9, 3.6731153914037313`*^9}, {3.6745793764153843`*^9, 
   3.674579391793455*^9}, {3.676982633235635*^9, 3.676982633493552*^9}, {
   3.677507732534018*^9, 3.677507751033656*^9}, {3.681130559539097*^9, 
   3.6811305780083437`*^9}, 3.6811361220647984`*^9, {3.681156028195547*^9, 
   3.681156149225259*^9}, 3.681156820553846*^9, {3.681157532138393*^9, 
   3.681157563626779*^9}, {3.6811576266082993`*^9, 3.681157674562698*^9}, {
   3.681214978304613*^9, 3.681215019454145*^9}, {3.6813269016962*^9, 
   3.68132691367632*^9}, {3.681344023913309*^9, 3.681344030931196*^9}, {
   3.6814110106244345`*^9, 3.6814110270814047`*^9}, {3.681475706250722*^9, 
   3.681475755910637*^9}, {3.6814760417683764`*^9, 3.681476077511148*^9}, {
   3.6815625465431223`*^9, 3.681562567976326*^9}, 3.681562610418261*^9, {
   3.684779232335705*^9, 3.684779239458054*^9}, {3.705309276286437*^9, 
   3.7053093636911383`*^9}, {3.7053772162643833`*^9, 3.705377222598837*^9}, {
   3.706501617133712*^9, 3.706501705904335*^9}, {3.706538844631814*^9, 
   3.706538847491012*^9}, {3.706604348100565*^9, 3.706604358131256*^9}, {
   3.7071921147587547`*^9, 3.707192126315027*^9}, {3.70719216260676*^9, 
   3.707192182714364*^9}, {3.739780942461699*^9, 3.739781010494735*^9}, {
   3.7397813687355556`*^9, 3.739781419324602*^9}, {3.739781940940146*^9, 
   3.739781963988336*^9}, {3.7397820383744383`*^9, 3.739782042471107*^9}, 
   3.7397820938900757`*^9, {3.750934813597088*^9, 3.750934817518448*^9}, {
   3.750936307532031*^9, 3.750936317606743*^9}, {3.751440554949497*^9, 
   3.7514405699869957`*^9}, {3.7514592329633427`*^9, 3.75145925477804*^9}, {
   3.7514598460313168`*^9, 3.751459847283805*^9}, {3.7707004488998327`*^9, 
   3.7707004511162167`*^9}, 3.771049574187031*^9, {3.7711290695194197`*^9, 
   3.7711290890909567`*^9}, {3.772772648526881*^9, 3.772772692221644*^9}, {
   3.772772923741626*^9, 3.772772926397278*^9}, {3.772774790792592*^9, 
   3.77277479813407*^9}, 3.772774941623723*^9, {3.772854453752864*^9, 
   3.772854469810979*^9}, {3.772857695656221*^9, 3.772857698458583*^9}, {
   3.772878120130991*^9, 3.772878155056855*^9}, 3.7728783014722633`*^9, {
   3.772878451809594*^9, 3.772878458126161*^9}, {3.772878600498712*^9, 
   3.772878688400263*^9}, {3.773028662671681*^9, 3.77302872681277*^9}, {
   3.7730287699192753`*^9, 3.773028835449603*^9}, 3.77417950921146*^9, {
   3.774179640719491*^9, 3.774179654267242*^9}, {3.7741810201986732`*^9, 
   3.774181054852113*^9}, {3.7741812017722683`*^9, 3.774181214441244*^9}, {
   3.774181281241661*^9, 3.7741813485743313`*^9}, {3.7741814532316923`*^9, 
   3.774181498055079*^9}, {3.7764046306903257`*^9, 3.776404632188776*^9}, {
   3.7764065871692133`*^9, 3.776406591966625*^9}, {3.776594240661762*^9, 
   3.776594319698357*^9}, {3.776594384020316*^9, 3.776594510769773*^9}, {
   3.777282794020352*^9, 3.777282821678803*^9}, {3.777608090997121*^9, 
   3.777608125889227*^9}, {3.777702482257514*^9, 3.7777024855682507`*^9}, {
   3.777702559902231*^9, 3.777702617564183*^9}, {3.777702676559209*^9, 
   3.777702712914399*^9}, {3.777737910430224*^9, 3.777737936464561*^9}, 
   3.777737982995718*^9, {3.7777888979088*^9, 3.777788899522048*^9}, {
   3.777875877726449*^9, 3.777875916790193*^9}, {3.777875950374593*^9, 
   3.777875956370566*^9}, {3.77787599780938*^9, 3.777876003525231*^9}, {
   3.7782182350421867`*^9, 3.7782182769132967`*^9}, {3.778218369964554*^9, 
   3.778218372602792*^9}, {3.778218986420429*^9, 3.778219045565406*^9}, {
   3.778236008355287*^9, 3.778236065692494*^9}, {3.77907628629196*^9, 
   3.7790762904802227`*^9}, 3.780131746350254*^9, {3.780203735271302*^9, 
   3.7802037357463417`*^9}, {3.780204071032877*^9, 3.7802040717228413`*^9}, {
   3.7802044475879087`*^9, 3.780204449123412*^9}, {3.780290729804841*^9, 
   3.780290787331416*^9}, 3.7802911145629377`*^9, {3.7802911828030443`*^9, 
   3.7802911897472067`*^9}, {3.780292671439479*^9, 3.780292694897224*^9}, {
   3.78029277962112*^9, 3.7802928543832207`*^9}, {3.7802931666698008`*^9, 
   3.780293186399098*^9}, {3.780311642112919*^9, 3.7803117270067387`*^9}, {
   3.7803117705448523`*^9, 3.7803118536318808`*^9}, {3.780372629053857*^9, 
   3.780372665579208*^9}, {3.780372717124321*^9, 3.7803727181532307`*^9}, {
   3.780808722670747*^9, 3.780808727004045*^9}, {3.780811221383017*^9, 
   3.7808112217170343`*^9}, {3.780996012009388*^9, 3.780996021018014*^9}, {
   3.7867753225463123`*^9, 3.78677534119051*^9}, {3.786775402592476*^9, 
   3.7867754313375*^9}, 3.787565307623312*^9, {3.789487088750938*^9, 
   3.7894870929169703`*^9}, {3.789532525953886*^9, 3.7895325451530733`*^9}, {
   3.789532578956251*^9, 3.789532586402308*^9}, 3.790943552231944*^9, {
   3.798780896970728*^9, 3.798780905693289*^9}, {3.798781057520308*^9, 
   3.79878106976523*^9}, {3.798781132075488*^9, 3.7987811932538958`*^9}, 
   3.7987812446596212`*^9, {3.798781398530952*^9, 3.798781435310608*^9}, 
   3.798781573836482*^9, {3.798783476464259*^9, 3.798783478530792*^9}, 
   3.7987846017862473`*^9, 3.798785634224238*^9, {3.798785863836864*^9, 
   3.798785871248645*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"82154b46-ed34-4e7e-909d-43fd3215bc46"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"ninequalities", "\[IndentingNewLine]", "nequalities", "\
\[IndentingNewLine]", "nvars", "\[IndentingNewLine]", "nnonzerojac", "\
\[IndentingNewLine]", "nnonzeroobj", "\[IndentingNewLine]", 
 RowBox[{"LBstate", "/.", "parameterssub"}], "\[IndentingNewLine]", 
 RowBox[{"UBstate", "/.", "parameterssub"}], "\[IndentingNewLine]"}], "Input",\

 CellChangeTimes->{{3.705379714380931*^9, 3.705379721527854*^9}, {
   3.705379812293248*^9, 3.705379831784528*^9}, 3.705379913724285*^9, {
   3.705379950149743*^9, 3.705379982376968*^9}, {3.706013431506147*^9, 
   3.706013436045879*^9}, 3.706013521905416*^9, {3.706013569385777*^9, 
   3.706013573863982*^9}, {3.7252792855474167`*^9, 3.725279289553013*^9}, {
   3.725280317272359*^9, 3.725280324602683*^9}, {3.7253455432964153`*^9, 
   3.725345551595586*^9}, {3.7262978197749157`*^9, 3.726297830388269*^9}, {
   3.7269306720320597`*^9, 3.726930679886189*^9}, {3.730716221488352*^9, 
   3.7307162244987717`*^9}, {3.739790230161066*^9, 3.739790235841003*^9}, {
   3.7509312961580563`*^9, 3.750931302002612*^9}, {3.751438810113165*^9, 
   3.751438898180346*^9}, {3.751440087321992*^9, 3.751440089622281*^9}, {
   3.770635882937409*^9, 3.770635883193472*^9}, {3.770695273984366*^9, 
   3.770695285901678*^9}, {3.770696564222937*^9, 3.770696590571396*^9}, {
   3.7711311639592953`*^9, 3.77113116888347*^9}, {3.771134896053323*^9, 
   3.771134898530074*^9}, {3.7712167563441772`*^9, 3.771216761101507*^9}, {
   3.771217887000966*^9, 3.771217889596072*^9}, {3.772871993062323*^9, 
   3.772871994105315*^9}, {3.7728720257655983`*^9, 3.7728720269524403`*^9}, {
   3.772878953035708*^9, 3.772878977322022*^9}, {3.775460375453841*^9, 
   3.7754604118995*^9}, {3.7754604441447487`*^9, 3.775460447709961*^9}, {
   3.7764038130205183`*^9, 3.776403813512219*^9}, {3.776404516039927*^9, 
   3.776404518291253*^9}, {3.7764056840045977`*^9, 3.776405684323535*^9}, {
   3.7764086053757267`*^9, 3.7764086135320807`*^9}, {3.778216187874565*^9, 
   3.778216190409091*^9}, {3.778216255438304*^9, 3.7782162757740307`*^9}, {
   3.778216326363874*^9, 3.778216342987341*^9}, {3.778218291780238*^9, 
   3.778218295941383*^9}, {3.778218436571459*^9, 3.778218436865301*^9}, {
   3.7782190618402357`*^9, 3.778219071759817*^9}, {3.778307069653082*^9, 
   3.778307076742956*^9}, {3.780737730589212*^9, 3.780737743895484*^9}, {
   3.7822093012188187`*^9, 3.782209322671134*^9}, {3.7824712781933527`*^9, 
   3.7824713497259703`*^9}, {3.782532401870243*^9, 3.7825324485870256`*^9}, {
   3.7830753276048937`*^9, 3.783075330913951*^9}, {3.789277221312653*^9, 
   3.789277231852413*^9}, {3.7989023932082853`*^9, 3.798902393974745*^9}, {
   3.798902441952067*^9, 3.7989024631970673`*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"80a4b447-df74-4bf0-b06d-eaa1a9a04f60"],

Cell[BoxData["31"], "Output",
 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.798902463588119*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"e3bbb2dd-89b3-41e9-9c05-ed3371987ed2"],

Cell[BoxData["16"], "Output",
 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.798902463593748*^9},
 CellLabel->
  "Out[161]=",ExpressionUUID->"df66b3e2-9882-4998-9e1b-55eb180fdf6e"],

Cell[BoxData["30"], "Output",
 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.798902463597527*^9},
 CellLabel->
  "Out[162]=",ExpressionUUID->"cab7e061-6405-4a30-9969-a6a8f9dbcfae"],

Cell[BoxData["127"], "Output",
 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.7989024635998287`*^9},
 CellLabel->
  "Out[163]=",ExpressionUUID->"46e3aac9-ea82-4418-abf0-6f3c014e2f9d"],

Cell[BoxData["6"], "Output",
 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.798902463601612*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"398a4fcd-1b5e-4dfb-8378-0e15861b80ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"15.31929201955636`", ",", "15.31929201955636`"}], "}"}]], "Output",\

 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.79890246360347*^9},
 CellLabel->
  "Out[165]=",ExpressionUUID->"6c81397a-80a7-41e3-a12e-29bf60b0d5ff"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"70.21244586351112`", ",", "70.21244586351112`"}], "}"}]], "Output",\

 CellChangeTimes->{
  3.705379722739381*^9, {3.705379820157741*^9, 3.705379832723009*^9}, 
   3.7053799154501057`*^9, {3.705379952249799*^9, 3.7053799831342993`*^9}, 
   3.706013436874859*^9, 3.706013522765747*^9, 3.706013574514688*^9, 
   3.7060174972252693`*^9, 3.7060225760922413`*^9, 3.706337288252393*^9, 
   3.706761801853435*^9, 3.707196567013558*^9, 3.725279290793737*^9, 
   3.7252803254518538`*^9, 3.7253455524708652`*^9, 3.725345661378942*^9, {
   3.7262978230068293`*^9, 3.726297831144948*^9}, 3.726297890337289*^9, {
   3.726930660745078*^9, 3.726930680751742*^9}, 3.7307162253184137`*^9, 
   3.7323535220931787`*^9, 3.732353830408918*^9, 3.732353874390255*^9, 
   3.732357199028604*^9, 3.732357482988598*^9, 3.7323606615667152`*^9, 
   3.7397841538590937`*^9, 3.739790237087682*^9, 3.7419610901198797`*^9, 
   3.7419639178463984`*^9, 3.741966218268182*^9, 3.741966778063115*^9, 
   3.742024793747541*^9, 3.7420249798688507`*^9, 3.742120889140772*^9, 
   3.747541180091385*^9, 3.7475456210429163`*^9, 3.7507661174522667`*^9, 
   3.7507661590994377`*^9, 3.7507663760719023`*^9, 3.750931262894916*^9, 
   3.750931303660468*^9, 3.750931497094717*^9, 3.750932017706334*^9, 
   3.750934399681252*^9, 3.7509363246442957`*^9, 3.750939201078022*^9, 
   3.750940422586277*^9, 3.750940457409041*^9, 3.750940929277347*^9, 
   3.750940977569241*^9, 3.750998336786002*^9, 3.750998786000895*^9, 
   3.750999970698222*^9, 3.751024315317429*^9, 3.751024372550631*^9, 
   3.7510264807773952`*^9, 3.751384249163945*^9, 3.7513853466666737`*^9, 
   3.751385794043519*^9, 3.751387940800596*^9, {3.751438788866626*^9, 
   3.75143888042412*^9}, 3.751440090397974*^9, 3.7514590352677803`*^9, 
   3.751459270378878*^9, 3.751476567009738*^9, 3.7515113698979187`*^9, 
   3.751947941958877*^9, 3.7519546140924387`*^9, 3.7706358841977987`*^9, 
   3.7706359257788267`*^9, 3.770636111425927*^9, 3.7706362322493353`*^9, 
   3.770693745486244*^9, 3.770695286976687*^9, 3.770696431059311*^9, 
   3.7706965914947968`*^9, 3.7709541349289827`*^9, 3.7709588547805433`*^9, 
   3.770958912974915*^9, 3.770960006775326*^9, 3.770960833680729*^9, 
   3.770965751678979*^9, 3.7709658980730886`*^9, 3.770966373280776*^9, 
   3.770967393397537*^9, 3.770967464967938*^9, 3.770981379001471*^9, 
   3.770981633602001*^9, 3.771041464874469*^9, 3.7710420683665857`*^9, 
   3.771048484027898*^9, 3.7710495151148233`*^9, 3.7710499020793753`*^9, 
   3.771052428686013*^9, {3.771052667378908*^9, 3.771052682895851*^9}, 
   3.771065891398155*^9, 3.771068499304878*^9, 3.771127499877078*^9, 
   3.771128576033928*^9, 3.771129240439473*^9, {3.7711306664138193`*^9, 
   3.7711306895006227`*^9}, 3.771131169717746*^9, 3.771132942304007*^9, 
   3.771134421945189*^9, 3.7711345224296007`*^9, 3.7711346482156067`*^9, 
   3.771134699894701*^9, {3.771134884472237*^9, 3.771134899207198*^9}, 
   3.771216107374217*^9, 3.77121676218267*^9, 3.771216853222786*^9, 
   3.771217890184003*^9, 3.771301575402968*^9, 3.772872028388278*^9, {
   3.7728789573311577`*^9, 3.7728789784335003`*^9}, 3.772879897225721*^9, 
   3.7729849180176067`*^9, 3.773028094929916*^9, 3.774160729067432*^9, 
   3.774160763079845*^9, 3.7741621085833397`*^9, 3.77416638759338*^9, 
   3.774166584101769*^9, 3.7741688453061523`*^9, 3.774168988575653*^9, 
   3.7741691015124063`*^9, 3.7741691685520983`*^9, {3.7741698986211243`*^9, 
   3.774169949222231*^9}, 3.7741701664504967`*^9, 3.77545664309379*^9, 
   3.77545682838169*^9, 3.7754603038666763`*^9, {3.7754604296804237`*^9, 
   3.775460448908348*^9}, 3.7761570313849983`*^9, 3.77640315964789*^9, 
   3.776403814393367*^9, 3.776404373081909*^9, 3.7764045194783363`*^9, 
   3.7764046707770653`*^9, 3.776404852629506*^9, 3.776405685416492*^9, 
   3.7764066085975037`*^9, 3.776408615140759*^9, 3.7771891234090853`*^9, 
   3.777618109478053*^9, {3.777701432977985*^9, 3.7777014468900213`*^9}, 
   3.77770230307898*^9, 3.7777024253566093`*^9, 3.7777027200570383`*^9, 
   3.777717837701416*^9, 3.777718045051265*^9, 3.777718209842307*^9, 
   3.777719931649255*^9, 3.777720033244801*^9, 3.777730151158575*^9, 
   3.777737175022821*^9, 3.7777377586613617`*^9, 3.7777788652716913`*^9, 
   3.7777792031316643`*^9, 3.7777806772108707`*^9, 3.7777890344839907`*^9, 
   3.777789102480823*^9, 3.777801829510511*^9, 3.777875923012692*^9, 
   3.7778759627410183`*^9, 3.777876008004586*^9, 3.7778871777628803`*^9, 
   3.778215098861557*^9, 3.7782154039203568`*^9, 3.778216276996727*^9, 
   3.778216344915722*^9, 3.7782183809418716`*^9, 3.778218438101838*^9, 
   3.7782190626087093`*^9, 3.778227086517357*^9, 3.778235353558794*^9, 
   3.778235593149269*^9, 3.778298647149984*^9, 3.77830395662873*^9, 
   3.7783060332982063`*^9, 3.7783070325459547`*^9, 3.778307077382264*^9, 
   3.778311395805851*^9, 3.778311592144718*^9, 3.778487211477187*^9, 
   3.779076302150772*^9, 3.7794230690993757`*^9, 3.780132301703833*^9, 
   3.78020277527483*^9, 3.780205489240912*^9, 3.7802069855775623`*^9, 
   3.7802932384984426`*^9, 3.780295419990902*^9, 3.780299995245324*^9, 
   3.780301583433689*^9, 3.780313371899549*^9, 3.780372732304759*^9, 
   3.7807249411611357`*^9, 3.780737745036619*^9, 3.78081207199757*^9, 
   3.780996028309503*^9, 3.7819324909877243`*^9, 3.782209276994032*^9, 
   3.782209309519498*^9, 3.7824670960318737`*^9, {3.782471321052443*^9, 
   3.782471350191577*^9}, 3.782472292450485*^9, {3.782532424956051*^9, 
   3.782532449361368*^9}, 3.7830753324190283`*^9, 3.785836108800934*^9, 
   3.786775120060083*^9, 3.7867799542586412`*^9, 3.7875652254491673`*^9, {
   3.789277224096107*^9, 3.789277233070718*^9}, 3.789487134747799*^9, 
   3.789532589899066*^9, 3.7895367008066273`*^9, 3.789537176381649*^9, 
   3.789537423245469*^9, 3.78953801531345*^9, 3.7895399428643093`*^9, 
   3.789727335122987*^9, 3.7987834522568007`*^9, 3.79890233601369*^9, 
   3.798902394564981*^9, 3.798902463605343*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"2b062623-821b-4dd1-b549-9007d4d39adb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["replacetonumerated"], "Input",
 CellChangeTimes->{{3.782471871392364*^9, 3.7824718949099073`*^9}, {
   3.782472241213059*^9, 3.782472249963744*^9}, {3.7858626901465473`*^9, 
   3.78586269293184*^9}, {3.786775184678926*^9, 3.786775287912815*^9}, {
   3.787565272290563*^9, 3.787565293227882*^9}, 3.789537341865309*^9, {
   3.789727347070776*^9, 3.7897273549222803`*^9}, {3.7897274870381737`*^9, 
   3.789727501771812*^9}, {3.798782238694932*^9, 3.798782254135501*^9}, 
   3.7987834581823378`*^9, {3.7987846331238422`*^9, 3.798784635167128*^9}, 
   3.798785566453825*^9, 3.7987855983915863`*^9, {3.7987861536468487`*^9, 
   3.798786160344907*^9}, 3.798786283764647*^9, {3.7989788462099733`*^9, 
   3.798978848487742*^9}, 3.798978884838915*^9},
 CellLabel->
  "In[1402]:=",ExpressionUUID->"0b5897b7-1d21-4f06-8a3b-d70334991f38"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"aaction1EN\"\>", "\[Rule]", "\<\"X(1)\"\>"}], ",", 
   RowBox[{"\<\"aaction2EN\"\>", "\[Rule]", "\<\"X(2)\"\>"}], ",", 
   RowBox[{"\<\"consumption1EN\"\>", "\[Rule]", "\<\"X(3)\"\>"}], ",", 
   RowBox[{"\<\"otheragag1EN\"\>", "\[Rule]", "\<\"X(4)\"\>"}], ",", 
   RowBox[{"\<\"continuationA1S1EN\"\>", "\[Rule]", "\<\"X(5)\"\>"}], ",", 
   RowBox[{"\<\"continuationA1S2EN\"\>", "\[Rule]", "\<\"X(6)\"\>"}], ",", 
   RowBox[{"\<\"consumption2EN\"\>", "\[Rule]", "\<\"X(7)\"\>"}], ",", 
   RowBox[{"\<\"otheragag2EN\"\>", "\[Rule]", "\<\"X(8)\"\>"}], ",", 
   RowBox[{"\<\"continuationA2S1EN\"\>", "\[Rule]", "\<\"X(9)\"\>"}], ",", 
   RowBox[{"\<\"continuationA2S2EN\"\>", "\[Rule]", "\<\"X(10)\"\>"}], ",", 
   RowBox[{"\<\"Rho1E\"\>", "\[Rule]", "\<\"X(11)\"\>"}], ",", 
   RowBox[{"\<\"S1T1T1A1E\"\>", "\[Rule]", "\<\"X(12)\"\>"}], ",", 
   RowBox[{"\<\"S1T2T1A1E\"\>", "\[Rule]", "\<\"X(13)\"\>"}], ",", 
   RowBox[{"\<\"S1T2T2A1E\"\>", "\[Rule]", "\<\"X(14)\"\>"}], ",", 
   RowBox[{"\<\"S1T3T1A1E\"\>", "\[Rule]", "\<\"X(15)\"\>"}], ",", 
   RowBox[{"\<\"S1T3T2A1E\"\>", "\[Rule]", "\<\"X(16)\"\>"}], ",", 
   RowBox[{"\<\"S1T3T3A1E\"\>", "\[Rule]", "\<\"X(17)\"\>"}], ",", 
   RowBox[{"\<\"S2T1T1A1E\"\>", "\[Rule]", "\<\"X(18)\"\>"}], ",", 
   RowBox[{"\<\"S2T2T1A1E\"\>", "\[Rule]", "\<\"X(19)\"\>"}], ",", 
   RowBox[{"\<\"S2T2T2A1E\"\>", "\[Rule]", "\<\"X(20)\"\>"}], ",", 
   RowBox[{"\<\"Rho2E\"\>", "\[Rule]", "\<\"X(21)\"\>"}], ",", 
   RowBox[{"\<\"S1T1T1A2E\"\>", "\[Rule]", "\<\"X(22)\"\>"}], ",", 
   RowBox[{"\<\"S1T2T1A2E\"\>", "\[Rule]", "\<\"X(23)\"\>"}], ",", 
   RowBox[{"\<\"S1T2T2A2E\"\>", "\[Rule]", "\<\"X(24)\"\>"}], ",", 
   RowBox[{"\<\"S1T3T1A2E\"\>", "\[Rule]", "\<\"X(25)\"\>"}], ",", 
   RowBox[{"\<\"S1T3T2A2E\"\>", "\[Rule]", "\<\"X(26)\"\>"}], ",", 
   RowBox[{"\<\"S1T3T3A2E\"\>", "\[Rule]", "\<\"X(27)\"\>"}], ",", 
   RowBox[{"\<\"S2T1T1A2E\"\>", "\[Rule]", "\<\"X(28)\"\>"}], ",", 
   RowBox[{"\<\"S2T2T1A2E\"\>", "\[Rule]", "\<\"X(29)\"\>"}], ",", 
   RowBox[{"\<\"S2T2T2A2E\"\>", "\[Rule]", "\<\"X(30)\"\>"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.782472250258959*^9, 3.7824722938845*^9, 3.785862693502219*^9, 
   3.78677512666616*^9, 3.786775288524469*^9, {3.787565275272735*^9, 
   3.787565294161228*^9}, 3.789537343071351*^9, 3.78953742930831*^9, {
   3.7897273485102873`*^9, 3.78972735527503*^9}, {3.789727489465152*^9, 
   3.789727502097739*^9}, {3.798782244882831*^9, 3.7987822547651176`*^9}, {
   3.798783459458497*^9, 3.798783484152362*^9}, {3.7987845598567753`*^9, 
   3.798784605651301*^9}, 3.798784636394206*^9, 3.798784713142892*^9, 
   3.798785195069833*^9, 3.798785569991084*^9, {3.798785623979621*^9, 
   3.798785639885455*^9}, 3.798786160823769*^9, 3.798786284419166*^9, 
   3.798978849117826*^9, 3.7989788855806313`*^9},
 CellLabel->
  "Out[1402]=",ExpressionUUID->"7d027dbb-d664-41b2-8277-150f073e1ec2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["solfeas"], "Input",
 CellChangeTimes->{{3.780139967657956*^9, 3.780139980276102*^9}, {
   3.780202820824729*^9, 3.780202850454535*^9}, {3.780203719862414*^9, 
   3.7802037251560593`*^9}, {3.780204175234462*^9, 3.780204230481642*^9}, {
   3.780204399378344*^9, 3.780204443794833*^9}, {3.780206990859483*^9, 
   3.7802069935807943`*^9}, {3.7802070942527514`*^9, 3.780207120988338*^9}, {
   3.780207322300207*^9, 3.78020733593216*^9}, {3.7802074159324827`*^9, 
   3.7802074174841337`*^9}, {3.780207596331308*^9, 3.780207640201508*^9}, {
   3.780208272587534*^9, 3.7802082997561502`*^9}, {3.780223190195943*^9, 
   3.780223208099688*^9}, {3.780293276826076*^9, 3.78029328714406*^9}, 
   3.780293324219183*^9, {3.780293404072288*^9, 3.7802934049952*^9}, {
   3.780808664893046*^9, 3.7808086652220173`*^9}, {3.780808699600666*^9, 
   3.780808704891445*^9}, {3.7809959397063723`*^9, 3.780995941720668*^9}, {
   3.7809959865692053`*^9, 3.780995996710085*^9}, {3.78247056411302*^9, 
   3.7824705674238443`*^9}, {3.785862676118847*^9, 3.785862676322864*^9}, 
   3.798784731710472*^9, {3.79878478012176*^9, 3.798784781969705*^9}, {
   3.798784970197274*^9, 3.798784978361733*^9}, {3.798785250919405*^9, 
   3.798785252442019*^9}, 3.7989785154740553`*^9},
 CellLabel->
  "In[1263]:=",ExpressionUUID->"38de53a1-46ed-4adf-87ff-9c58c0b4a8e7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"otheragag1EN", "\[Rule]", "aaction2EN"}], ",", 
    RowBox[{"otheragag2EN", "\[Rule]", "aaction1EN"}], ",", 
    RowBox[{"Rho1E", "\[Rule]", "currentutilpromise1EN"}], ",", 
    RowBox[{"consumption1EN", "\[Rule]", 
     RowBox[{
      RowBox[{"0.02`", " ", 
       SuperscriptBox["aaction1EN", "2"]}], "+", 
      RowBox[{"1.`", " ", 
       SuperscriptBox["aaction1EN", "4"]}], "-", 
      RowBox[{"0.0196`", " ", "continuationA1S2EN"}], "-", 
      RowBox[{"1.96`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", "continuationA1S2EN"}], "+", 
      RowBox[{"0.9604`", " ", 
       SuperscriptBox["continuationA1S2EN", "2"]}], "+", 
      RowBox[{"0.02`", " ", "currentutilpromise1EN"}], "+", 
      RowBox[{"2.`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", "currentutilpromise1EN"}], "-", 
      RowBox[{
      "1.96`", " ", "continuationA1S2EN", " ", "currentutilpromise1EN"}], "+", 
      RowBox[{"1.`", " ", 
       SuperscriptBox["currentutilpromise1EN", "2"]}], "-", 
      RowBox[{"0.02`", " ", "S1T1T1A1E"}], "-", 
      RowBox[{"2.`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", "S1T1T1A1E"}], "+", 
      RowBox[{"1.96`", " ", "continuationA1S2EN", " ", "S1T1T1A1E"}], "-", 
      RowBox[{"2.`", " ", "currentutilpromise1EN", " ", "S1T1T1A1E"}], "+", 
      RowBox[{"1.`", " ", 
       SuperscriptBox["S1T1T1A1E", "2"]}], "-", 
      RowBox[{"0.04`", " ", "S1T3T2A1E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", "S1T3T2A1E"}], "+", 
      RowBox[{"0.04`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T3T2A1E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T3T2A1E"}], "+", 
      RowBox[{"3.92`", " ", "continuationA1S2EN", " ", "S1T3T2A1E"}], "-", 
      RowBox[{"3.92`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "continuationA1S2EN", " ", 
       "S1T3T2A1E"}], "-", 
      RowBox[{"4.`", " ", "currentutilpromise1EN", " ", "S1T3T2A1E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "currentutilpromise1EN", " ", 
       "S1T3T2A1E"}], "+", 
      RowBox[{"4.`", " ", "S1T1T1A1E", " ", "S1T3T2A1E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T1T1A1E", " ", 
       "S1T3T2A1E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["S1T3T2A1E", "2"]}], "-", 
      RowBox[{"8.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", 
       SuperscriptBox["S1T3T2A1E", "2"]}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "6"], " ", 
       SuperscriptBox["S1T3T2A1E", "2"]}], "+", 
      RowBox[{"0.04`", " ", "S2T2T1A1E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", "S2T2T1A1E"}], "-", 
      RowBox[{"0.04`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S2T2T1A1E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S2T2T1A1E"}], "-", 
      RowBox[{"3.92`", " ", "continuationA1S2EN", " ", "S2T2T1A1E"}], "+", 
      RowBox[{"3.92`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "continuationA1S2EN", " ", 
       "S2T2T1A1E"}], "+", 
      RowBox[{"4.`", " ", "currentutilpromise1EN", " ", "S2T2T1A1E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "currentutilpromise1EN", " ", 
       "S2T2T1A1E"}], "-", 
      RowBox[{"4.`", " ", "S1T1T1A1E", " ", "S2T2T1A1E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T1T1A1E", " ", 
       "S2T2T1A1E"}], "-", 
      RowBox[{"8.`", " ", "S1T3T2A1E", " ", "S2T2T1A1E"}], "+", 
      RowBox[{"16.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T3T2A1E", " ", 
       "S2T2T1A1E"}], "-", 
      RowBox[{"8.`", " ", 
       SuperscriptBox["aaction2EN", "6"], " ", "S1T3T2A1E", " ", 
       "S2T2T1A1E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["S2T2T1A1E", "2"]}], "-", 
      RowBox[{"8.`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", 
       SuperscriptBox["S2T2T1A1E", "2"]}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "6"], " ", 
       SuperscriptBox["S2T2T1A1E", "2"]}], "-", 
      RowBox[{"0.018`", " ", "S2T2T2A1E"}], "-", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", "S2T2T2A1E"}], "+", 
      RowBox[{"0.018`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S2T2T2A1E"}], "+", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction1EN", "2"], " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S2T2T2A1E"}], "+", 
      RowBox[{"1.764`", " ", "continuationA1S2EN", " ", "S2T2T2A1E"}], "-", 
      RowBox[{"1.764`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "continuationA1S2EN", " ", 
       "S2T2T2A1E"}], "-", 
      RowBox[{"1.8`", " ", "currentutilpromise1EN", " ", "S2T2T2A1E"}], "+", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "currentutilpromise1EN", " ", 
       "S2T2T2A1E"}], "+", 
      RowBox[{"1.8`", " ", "S1T1T1A1E", " ", "S2T2T2A1E"}], "-", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T1T1A1E", " ", 
       "S2T2T2A1E"}], "+", 
      RowBox[{"3.6`", " ", "S1T3T2A1E", " ", "S2T2T2A1E"}], "-", 
      RowBox[{"7.2`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S1T3T2A1E", " ", 
       "S2T2T2A1E"}], "+", 
      RowBox[{"3.6`", " ", 
       SuperscriptBox["aaction2EN", "6"], " ", "S1T3T2A1E", " ", 
       "S2T2T2A1E"}], "-", 
      RowBox[{"3.6`", " ", "S2T2T1A1E", " ", "S2T2T2A1E"}], "+", 
      RowBox[{"7.2`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", "S2T2T1A1E", " ", 
       "S2T2T2A1E"}], "-", 
      RowBox[{"3.6`", " ", 
       SuperscriptBox["aaction2EN", "6"], " ", "S2T2T1A1E", " ", 
       "S2T2T2A1E"}], "+", 
      RowBox[{"0.81`", " ", 
       SuperscriptBox["S2T2T2A1E", "2"]}], "-", 
      RowBox[{"1.62`", " ", 
       SuperscriptBox["aaction2EN", "3"], " ", 
       SuperscriptBox["S2T2T2A1E", "2"]}], "+", 
      RowBox[{"0.81`", " ", 
       SuperscriptBox["aaction2EN", "6"], " ", 
       SuperscriptBox["S2T2T2A1E", "2"]}]}]}], ",", 
    RowBox[{"continuationA1S1EN", "\[Rule]", 
     RowBox[{
      RowBox[{"1.`", " ", "continuationA1S2EN"}], "+", 
      RowBox[{"2.0408163265306123`", " ", "S1T3T2A1E"}], "-", 
      RowBox[{"2.0408163265306123`", " ", "S2T2T1A1E"}], "+", 
      RowBox[{"0.9183673469387755`", " ", "S2T2T2A1E"}]}]}], ",", 
    RowBox[{"Rho2E", "\[Rule]", "currentutilpromise2EN"}], ",", 
    RowBox[{"consumption2EN", "\[Rule]", 
     RowBox[{
      RowBox[{"0.02`", " ", 
       SuperscriptBox["aaction2EN", "2"]}], "+", 
      RowBox[{"1.`", " ", 
       SuperscriptBox["aaction2EN", "4"]}], "-", 
      RowBox[{"0.0196`", " ", "continuationA2S2EN"}], "-", 
      RowBox[{"1.96`", " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "continuationA2S2EN"}], "+", 
      RowBox[{"0.9604`", " ", 
       SuperscriptBox["continuationA2S2EN", "2"]}], "+", 
      RowBox[{"0.02`", " ", "currentutilpromise2EN"}], "+", 
      RowBox[{"2.`", " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "currentutilpromise2EN"}], "-", 
      RowBox[{
      "1.96`", " ", "continuationA2S2EN", " ", "currentutilpromise2EN"}], "+", 
      RowBox[{"1.`", " ", 
       SuperscriptBox["currentutilpromise2EN", "2"]}], "-", 
      RowBox[{"0.02`", " ", "S1T1T1A2E"}], "-", 
      RowBox[{"2.`", " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S1T1T1A2E"}], "+", 
      RowBox[{"1.96`", " ", "continuationA2S2EN", " ", "S1T1T1A2E"}], "-", 
      RowBox[{"2.`", " ", "currentutilpromise2EN", " ", "S1T1T1A2E"}], "+", 
      RowBox[{"1.`", " ", 
       SuperscriptBox["S1T1T1A2E", "2"]}], "-", 
      RowBox[{"0.04`", " ", "S1T3T2A2E"}], "+", 
      RowBox[{"0.04`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S1T3T2A2E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S1T3T2A2E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S1T3T2A2E"}], "+", 
      RowBox[{"3.92`", " ", "continuationA2S2EN", " ", "S1T3T2A2E"}], "-", 
      RowBox[{"3.92`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "continuationA2S2EN", " ", 
       "S1T3T2A2E"}], "-", 
      RowBox[{"4.`", " ", "currentutilpromise2EN", " ", "S1T3T2A2E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "currentutilpromise2EN", " ", 
       "S1T3T2A2E"}], "+", 
      RowBox[{"4.`", " ", "S1T1T1A2E", " ", "S1T3T2A2E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S1T1T1A2E", " ", 
       "S1T3T2A2E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["S1T3T2A2E", "2"]}], "-", 
      RowBox[{"8.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", 
       SuperscriptBox["S1T3T2A2E", "2"]}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "6"], " ", 
       SuperscriptBox["S1T3T2A2E", "2"]}], "+", 
      RowBox[{"0.04`", " ", "S2T2T1A2E"}], "-", 
      RowBox[{"0.04`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S2T2T1A2E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S2T2T1A2E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S2T2T1A2E"}], "-", 
      RowBox[{"3.92`", " ", "continuationA2S2EN", " ", "S2T2T1A2E"}], "+", 
      RowBox[{"3.92`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "continuationA2S2EN", " ", 
       "S2T2T1A2E"}], "+", 
      RowBox[{"4.`", " ", "currentutilpromise2EN", " ", "S2T2T1A2E"}], "-", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "currentutilpromise2EN", " ", 
       "S2T2T1A2E"}], "-", 
      RowBox[{"4.`", " ", "S1T1T1A2E", " ", "S2T2T1A2E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S1T1T1A2E", " ", 
       "S2T2T1A2E"}], "-", 
      RowBox[{"8.`", " ", "S1T3T2A2E", " ", "S2T2T1A2E"}], "+", 
      RowBox[{"16.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S1T3T2A2E", " ", 
       "S2T2T1A2E"}], "-", 
      RowBox[{"8.`", " ", 
       SuperscriptBox["aaction1EN", "6"], " ", "S1T3T2A2E", " ", 
       "S2T2T1A2E"}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["S2T2T1A2E", "2"]}], "-", 
      RowBox[{"8.`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", 
       SuperscriptBox["S2T2T1A2E", "2"]}], "+", 
      RowBox[{"4.`", " ", 
       SuperscriptBox["aaction1EN", "6"], " ", 
       SuperscriptBox["S2T2T1A2E", "2"]}], "-", 
      RowBox[{"0.018`", " ", "S2T2T2A2E"}], "+", 
      RowBox[{"0.018`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S2T2T2A2E"}], "-", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S2T2T2A2E"}], "+", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", 
       SuperscriptBox["aaction2EN", "2"], " ", "S2T2T2A2E"}], "+", 
      RowBox[{"1.764`", " ", "continuationA2S2EN", " ", "S2T2T2A2E"}], "-", 
      RowBox[{"1.764`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "continuationA2S2EN", " ", 
       "S2T2T2A2E"}], "-", 
      RowBox[{"1.8`", " ", "currentutilpromise2EN", " ", "S2T2T2A2E"}], "+", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "currentutilpromise2EN", " ", 
       "S2T2T2A2E"}], "+", 
      RowBox[{"1.8`", " ", "S1T1T1A2E", " ", "S2T2T2A2E"}], "-", 
      RowBox[{"1.8`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S1T1T1A2E", " ", 
       "S2T2T2A2E"}], "+", 
      RowBox[{"3.6`", " ", "S1T3T2A2E", " ", "S2T2T2A2E"}], "-", 
      RowBox[{"7.2`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S1T3T2A2E", " ", 
       "S2T2T2A2E"}], "+", 
      RowBox[{"3.6`", " ", 
       SuperscriptBox["aaction1EN", "6"], " ", "S1T3T2A2E", " ", 
       "S2T2T2A2E"}], "-", 
      RowBox[{"3.6`", " ", "S2T2T1A2E", " ", "S2T2T2A2E"}], "+", 
      RowBox[{"7.2`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", "S2T2T1A2E", " ", 
       "S2T2T2A2E"}], "-", 
      RowBox[{"3.6`", " ", 
       SuperscriptBox["aaction1EN", "6"], " ", "S2T2T1A2E", " ", 
       "S2T2T2A2E"}], "+", 
      RowBox[{"0.81`", " ", 
       SuperscriptBox["S2T2T2A2E", "2"]}], "-", 
      RowBox[{"1.62`", " ", 
       SuperscriptBox["aaction1EN", "3"], " ", 
       SuperscriptBox["S2T2T2A2E", "2"]}], "+", 
      RowBox[{"0.81`", " ", 
       SuperscriptBox["aaction1EN", "6"], " ", 
       SuperscriptBox["S2T2T2A2E", "2"]}]}]}], ",", 
    RowBox[{"continuationA2S1EN", "\[Rule]", 
     RowBox[{
      RowBox[{"1.`", " ", "continuationA2S2EN"}], "+", 
      RowBox[{"2.0408163265306123`", " ", "S1T3T2A2E"}], "-", 
      RowBox[{"2.0408163265306123`", " ", "S2T2T1A2E"}], "+", 
      RowBox[{"0.9183673469387755`", " ", "S2T2T2A2E"}]}]}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.780139970720524*^9, 3.780139980703562*^9}, {
   3.780202767318482*^9, 3.780202776744319*^9}, {3.780202824464082*^9, 
   3.780202851701522*^9}, 3.7802041831663*^9, {3.780204435741871*^9, 
   3.780204439404931*^9}, 3.780206994512621*^9, {3.780207114342119*^9, 
   3.780207121489468*^9}, 3.780207336446844*^9, 3.780207417800767*^9, {
   3.7802076051355124`*^9, 3.780207640918433*^9}, {3.780208276891626*^9, 
   3.780208300332974*^9}, {3.780223192039568*^9, 3.7802232101818333`*^9}, 
   3.780293287976597*^9, 3.780293325865294*^9, 3.7802934062297697`*^9, 
   3.780295421796875*^9, 3.7803133798388166`*^9, 3.780808668696845*^9, 
   3.780808705396373*^9, 3.7809959429469357`*^9, 3.780995997046707*^9, 
   3.7824705677178783`*^9, {3.785862661857212*^9, 3.7858626770503397`*^9}, 
   3.798784733227216*^9, 3.798784782383235*^9, 3.798784980629569*^9, 
   3.798785197685095*^9, 3.798785253501292*^9, 3.798978516419362*^9},
 CellLabel->
  "Out[1263]=",ExpressionUUID->"2c46593c-b765-4b27-8ae8-bf4760079a56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["UBvars"], "Input",
 CellChangeTimes->{{3.780896743544964*^9, 3.7808968738280773`*^9}, {
  3.798952765800887*^9, 3.798952767181636*^9}},
 CellLabel->
  "In[139]:=",ExpressionUUID->"86af0008-917b-441d-bae3-5bf62d095e9f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0.9`", "}"}], ",", 
   RowBox[{"{", "0.9`", "}"}], ",", "10.`", ",", "0.9`", ",", 
   "70.21244586351112`", ",", "70.21244586351112`", ",", "10.`", ",", "0.9`", 
   ",", "70.21244586351112`", ",", "70.21244586351112`", ",", "1000.`", ",", 
   "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`", ",", 
   "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`", ",", 
   "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`", ",", 
   "1000.`", ",", "1000.`", ",", "1000.`", ",", "1000.`"}], "}"}]], "Output",
 CellChangeTimes->{{3.780896826346858*^9, 3.780896874739047*^9}, 
   3.798952768126712*^9},
 CellLabel->
  "Out[139]=",ExpressionUUID->"c5b54f2a-291c-4f92-9bf1-a422b5037058"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"VarsbyAgentpos", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"ListofVars", ",", 
          RowBox[{"VarsbyAgent", "[", 
           RowBox[{"[", 
            RowBox[{"indxa", ",", "indxv"}], "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"indxv", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"VarsbyAgent", "[", 
            RowBox[{"[", "indxa", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"indxa", ",", "nagents"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7825346643251038`*^9, 3.7825346815356903`*^9}, {
  3.789561324935156*^9, 3.789561334724903*^9}, {3.799076639679083*^9, 
  3.799076660789853*^9}, {3.799076701500884*^9, 
  3.799076777808092*^9}},ExpressionUUID->"5654979c-37d2-44ec-b698-\
0c1efc494b17"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "2", ",", "9", ",", "10"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.782534682140416*^9, 3.789561335425943*^9, {3.799076651451962*^9, 
   3.799076661277565*^9}, {3.7990767485202007`*^9, 3.7990767634293127`*^9}},
 CellLabel->
  "Out[138]=",ExpressionUUID->"75eb57d5-27e3-4680-a0b8-5d2b01a9b348"]
}, Open  ]]
},
WindowSize->{1454, 1143},
WindowMargins->{{8, Automatic}, {37, Automatic}},
Magnification:>2. Inherited,
FrontEndVersion->"12.0 for Linux x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 522, 10, 106, "Input",ExpressionUUID->"ced6cdd9-cea4-4ef2-b681-e154a2c5beff"],
Cell[CellGroupData[{
Cell[1105, 34, 128606, 2372, 14626, "Input",ExpressionUUID->"d94ef849-a0da-49b1-8261-6b5c237d2bbe",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[129714, 2408, 28785, 686, 5738, "Input",ExpressionUUID->"82154b46-ed34-4e7e-909d-43fd3215bc46",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[158536, 3099, 2786, 39, 370, "Input",ExpressionUUID->"80a4b447-df74-4bf0-b06d-eaa1a9a04f60"],
Cell[161325, 3140, 5959, 84, 98, "Output",ExpressionUUID->"e3bbb2dd-89b3-41e9-9c05-ed3371987ed2"],
Cell[167287, 3226, 5959, 84, 98, "Output",ExpressionUUID->"df66b3e2-9882-4998-9e1b-55eb180fdf6e"],
Cell[173249, 3312, 5959, 84, 98, "Output",ExpressionUUID->"cab7e061-6405-4a30-9969-a6a8f9dbcfae"],
Cell[179211, 3398, 5962, 84, 98, "Output",ExpressionUUID->"46e3aac9-ea82-4418-abf0-6f3c014e2f9d"],
Cell[185176, 3484, 5958, 84, 98, "Output",ExpressionUUID->"398a4fcd-1b5e-4dfb-8378-0e15861b80ea"],
Cell[191137, 3570, 6038, 87, 98, "Output",ExpressionUUID->"6c81397a-80a7-41e3-a12e-29bf60b0d5ff"],
Cell[197178, 3659, 6039, 87, 98, "Output",ExpressionUUID->"2b062623-821b-4dd1-b549-9007d4d39adb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[203254, 3751, 839, 12, 61, "Input",ExpressionUUID->"0b5897b7-1d21-4f06-8a3b-d70334991f38"],
Cell[204096, 3765, 2931, 46, 407, "Output",ExpressionUUID->"7d027dbb-d664-41b2-8277-150f073e1ec2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[207064, 3816, 1341, 19, 61, "Input",ExpressionUUID->"38de53a1-46ed-4adf-87ff-9c58c0b4a8e7"],
Cell[208408, 3837, 14118, 295, 2925, "Output",ExpressionUUID->"2c46593c-b765-4b27-8ae8-bf4760079a56"]
}, Open  ]],
Cell[CellGroupData[{
Cell[222563, 4137, 232, 4, 61, "Input",ExpressionUUID->"86af0008-917b-441d-bae3-5bf62d095e9f"],
Cell[222798, 4143, 786, 14, 187, "Output",ExpressionUUID->"c5b54f2a-291c-4f92-9bf1-a422b5037058"]
}, Open  ]],
Cell[CellGroupData[{
Cell[223621, 4162, 970, 25, 150, "Input",ExpressionUUID->"5654979c-37d2-44ec-b698-0c1efc494b17"],
Cell[224594, 4189, 462, 11, 98, "Output",ExpressionUUID->"75eb57d5-27e3-4680-a0b8-5d2b01a9b348"]
}, Open  ]]
}
]
*)

